// SPDX-License-Identifier: GPL-2.0
/*
 * Copyright (c) 2019 MediaTek Inc.
 */
#include <linux/kernel.h>
#include "cam_cal_list.h"
#include "eeprom_i2c_common_driver.h"
#include "eeprom_i2c_custom_driver.h"
#include "kd_imgsensor.h"

#ifdef  CONFIG_PROJECT_V590AE
extern unsigned int gc08a3_dd_v590_read_region(struct i2c_client *client,
				unsigned int addr,
				unsigned char *data,
				unsigned int size);
extern unsigned int gc08a3_st_v590_read_region(struct i2c_client *client,
				unsigned int addr,
				unsigned char *data,
				unsigned int size);
#endif
#if (defined(CONFIG_PROJECT_V690AE) || defined(CONFIG_PROJECT_V691AE))
extern unsigned int gc08a3_dd_v690_read_region(struct i2c_client *client,
				unsigned int addr,
				unsigned char *data,
				unsigned int size);
extern unsigned int gc08a3_st_v690_read_region(struct i2c_client *client,
				unsigned int addr,
				unsigned char *data,
				unsigned int size);
#endif
struct stCAM_CAL_LIST_STRUCT g_camCalList[] = {
	/*Below is commom sensor */
#ifdef  CONFIG_PROJECT_V590AE
	{GC08A3_DD_V590_SENSOR_ID, 0x62, gc08a3_dd_v590_read_region},
	{GC08A3_ST_V590_SENSOR_ID, 0x62, gc08a3_st_v590_read_region},
#endif
#if (defined(CONFIG_PROJECT_V690AE) || defined(CONFIG_PROJECT_V691AE))
	{GC08A3_DD_V690_SENSOR_ID, 0x22, gc08a3_dd_v690_read_region},
	{GC08A3_ST_V690_SENSOR_ID, 0x22, gc08a3_st_v690_read_region},
#endif
	{HI1336_AAC_V690_SENSOR_ID, 0xA0, Common_read_region},
	{S5K3L6_SUNWIN_V690_SENSOR_ID, 0xA0, Common_read_region},
	{OV13B10_SUNWIN_V690_SENSOR_ID, 0xA0, Common_read_region},  //add for v691
	/*  ADD before this line */
	{0, 0, 0}       /*end of list */
};

unsigned int cam_cal_get_sensor_list(
	struct stCAM_CAL_LIST_STRUCT **ppCamcalList)
{
	if (ppCamcalList == NULL)
		return 1;

	*ppCamcalList = &g_camCalList[0];
	return 0;
}


