/* SPDX-License-Identifier: GPL-2.0 */
/*
 * Copyright (c) 2019 MediaTek Inc.
*/

#ifndef _EMI_MODULE_H_
#define _EMI_MODULE_H_

struct mst_tbl_entry {
	u32 master;
	u32 port;
	u32 id_mask;
	u32 id_val;
	const char *note;
	const char *name;
};

enum {
	MT6739_M1_AXI_MST_DISP_RDMA0,
	MT6739_M4_AXI_MST_TBO,
	MT6739_M4_AXI_MST_HRQ_RD,
	MT6739_M3_AXI_MST_MD_MM,
	MT6739_M4_AXI_MST_CNWDMA,
	MT6739_M1_AXI_MST_DISP_OVL0,
	MT6739_M4_AXI_MST_TXBRP0,
	MT6739_M1_AXI_MST_MDP_WDMA0,
	MT6739_M1_AXI_MST_LSCI_0,
	MT6739_M2_AXI_MST_MSDC1,
	MT6739_M2_AXI_MST_NFI,
	MT6739_M2_AXI_MST_CQ_DMA,
	MT6739_M1_AXI_MST_MDP_RDMA0,
	MT6739_M2_AXI_MST_DMA_EXT,
	MT6739_M2_AXI_MST_GCE_M,
	MT6739_M1_AXI_MST_JPGENC_BSDMA,
	MT6739_M4_AXI_MST_RXDFE_DMA,
	MT6739_M2_AXI_MST_THERM,
	MT6739_M1_AXI_MST_BPCI_0,
	MT6739_M4_AXI_MST_IPSEC,
	MT6739_M4_AXI_MST_CSH,
	MT6739_M1_AXI_MST_VENC_RD_COMV_HW_VDEC_PRED_RD_EXT,
	MT6739_M4_AXI_MST_DCXO,
	MT6739_M1_AXI_MST_VENC_CUR_LUMA_HW_VDEC_VLD_EXT,
	MT6739_M2_AXI_MST_USB20,
	MT6739_M3_AXI_MST_USIP_1_I,
	MT6739_M4_AXI_MST_DMA_RD,
	MT6739_M4_AXI_MST_DBGSYS,
	MT6739_M1_AXI_MST_CAM_SV0,
	MT6739_M1_AXI_MST_JPGENC_RDMA,
	MT6739_M3_AXI_MST_USIP_0_DNOCACHE,
	MT6739_M3_AXI_MST_USIP_0_I,
	MT6739_M2_AXI_MST_SPI1,
	MT6739_M4_AXI_MST_HRQ_RD1,
	MT6739_M4_AXI_MST_MMU,
	MT6739_M4_AXI_MST_DFE_DUMP,
	MT6739_M1_AXI_MST_VENC_CUR_CHROMA_HW_VDEC_PPWRAP_EXT,
	MT6739_M1_AXI_MST_AAO,
	MT6739_M4_AXI_MST_MRSG1,
	MT6739_M4_AXI_MST_HRQ_WR,
	MT6739_M1_AXI_MST_DISP_FAKE,
	MT6739_M2_AXI_MST_MSDC0,
	MT6739_M2_AXI_MST_MCUPM,
	MT6739_M1_AXI_MST_VENC_SV_COMV_HW_VDEC_PRED_WR_EXT,
	MT6739_M1_AXI_MST_MM_IOMMU,
	MT6739_M4_AXI_MST_DEBUG,
	MT6739_M3_AXI_MST_MD_MMU,
	MT6739_M4_AXI_MST_TXBRP1,
	MT6739_M2_AXI_MST_MD,
	MT6739_M1_AXI_MST_RRZO,
	MT6739_M1_AXI_MST_VENC_REF_LUMA_HW_VDEC_AVC_MV_EXT,
	MT6739_M1_AXI_MST_LSCI_1,
	MT6739_M4_AXI_MST_LOG_TOP_DSP,
	MT6739_M1_AXI_MST_IMG2O,
	MT6739_M2_AXI_MST_PWM,
	MT6739_M4_AXI_MST_PPPHA,
	MT6739_M4_AXI_MST_TPC,
	MT6739_M5_AXI_MST_MFG,
	MT6739_M4_AXI_MST_BR_DMA,
	MT6739_M4_AXI_MST_LOG_TOP_MCU,
	MT6739_M4_AXI_MST_TXCAL,
	MT6739_M3_AXI_MST_USIP_0_DCACHE,
	MT6739_M2_AXI_MST_DX_CC,
	MT6739_M1_AXI_MST_BPCI_1,
	MT6739_M1_AXI_MST_VENC_BSDMA_HW_VDEC_PP_EXT,
	MT6739_M1_AXI_MST_IMGI,
	MT6739_M1_AXI_MST_ESFKO,
	MT6739_M4_AXI_MST_QP,
	MT6739_M4_AXI_MST_DMA_WR,
	MT6739_M3_AXI_MST_USIP_1_DCACHE,
	MT6739_M1_AXI_MST_MDP_WROT0,
	MT6739_M2_AXI_MST_SPM,
	MT6739_M4_AXI_MST_GDMA,
	MT6739_M4_AXI_MST_VTB,
	MT6739_M3_AXI_MST_USIP_1_DNOCACHE,
	MT6739_M0_AXI_MST_MP0,
	MT6739_M4_AXI_MST_TRACE_TOP,
	MT6739_M1_AXI_MST_DISP_WDMA0,
	MT6739_M1_AXI_MST_VENC_RCPU_HW_VDEC_MC_EXT,
	MT6739_M1_AXI_MST_VENC_REC,
	MT6739_M1_AXI_MST_IMGO,
	MT6739_M2_AXI_MST_DEBUGTOP,
	MT6739_M4_AXI_MST_HRQ_WR1,
	MT6739_M1_AXI_MST_VENC_REF_CHROMA,
	MT6739_M2_AXI_MST_SPI0,
	MT6739_M2_AXI_MST_CLDMA,
	MT6739_M2_AXI_MST_SPI2,
	MT6739_M4_AXI_MST_MRSG0,
	MT6739_M2_AXI_MST_CONNSYS,
	MT6739_M4_AXI_MST_IRDMA,
	MT6739_M2_AXI_MST_AUDIO,
	MST_INVALID,
	NR_MST
};

static const struct mst_tbl_entry mst_tbl[] = {
	{.master = MT6739_M0_AXI_MST_MP0, .port = 0, .id_mask = 0x1FFC,
		.id_val = 0x0,
		.note = "Core nn system domain store exclusive",
		.name = "MT6739_M0_AXI_MST_MP0"},
	{.master = MT6739_M0_AXI_MST_MP0, .port = 0, .id_mask = 0x1FFC,
		.id_val = 0x4,
		.note = "Core nn barrier",
		.name = "MT6739_M0_AXI_MST_MP0"},
	{.master = MT6739_M0_AXI_MST_MP0, .port = 0, .id_mask = 0x1FFF,
		.id_val = 0x8,
		.note = "Unused",
		.name = "MT6739_M0_AXI_MST_MP0"},
	{.master = MT6739_M0_AXI_MST_MP0, .port = 0, .id_mask = 0x1FFF,
		.id_val = 0x9,
		.note = "SCU generated barrier",
		.name = "MT6739_M0_AXI_MST_MP0"},
	{.master = MT6739_M0_AXI_MST_MP0, .port = 0, .id_mask = 0x1FFE,
		.id_val = 0xA,
		.note = "Unused",
		.name = "MT6739_M0_AXI_MST_MP0"},
	{.master = MT6739_M0_AXI_MST_MP0, .port = 0, .id_mask = 0x1FFC,
		.id_val = 0xC,
		.note = "Core nn non-re-orderable device write",
		.name = "MT6739_M0_AXI_MST_MP0"},
	{.master = MT6739_M0_AXI_MST_MP0, .port = 0, .id_mask = 0x1FF0,
		.id_val = 0x10,
		.note = "Write to normal memory or re-orderable device memory",
		.name = "MT6739_M0_AXI_MST_MP0"},
	{.master = MT6739_M0_AXI_MST_MP0, .port = 0, .id_mask = 0x1FFC,
		.id_val = 0x0,
		.note = "Core nn exclusive read or non-reorderable device read",
		.name = "MT6739_M0_AXI_MST_MP0"},
	{.master = MT6739_M0_AXI_MST_MP0, .port = 0, .id_mask = 0x1FFC,
		.id_val = 0x4,
		.note = "Core nn barrier",
		.name = "MT6739_M0_AXI_MST_MP0"},
	{.master = MT6739_M0_AXI_MST_MP0, .port = 0, .id_mask = 0x1FFF,
		.id_val = 0x8,
		.note = "Unused",
		.name = "MT6739_M0_AXI_MST_MP0"},
	{.master = MT6739_M0_AXI_MST_MP0, .port = 0, .id_mask = 0x1FFF,
		.id_val = 0x9,
		.note = "SCU generated barrier or DVM complete",
		.name = "MT6739_M0_AXI_MST_MP0"},
	{.master = MT6739_M0_AXI_MST_MP0, .port = 0, .id_mask = 0x1FFE,
		.id_val = 0xA,
		.note = "Unused",
		.name = "MT6739_M0_AXI_MST_MP0"},
	{.master = MT6739_M0_AXI_MST_MP0, .port = 0, .id_mask = 0x1FFC,
		.id_val = 0xC,
		.note = "Unused",
		.name = "MT6739_M0_AXI_MST_MP0"},
	{.master = MT6739_M0_AXI_MST_MP0, .port = 0, .id_mask = 0x1FF3,
		.id_val = 0x10,
		.note = "ACP read",
		.name = "MT6739_M0_AXI_MST_MP0"},
	{.master = MT6739_M0_AXI_MST_MP0, .port = 0, .id_mask = 0x1FF3,
		.id_val = 0x11,
		.note = "Unused",
		.name = "MT6739_M0_AXI_MST_MP0"},
	{.master = MT6739_M0_AXI_MST_MP0, .port = 0, .id_mask = 0x1FF2,
		.id_val = 0x12,
		.note = "Unused",
		.name = "MT6739_M0_AXI_MST_MP0"},
	{.master = MT6739_M0_AXI_MST_MP0, .port = 0, .id_mask = 0x1FE0,
		.id_val = 0x20,
		.note = "Core nn read",
		.name = "MT6739_M0_AXI_MST_MP0"},
	{.master = MT6739_M1_AXI_MST_DISP_OVL0, .port = 1, .id_mask = 0x1FFC,
		.id_val = 0x0,
		.note = "",
		.name = "MT6739_M1_AXI_MST_DISP_OVL0"},
	{.master = MT6739_M1_AXI_MST_DISP_RDMA0, .port = 1, .id_mask = 0x1FFC,
		.id_val = 0x4,
		.note = "",
		.name = "MT6739_M1_AXI_MST_DISP_RDMA0"},
	{.master = MT6739_M1_AXI_MST_DISP_WDMA0, .port = 1, .id_mask = 0x1FFC,
		.id_val = 0x8,
		.note = "",
		.name = "MT6739_M1_AXI_MST_DISP_WDMA0"},
	{.master = MT6739_M1_AXI_MST_MDP_RDMA0, .port = 1, .id_mask = 0x1FFC,
		.id_val = 0xC,
		.note = "",
		.name = "MT6739_M1_AXI_MST_MDP_RDMA0"},
	{.master = MT6739_M1_AXI_MST_MDP_WDMA0, .port = 1, .id_mask = 0x1FFC,
		.id_val = 0x10,
		.note = "",
		.name = "MT6739_M1_AXI_MST_MDP_WDMA0"},
	{.master = MT6739_M1_AXI_MST_MDP_WROT0, .port = 1, .id_mask = 0x1FFC,
		.id_val = 0x14,
		.note = "",
		.name = "MT6739_M1_AXI_MST_MDP_WROT0"},
	{.master = MT6739_M1_AXI_MST_DISP_FAKE, .port = 1, .id_mask = 0x1FFC,
		.id_val = 0x18,
		.note = "",
		.name = "MT6739_M1_AXI_MST_DISP_FAKE"},
	{.master = MT6739_M1_AXI_MST_VENC_RCPU_HW_VDEC_MC_EXT, .port = 1, .id_mask = 0x1FFC,
		.id_val = 0x80,
		.note = "",
		.name = "MT6739_M1_AXI_MST_VENC_RCPU_HW_VDEC_MC_EXT"},
	{.master = MT6739_M1_AXI_MST_VENC_REC, .port = 1, .id_mask = 0x1FFC,
		.id_val = 0x84,
		.note = "",
		.name = "MT6739_M1_AXI_MST_VENC_REC"},
	{.master = MT6739_M1_AXI_MST_VENC_BSDMA_HW_VDEC_PP_EXT, .port = 1, .id_mask = 0x1FFC,
		.id_val = 0x88,
		.note = "",
		.name = "MT6739_M1_AXI_MST_VENC_BSDMA_HW_VDEC_PP_EXT"},
	{.master = MT6739_M1_AXI_MST_VENC_SV_COMV_HW_VDEC_PRED_WR_EXT, .port = 1, .id_mask = 0x1FFC,
		.id_val = 0x8C,
		.note = "",
		.name = "MT6739_M1_AXI_MST_VENC_SV_COMV_HW_VDEC_PRED_WR_EXT"},
	{.master = MT6739_M1_AXI_MST_VENC_RD_COMV_HW_VDEC_PRED_RD_EXT, .port = 1, .id_mask = 0x1FFC,
		.id_val = 0x90,
		.note = "",
		.name = "MT6739_M1_AXI_MST_VENC_RD_COMV_HW_VDEC_PRED_RD_EXT"},
	{.master = MT6739_M1_AXI_MST_JPGENC_RDMA, .port = 1, .id_mask = 0x1FFC,
		.id_val = 0x94,
		.note = "",
		.name = "MT6739_M1_AXI_MST_JPGENC_RDMA"},
	{.master = MT6739_M1_AXI_MST_JPGENC_BSDMA, .port = 1, .id_mask = 0x1FFC,
		.id_val = 0x98,
		.note = "",
		.name = "MT6739_M1_AXI_MST_JPGENC_BSDMA"},
	{.master = MT6739_M1_AXI_MST_VENC_CUR_LUMA_HW_VDEC_VLD_EXT, .port = 1, .id_mask = 0x1FFC,
		.id_val = 0x9C,
		.note = "",
		.name = "MT6739_M1_AXI_MST_VENC_CUR_LUMA_HW_VDEC_VLD_EXT"},
	{.master = MT6739_M1_AXI_MST_VENC_CUR_CHROMA_HW_VDEC_PPWRAP_EXT, .port = 1, .id_mask = 0x1FFC,
		.id_val = 0xA0,
		.note = "",
		.name = "MT6739_M1_AXI_MST_VENC_CUR_CHROMA_HW_VDEC_PPWRAP_EXT"},
	{.master = MT6739_M1_AXI_MST_VENC_REF_LUMA_HW_VDEC_AVC_MV_EXT, .port = 1, .id_mask = 0x1FFC,
		.id_val = 0xA4,
		.note = "",
		.name = "MT6739_M1_AXI_MST_VENC_REF_LUMA_HW_VDEC_AVC_MV_EXT"},
	{.master = MT6739_M1_AXI_MST_VENC_REF_CHROMA, .port = 1, .id_mask = 0x1FFC,
		.id_val = 0xA8,
		.note = "",
		.name = "MT6739_M1_AXI_MST_VENC_REF_CHROMA"},
	{.master = MT6739_M1_AXI_MST_IMGO, .port = 1, .id_mask = 0x1FFC,
		.id_val = 0x100,
		.note = "",
		.name = "MT6739_M1_AXI_MST_IMGO"},
	{.master = MT6739_M1_AXI_MST_RRZO, .port = 1, .id_mask = 0x1FFC,
		.id_val = 0x104,
		.note = "",
		.name = "MT6739_M1_AXI_MST_RRZO"},
	{.master = MT6739_M1_AXI_MST_LSCI_0, .port = 1, .id_mask = 0x1FFC,
		.id_val = 0x108,
		.note = "",
		.name = "MT6739_M1_AXI_MST_LSCI_0"},
	{.master = MT6739_M1_AXI_MST_LSCI_1, .port = 1, .id_mask = 0x1FFC,
		.id_val = 0x10C,
		.note = "",
		.name = "MT6739_M1_AXI_MST_LSCI_1"},
	{.master = MT6739_M1_AXI_MST_BPCI_0, .port = 1, .id_mask = 0x1FFC,
		.id_val = 0x110,
		.note = "",
		.name = "MT6739_M1_AXI_MST_BPCI_0"},
	{.master = MT6739_M1_AXI_MST_BPCI_1, .port = 1, .id_mask = 0x1FFC,
		.id_val = 0x114,
		.note = "",
		.name = "MT6739_M1_AXI_MST_BPCI_1"},
	{.master = MT6739_M1_AXI_MST_ESFKO, .port = 1, .id_mask = 0x1FFC,
		.id_val = 0x118,
		.note = "",
		.name = "MT6739_M1_AXI_MST_ESFKO"},
	{.master = MT6739_M1_AXI_MST_AAO, .port = 1, .id_mask = 0x1FFC,
		.id_val = 0x11C,
		.note = "",
		.name = "MT6739_M1_AXI_MST_AAO"},
	{.master = MT6739_M1_AXI_MST_CAM_SV0, .port = 1, .id_mask = 0x1FFC,
		.id_val = 0x120,
		.note = "",
		.name = "MT6739_M1_AXI_MST_CAM_SV0"},
	{.master = MT6739_M1_AXI_MST_IMGI, .port = 1, .id_mask = 0x1FFC,
		.id_val = 0x124,
		.note = "",
		.name = "MT6739_M1_AXI_MST_IMGI"},
	{.master = MT6739_M1_AXI_MST_IMG2O, .port = 1, .id_mask = 0x1FFC,
		.id_val = 0x128,
		.note = "",
		.name = "MT6739_M1_AXI_MST_IMG2O"},
	{.master = MT6739_M1_AXI_MST_MM_IOMMU, .port = 1, .id_mask = 0x1FFF,
		.id_val = 0x3FC,
		.note = "internal used",
		.name = "MT6739_M1_AXI_MST_MM_IOMMU"},
	{.master = MT6739_M1_AXI_MST_MM_IOMMU, .port = 1, .id_mask = 0x1FFF,
		.id_val = 0x3FD,
		.note = "internal used",
		.name = "MT6739_M1_AXI_MST_MM_IOMMU"},
	{.master = MT6739_M2_AXI_MST_DEBUGTOP, .port = 2, .id_mask = 0x1FF7,
		.id_val = 0x0,
		.note = "",
		.name = "MT6739_M2_AXI_MST_DEBUGTOP"},
	{.master = MT6739_M2_AXI_MST_MSDC0, .port = 2, .id_mask = 0x1FFF,
		.id_val = 0x1,
		.note = "",
		.name = "MT6739_M2_AXI_MST_MSDC0"},
	{.master = MT6739_M2_AXI_MST_PWM, .port = 2, .id_mask = 0x1FFF,
		.id_val = 0x9,
		.note = "",
		.name = "MT6739_M2_AXI_MST_PWM"},
	{.master = MT6739_M2_AXI_MST_MSDC1, .port = 2, .id_mask = 0x1FFF,
		.id_val = 0x49,
		.note = "",
		.name = "MT6739_M2_AXI_MST_MSDC1"},
	{.master = MT6739_M2_AXI_MST_AUDIO, .port = 2, .id_mask = 0x1FFF,
		.id_val = 0x89,
		.note = "",
		.name = "MT6739_M2_AXI_MST_AUDIO"},
	{.master = MT6739_M2_AXI_MST_SPI0, .port = 2, .id_mask = 0x1FFF,
		.id_val = 0xC9,
		.note = "",
		.name = "MT6739_M2_AXI_MST_SPI0"},
	{.master = MT6739_M2_AXI_MST_NFI, .port = 2, .id_mask = 0x1FFF,
		.id_val = 0x11,
		.note = "",
		.name = "MT6739_M2_AXI_MST_NFI"},
	{.master = MT6739_M2_AXI_MST_SPI2, .port = 2, .id_mask = 0x1FFF,
		.id_val = 0x51,
		.note = "",
		.name = "MT6739_M2_AXI_MST_SPI2"},
	{.master = MT6739_M2_AXI_MST_SPI1, .port = 2, .id_mask = 0x1FFF,
		.id_val = 0x91,
		.note = "",
		.name = "MT6739_M2_AXI_MST_SPI1"},
	{.master = MT6739_M2_AXI_MST_USB20, .port = 2, .id_mask = 0x1FFF,
		.id_val = 0xD1,
		.note = "",
		.name = "MT6739_M2_AXI_MST_USB20"},
	{.master = MT6739_M2_AXI_MST_MCUPM, .port = 2, .id_mask = 0x1FFF,
		.id_val = 0x19,
		.note = "",
		.name = "MT6739_M2_AXI_MST_MCUPM"},
	{.master = MT6739_M2_AXI_MST_SPM, .port = 2, .id_mask = 0x1FFF,
		.id_val = 0x59,
		.note = "",
		.name = "MT6739_M2_AXI_MST_SPM"},
	{.master = MT6739_M2_AXI_MST_MD, .port = 2, .id_mask = 0x1FFF,
		.id_val = 0x99,
		.note = "",
		.name = "MT6739_M2_AXI_MST_MD"},
	{.master = MT6739_M2_AXI_MST_THERM, .port = 2, .id_mask = 0x1FFF,
		.id_val = 0xD9,
		.note = "",
		.name = "MT6739_M2_AXI_MST_THERM"},
	{.master = MT6739_M2_AXI_MST_DMA_EXT, .port = 2, .id_mask = 0x1FFF,
		.id_val = 0x21,
		.note = "",
		.name = "MT6739_M2_AXI_MST_DMA_EXT"},
	{.master = MT6739_M2_AXI_MST_CONNSYS, .port = 2, .id_mask = 0x1FFF,
		.id_val = 0x2,
		.note = "",
		.name = "MT6739_M2_AXI_MST_CONNSYS"},
	{.master = MT6739_M2_AXI_MST_DX_CC, .port = 2, .id_mask = 0x1F87,
		.id_val = 0x3,
		.note = "",
		.name = "MT6739_M2_AXI_MST_DX_CC"},
	{.master = MT6739_M2_AXI_MST_CQ_DMA, .port = 2, .id_mask = 0x1F87,
		.id_val = 0x4,
		.note = "",
		.name = "MT6739_M2_AXI_MST_CQ_DMA"},
	{.master = MT6739_M2_AXI_MST_CLDMA, .port = 2, .id_mask = 0x1FE7,
		.id_val = 0x5,
		.note = "",
		.name = "MT6739_M2_AXI_MST_CLDMA"},
	{.master = MT6739_M2_AXI_MST_GCE_M, .port = 2, .id_mask = 0x1FE7,
		.id_val = 0x6,
		.note = "",
		.name = "MT6739_M2_AXI_MST_GCE_M"},
	{.master = MT6739_M3_AXI_MST_MD_MM, .port = 3, .id_mask = 0x1F83,
		.id_val = 0x0,
		.note = "",
		.name = "MT6739_M3_AXI_MST_MD_MM"},
	{.master = MT6739_M3_AXI_MST_MD_MMU, .port = 3, .id_mask = 0x1F83,
		.id_val = 0x1,
		.note = "",
		.name = "MT6739_M3_AXI_MST_MD_MMU"},
	{.master = MT6739_M3_AXI_MST_USIP_0_I, .port = 3, .id_mask = 0x1F1F,
		.id_val = 0x2,
		.note = "",
		.name = "MT6739_M3_AXI_MST_USIP_0_I"},
	{.master = MT6739_M3_AXI_MST_USIP_0_DCACHE, .port = 3, .id_mask = 0x1F1F,
		.id_val = 0x6,
		.note = "",
		.name = "MT6739_M3_AXI_MST_USIP_0_DCACHE"},
	{.master = MT6739_M3_AXI_MST_USIP_0_DNOCACHE, .port = 3, .id_mask = 0x1F1F,
		.id_val = 0xA,
		.note = "",
		.name = "MT6739_M3_AXI_MST_USIP_0_DNOCACHE"},
	{.master = MT6739_M3_AXI_MST_USIP_1_I, .port = 3, .id_mask = 0x1F1F,
		.id_val = 0x12,
		.note = "",
		.name = "MT6739_M3_AXI_MST_USIP_1_I"},
	{.master = MT6739_M3_AXI_MST_USIP_1_DCACHE, .port = 3, .id_mask = 0x1F1F,
		.id_val = 0x16,
		.note = "",
		.name = "MT6739_M3_AXI_MST_USIP_1_DCACHE"},
	{.master = MT6739_M3_AXI_MST_USIP_1_DNOCACHE, .port = 3, .id_mask = 0x1F1F,
		.id_val = 0x1A,
		.note = "",
		.name = "MT6739_M3_AXI_MST_USIP_1_DNOCACHE"},
	{.master = MT6739_M4_AXI_MST_HRQ_RD, .port = 4, .id_mask = 0x1FFF,
		.id_val = 0x0,
		.note = "",
		.name = "MT6739_M4_AXI_MST_HRQ_RD"},
	{.master = MT6739_M4_AXI_MST_HRQ_RD1, .port = 4, .id_mask = 0x1FFF,
		.id_val = 0x804,
		.note = "",
		.name = "MT6739_M4_AXI_MST_HRQ_RD1"},
	{.master = MT6739_M4_AXI_MST_HRQ_WR, .port = 4, .id_mask = 0x1FFF,
		.id_val = 0x801,
		.note = "",
		.name = "MT6739_M4_AXI_MST_HRQ_WR"},
	{.master = MT6739_M4_AXI_MST_HRQ_WR1, .port = 4, .id_mask = 0x1FFF,
		.id_val = 0x805,
		.note = "",
		.name = "MT6739_M4_AXI_MST_HRQ_WR1"},
	{.master = MT6739_M4_AXI_MST_VTB, .port = 4, .id_mask = 0x1FFF,
		.id_val = 0x806,
		.note = "",
		.name = "MT6739_M4_AXI_MST_VTB"},
	{.master = MT6739_M4_AXI_MST_TBO, .port = 4, .id_mask = 0x1FFF,
		.id_val = 0x80A,
		.note = "",
		.name = "MT6739_M4_AXI_MST_TBO"},
	{.master = MT6739_M4_AXI_MST_DEBUG, .port = 4, .id_mask = 0x1FFF,
		.id_val = 0x802,
		.note = "",
		.name = "MT6739_M4_AXI_MST_DEBUG"},
	{.master = MT6739_M4_AXI_MST_DFE_DUMP, .port = 4, .id_mask = 0x1FFF,
		.id_val = 0x404,
		.note = "",
		.name = "MT6739_M4_AXI_MST_DFE_DUMP"},
	{.master = MT6739_M4_AXI_MST_BR_DMA, .port = 4, .id_mask = 0x1FFF,
		.id_val = 0x405,
		.note = "",
		.name = "MT6739_M4_AXI_MST_BR_DMA"},
	{.master = MT6739_M4_AXI_MST_IRDMA, .port = 4, .id_mask = 0x1FFF,
		.id_val = 0x8,
		.note = "",
		.name = "MT6739_M4_AXI_MST_IRDMA"},
	{.master = MT6739_M4_AXI_MST_TXBRP0, .port = 4, .id_mask = 0x1FFF,
		.id_val = 0x28,
		.note = "",
		.name = "MT6739_M4_AXI_MST_TXBRP0"},
	{.master = MT6739_M4_AXI_MST_TXBRP1, .port = 4, .id_mask = 0x1FFF,
		.id_val = 0xA8,
		.note = "",
		.name = "MT6739_M4_AXI_MST_TXBRP1"},
	{.master = MT6739_M4_AXI_MST_TXCAL, .port = 4, .id_mask = 0x1FFF,
		.id_val = 0x68,
		.note = "",
		.name = "MT6739_M4_AXI_MST_TXCAL"},
	{.master = MT6739_M4_AXI_MST_TPC, .port = 4, .id_mask = 0x1FFF,
		.id_val = 0xE8,
		.note = "",
		.name = "MT6739_M4_AXI_MST_TPC"},
	{.master = MT6739_M4_AXI_MST_RXDFE_DMA, .port = 4, .id_mask = 0x1FFF,
		.id_val = 0x38,
		.note = "",
		.name = "MT6739_M4_AXI_MST_RXDFE_DMA"},
	{.master = MT6739_M4_AXI_MST_MRSG0, .port = 4, .id_mask = 0x1FFF,
		.id_val = 0x78,
		.note = "",
		.name = "MT6739_M4_AXI_MST_MRSG0"},
	{.master = MT6739_M4_AXI_MST_MRSG1, .port = 4, .id_mask = 0x1FFF,
		.id_val = 0xB8,
		.note = "",
		.name = "MT6739_M4_AXI_MST_MRSG1"},
	{.master = MT6739_M4_AXI_MST_CNWDMA, .port = 4, .id_mask = 0x1FFF,
		.id_val = 0x98,
		.note = "",
		.name = "MT6739_M4_AXI_MST_CNWDMA"},
	{.master = MT6739_M4_AXI_MST_CSH, .port = 4, .id_mask = 0x1FFF,
		.id_val = 0x58,
		.note = "",
		.name = "MT6739_M4_AXI_MST_CSH"},
	{.master = MT6739_M4_AXI_MST_DCXO, .port = 4, .id_mask = 0x1FFF,
		.id_val = 0x18,
		.note = "",
		.name = "MT6739_M4_AXI_MST_DCXO"},
	{.master = MT6739_M4_AXI_MST_DMA_RD, .port = 4, .id_mask = 0x1FFF,
		.id_val = 0xC02,
		.note = "",
		.name = "MT6739_M4_AXI_MST_DMA_RD"},
	{.master = MT6739_M4_AXI_MST_DMA_WR, .port = 4, .id_mask = 0x1FFF,
		.id_val = 0xC03,
		.note = "",
		.name = "MT6739_M4_AXI_MST_DMA_WR"},
	{.master = MT6739_M4_AXI_MST_MMU, .port = 4, .id_mask = 0x1FFF,
		.id_val = 0xC00,
		.note = "",
		.name = "MT6739_M4_AXI_MST_MMU"},
	{.master = MT6739_M4_AXI_MST_QP, .port = 4, .id_mask = 0x1FFF,
		.id_val = 0xC01,
		.note = "",
		.name = "MT6739_M4_AXI_MST_QP"},
	{.master = MT6739_M4_AXI_MST_LOG_TOP_MCU, .port = 4, .id_mask = 0x1FFF,
		.id_val = 0x12,
		.note = "",
		.name = "MT6739_M4_AXI_MST_LOG_TOP_MCU"},
	{.master = MT6739_M4_AXI_MST_LOG_TOP_DSP, .port = 4, .id_mask = 0x1FFF,
		.id_val = 0x3,
		.note = "",
		.name = "MT6739_M4_AXI_MST_LOG_TOP_DSP"},
	{.master = MT6739_M4_AXI_MST_TRACE_TOP, .port = 4, .id_mask = 0x1FFF,
		.id_val = 0x4,
		.note = "",
		.name = "MT6739_M4_AXI_MST_TRACE_TOP"},
	{.master = MT6739_M4_AXI_MST_PPPHA, .port = 4, .id_mask = 0x1FEF,
		.id_val = 0x1,
		.note = "",
		.name = "MT6739_M4_AXI_MST_PPPHA"},
	{.master = MT6739_M4_AXI_MST_IPSEC, .port = 4, .id_mask = 0x1FFF,
		.id_val = 0x5,
		.note = "",
		.name = "MT6739_M4_AXI_MST_IPSEC"},
	{.master = MT6739_M4_AXI_MST_GDMA, .port = 4, .id_mask = 0x1F1F,
		.id_val = 0x7,
		.note = "",
		.name = "MT6739_M4_AXI_MST_GDMA"},
	{.master = MT6739_M4_AXI_MST_DBGSYS, .port = 4, .id_mask = 0x1FFF,
		.id_val = 0x7,
		.note = "",
		.name = "MT6739_M4_AXI_MST_DBGSYS"},
	{.master = MT6739_M5_AXI_MST_MFG, .port = 5, .id_mask = 0x1FC0,
		.id_val = 0x0,
		.note = "",
		.name = "MT6739_M5_AXI_MST_MFG"},
};

#endif /* end of _EMI_MODULE_H_ */
