/*
 * Copyright (C) 2016 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See http://www.gnu.org/licenses/gpl-2.0.html for more details.
 */
#define LOG_TAG  "GC08A3_DD_V590:"
#define SENSORDB_GC08A3_DD_V590_OTP(fmt,arg...)  printk(LOG_TAG "%s: " fmt "\n", __FUNCTION__ ,##arg)
#include <linux/kernel.h>
//#include <linux/videodev2.h>
#include <linux/i2c.h>
#include <linux/platform_device.h>
#include <linux/delay.h>
#include <linux/cdev.h>
#include <linux/uaccess.h>
#include <linux/module.h>

//#include <asm/atomic.h>
#include <linux/slab.h>
#include <linux/fs.h>
#include <linux/of.h>
//#include "kd_camera_hw.h"
#include "cam_cal.h"
#include "cam_cal_define.h"
#include "kd_imgsensor.h" 
#include "kd_imgsensor_define.h"
#include "kd_imgsensor_errcode.h"
#include "kd_imgsensor_define.h"
#include "kd_camera_typedef.h"

#include <linux/dma-mapping.h>

#ifdef CONFIG_COMPAT
/* 64 bit */
#include <linux/fs.h>
#include <linux/compat.h>
#endif

#include "gc08a3_dd_v590_otp.h"
//u16 gc08a3_dd_v590_af_data[2];
static struct i2c_client *g_pstI2CclientG;

#define GC08A3_OTP_DEBUG  0
#define GC08A3_I2C_ID     0x62 /*0x20*/

extern u16 otp_dd_read_cmos_sensor(u16 addr)
{
	u16 get_byte=0;
	char pu_send_cmd[2] = { (char)((addr >> 8) & 0xff), (char)(addr & 0xff) };

	iReadRegI2C(pu_send_cmd, 2, (u8 *)&get_byte, 1, GC08A3_I2C_ID);

	return get_byte;
}

extern void otp_dd_write_cmos_sensor(u16 addr, u8 para)
{
	char pu_send_cmd[3] = { (char)((addr >> 8) & 0xff), (char)(addr & 0xff), (char)(para & 0xff) };

	iWriteRegI2C(pu_send_cmd, 3, GC08A3_I2C_ID);
}

void gc08a3_dd_otp_init(void)
{
	otp_dd_write_cmos_sensor(0x0324, 0x44);    
	otp_dd_write_cmos_sensor(0x0316, 0x09);    
	otp_dd_write_cmos_sensor(0x0a67, 0x80);    
	otp_dd_write_cmos_sensor(0x0313, 0x00);    
	otp_dd_write_cmos_sensor(0x0a53, 0x0e);//04
	otp_dd_write_cmos_sensor(0x0a65, 0x17);    
	otp_dd_write_cmos_sensor(0x0a68, 0xA1);    
	otp_dd_write_cmos_sensor(0x0a47, 0x00);    
	otp_dd_write_cmos_sensor(0x0a58, 0x00);
	otp_dd_write_cmos_sensor(0x0ace, 0x0c);
	mdelay(10);//add

}

static u16 gc08a3_otp_read_group(u16 addr, u8 *data, u16 length)
{
	u16 i = 0;
	//printk("[GC08A3_DD_V590_CAM_CAL] test addr = 0x%x, length = %d \n", addr, length);
	otp_dd_write_cmos_sensor(0x0313, 0x00);
	otp_dd_write_cmos_sensor(0x0a69, (addr >> 8) & 0xff);
	otp_dd_write_cmos_sensor(0x0a6a, addr & 0xff);
	otp_dd_write_cmos_sensor(0x0313, 0x20);
	otp_dd_write_cmos_sensor(0x0313, 0x12);

	for (i = 0; i < length; i++) {
		data[i] = otp_dd_read_cmos_sensor(0x0a6c);
#if GC08A3_OTP_DEBUG
	printk("[GC08A3_DD_V590_CAM_CAL] test addr = 0x%x, data = 0x%x\n", addr + i * 8, data[i]);
#endif
	}
	return 0;
}
void gc08a3_dd_otp_close(void)
{
	otp_dd_write_cmos_sensor(0x0316, 0x01);
	otp_dd_write_cmos_sensor(0x0a67, 0x00);
}

//end test otp flow

int gc08a3_iReadData(unsigned int ui4_offset,
	unsigned int ui4_length, unsigned char *pinputdata)
{
	int i4RetValue = 0;
	int i4ResidueDataLength;
	u32 u4CurrentOffset;
	u8 *pBuff;

//	u8 gc08a3_group_flag = 0x00;
//	u16 gc08a3_group_flag_offset = 0x1418;
//	u16 gc08a3_group_size = 1895;

	//printk("[GC08A3_DD_V590_CAM_CAL] test ui4_offset = 0x%x, ui4_length = %d \n", ui4_offset, ui4_length);

	i4ResidueDataLength = (int)ui4_length;
	u4CurrentOffset = ui4_offset;
	pBuff = pinputdata;

	gc08a3_dd_otp_init();
//	gc08a3_otp_read_group(gc08a3_group_flag_offset, &gc08a3_group_flag, 1);
	/*
	if ((gc08a3_group_flag & 0x03) == 1) {
		u4CurrentOffset = ui4_offset;
		pr_debug("gc08a3 otp group1, u4CurrentOffset = 0x%x\n", u4CurrentOffset);
	} else if (((gc08a3_group_flag >> 2) & 0x03) == 1) {
		u4CurrentOffset = ui4_offset + gc08a3_group_size * 8;
		pr_debug("gc08a3 otp group2, u4CurrentOffset = 0x%x\n", u4CurrentOffset);
	} else if (((gc08a3_group_flag >> 4) & 0x03) == 1) {
		u4CurrentOffset = ui4_offset + 2 * gc08a3_group_size * 8;
		pr_debug("gc08a3 otp group3, u4CurrentOffset = 0x%x\n", u4CurrentOffset);
	} else {
		pr_debug("gc08a3 otp error\n");
		return -1;
	}
*/
	i4RetValue =
			gc08a3_otp_read_group(
			(u16) u4CurrentOffset, pBuff, i4ResidueDataLength);
		if (i4RetValue != 0) {
			printk("I2C iReadData failed!!\n");
			return -1;
		}

	gc08a3_dd_otp_close();

	return 0;
}

extern unsigned int gc08a3_dd_v590_read_region(struct i2c_client *client, unsigned int addr,
				unsigned char *data, unsigned int size)
{
	printk("[GC08A3_DD_V590_CAM_CAL] read_region");
	g_pstI2CclientG = client;
	if (gc08a3_iReadData(addr, size, data) == 0)
		return size;
	else
		return 0;
}

