#ifndef BUILD_LK
#include <linux/string.h>
#include <linux/kernel.h>
#endif
#include "lcm_drv.h"

#ifdef BUILD_LK
#include <platform/mt_gpio.h>
#elif defined(BUILD_UBOOT)
#include <asm/arch/mt_gpio.h>
#else
#endif

#ifndef BUILD_LK
int bEnTGesture_icnl9911c_tp = 0; //用作tp 手势唤醒功能调试，先打开
#endif

// ---------------------------------------------------------------------------
//  Local Constants
// ---------------------------------------------------------------------------

#define FRAME_WIDTH  (720)
#define FRAME_HEIGHT (1560)


#ifndef TRUE
#define   TRUE     1
#endif

#ifndef FALSE
#define   FALSE    0
#endif

#ifdef BUILD_LK
#define LCM_PRINT printf
#else
#if defined(BUILD_UBOOT)
#define LCM_PRINT printf
#else
#define LCM_PRINT printk
#endif
#endif

#define LCM_DBG(fmt, arg...) \
    LCM_PRINT("[icnl9911c_v690_hdplus_dsi_vdo_hf.c] %s (line:%d) :" fmt "\r\n", __func__, __LINE__, ## arg)

// ---------------------------------------------------------------------------
//  Local Variables
// ---------------------------------------------------------------------------

static struct LCM_UTIL_FUNCS lcm_util;

#define SET_RESET_PIN(v)                                    (lcm_util.set_reset_pin((v)))
#define LCM_PHYSICAL_WIDTH (65000)
#define LCM_PHYSICAL_HEIGHT (140000)
// ---------------------------------------------------------------------------
//  Local Constants
// ---------------------------------------------------------------------------


#ifdef GPIO_LCM_PWR
#define SET_PWR_PIN(v)    \
    mt_set_gpio_mode(GPIO_LCM_PWR,GPIO_MODE_00);    \
    mt_set_gpio_dir(GPIO_LCM_PWR,GPIO_DIR_OUT);     \
    if(v)                                           \
        mt_set_gpio_out(GPIO_LCM_PWR,GPIO_OUT_ONE); \
    else                                            \
        mt_set_gpio_out(GPIO_LCM_PWR,GPIO_OUT_ZERO);	
#endif
#define UDELAY(n) (lcm_util.udelay(n))
#define MDELAY(n) (lcm_util.mdelay(n))

#define GPIO_LCD_ID (GPIO165 | 0x80000000)

// ---------------------------------------------------------------------------
//  Local Functions
// ---------------------------------------------------------------------------
#define dsi_set_cmdq_V3(para_tbl,size,force_update)        lcm_util.dsi_set_cmdq_V3(para_tbl,size,force_update)
#define dsi_set_cmdq_V2(cmd, count, ppara, force_update)	        lcm_util.dsi_set_cmdq_V2(cmd, count, ppara, force_update)
#define dsi_set_cmdq(pdata, queue_size, force_update)		lcm_util.dsi_set_cmdq(pdata, queue_size, force_update)
#define wrtie_cmd(cmd)										lcm_util.dsi_write_cmd(cmd)
#define write_regs(addr, pdata, byte_nums)					lcm_util.dsi_write_regs(addr, pdata, byte_nums)
#define read_reg(cmd)                                       lcm_util.dsi_read_reg(cmd)
#define read_reg_v2(cmd, buffer, buffer_size)   				lcm_util.dsi_dcs_read_lcm_reg_v2(cmd, buffer, buffer_size)


#define LCM_DSI_CMD_MODE                                    0


#define REGFLAG_DELAY                                       0XFCFC
#define REGFLAG_END_OF_TABLE                                0xFDFD   // END OF REGISTERS MARKER

#define LCM_ID       (0x9882)


#define UDELAY(n)                                           (lcm_util.udelay(n))
#define MDELAY(n)                                           (lcm_util.mdelay(n))


extern void lcm_enn(int onoff);
extern void lcm_enp(int onoff);
extern  int _lcm_i2c_write_bytes(unsigned char addr, unsigned char value);
extern int get_lcm_id_status(void);

char *r = NULL;
unsigned char kernel_F6_buf[3] = {0};
unsigned char kernel_F6_real = 0x0;


static unsigned int lcm_compare_id(void);
// ---------------------------------------------------------------------------
//  Local Functions
// ---------------------------------------------------------------------------

#define dsi_set_cmdq_V2(cmd, count, ppara, force_update)    lcm_util.dsi_set_cmdq_V2(cmd, count, ppara, force_update)
#define dsi_set_cmdq(pdata, queue_size, force_update)       lcm_util.dsi_set_cmdq(pdata, queue_size, force_update)
#define wrtie_cmd(cmd)                                      lcm_util.dsi_write_cmd(cmd)
#define write_regs(addr, pdata, byte_nums)                  lcm_util.dsi_write_regs(addr, pdata, byte_nums)
#define read_reg(cmd)                                       lcm_util.dsi_read_reg(cmd)
#define read_reg_v2(cmd, buffer, buffer_size)               lcm_util.dsi_dcs_read_lcm_reg_v2(cmd, buffer, buffer_size)

struct LCM_setting_table
{
    unsigned cmd;
    unsigned char count;
    unsigned char para_list[64];
};


static struct LCM_setting_table lcm_initialization_setting[] =
{
{0xF0,0x02,{0x5A,0x59}},
{0xF1,0x02,{0xA5,0xA6}},
{0xB0,0x1d,{0x83,0x82,0x00,0x00,0x85,0x86,0x00,0x00,0x33,0x33,0x33,0x33,0x00,0x00,0x00,0x78,0x00,0x00,0x0F,0x05,0x04,0x03,0x02,0x01,0x02,0x03,0x04,0x00,0x00}},
{0xB1,0x20,{0x12,0x42,0x89,0x80,0x00,0x05,0x05,0x75,0x05,0x00,0x04,0x08,0x53,0x00,0x00,0x00,0x44,0x40,0x02,0x01,0x40,0x02,0x01,0x40,0x02,0x01,0x40,0x02,0x01,0x00,0x00,0x00}},
//{0xB2,0x11,{0x54,0xC4,0x82,0x05,0x40,0x02,0x01,0x40,0x02,0x01,0x05,0x05,0x54,0x0C,0x0C,0x0D,0x0B}},
//{0xB3,0x1f,{0x02,0x00,0x00,0x00,0x00,0x26,0x26,0x91,0xA2,0x33,0x44,0x00,0x26,0x00,0x18,0x01,0x02,0x08,0x20,0x30,0x08,0x09,0x44,0x20,0x40,0x20,0x40,0x08,0x09,0x22,0x33}},
{0xB4,0x1c,{0x00,0x09,0x00,0x1D,0xDC,0x11,0x0F,0x0D,0x13,0x05,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0xFC,0x00,0x00,0x00}},
{0xB5,0x1c,{0x00,0x08,0x00,0x1D,0xDC,0x10,0x0E,0x0C,0x12,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0xFC,0x00,0x00,0x00}},

//{0xB8,0x18,{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00}},
{0xBB,0x0d,{0x01,0x05,0x09,0x11,0x0D,0x19,0x1D,0x55,0x25,0x69,0x00,0x21,0x25}},
{0xBC,0x0e,{0x00,0x00,0x00,0x00,0x02,0x20,0xFF,0x00,0x03,0x33,0x01,0x73,0x33,0x00}},
{0xBD,0x0a,{0xE9,0x02,0x4E,0xCF,0x72,0xA4,0x08,0x44,0xAE,0x15}},
{0xBE,0x0a,{0x59,0x59,0x50,0x3C,0x0C,0x77,0x43,0x07,0x0E,0x0E}},
{0xBF,0x08,{0x07,0x25,0x07,0x25,0x7F,0x00,0x11,0x04}},
{0xC0,0x09,{0x10,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,0xFF,0x00}},
{0xC1,0x13,{0xC0,0x20,0x20,0x96,0x04,0x60,0x60,0x04,0x2A,0x18,0x36,0x00,0x07,0xCF,0xFF,0xFF,0x9A,0x01,0xC0}},
{0xC2,0x01,{0x00}},
{0xC3,0x09,{0x06,0x00,0xFF,0x00,0xFF,0x00,0x00,0x81,0x01}},
{0xC4,0x0a,{0x84,0x01,0x2B,0x41,0x00,0x3C,0x00,0x03,0x03,0x2E}},
{0xC5,0x0b,{0x03,0x1C,0xC0,0xA8,0x48,0x10,0x62,0x44,0x0A,0x09,0x26}},
{0xC6,0x0a,{0x7F,0xA1,0x22,0x1F,0x1D,0x33,0x7F,0x04,0x08,0x00}},

{0xF6,0x01,{0x3F}},
{0xFA,0x03,{0x45,0x93,0x01}},

{0xC7,0x16,{0xF7,0xDD,0xC9,0xB8,0x97,0x7D,0x51,0xA5,0x6C,0x3E,0x10,0xDB,0x30,0xFF,0xDC,0xA8,0x8B,0x5E,0x1A,0x7F,0xF4,0x00}},
{0xC8,0x16,{0xF7,0xDD,0xC9,0xB8,0x97,0x7D,0x51,0xA5,0x6C,0x3E,0x10,0xDB,0x30,0xFF,0xDC,0xA8,0x8B,0x5E,0x1A,0x7F,0xF4,0x00}},

{0xCB,0x01,{0x00}},
{0xD0,0x05,{0x80,0x0D,0xFF,0x0F,0x61}},
{0xD2,0x00,{0x42}},
{0xFE,0x04,{0xFF,0xFF,0xFF,0x40}},

{0xF1,0x02,{0x5A,0x59}},
{0xF0,0x02,{0xA5,0xA6}},
{0x35,0x01,{0x00}},
    
{0x11,01,{0x00}},                  
{REGFLAG_DELAY,120,{}},
{0x29,01,{0x00}},
{REGFLAG_DELAY,20,{}},
{0x26,01,{0x01}},
{REGFLAG_END_OF_TABLE, 0x00, {}}
};

static struct LCM_setting_table lcm_deep_sleep_mode_in_setting[] =
{
    // Sleep Mode On
    {0x26, 1, {0x08}},
    {0x28, 1, {0x00}},
    {REGFLAG_DELAY, 20, {}},
    // Sleep Mode On
    {0x10, 1, {0x00}},
    {REGFLAG_DELAY, 120, {}},
    {REGFLAG_END_OF_TABLE, 0x00, {}}
};

static void push_table(struct LCM_setting_table *table, unsigned int count, unsigned char force_update)
{
    unsigned int i;

    for(i = 0; i < count; i++)
    {

        unsigned cmd;
        cmd = table[i].cmd;

        switch (cmd)
        {

            case REGFLAG_DELAY :
                MDELAY(table[i].count);
                break;

            case REGFLAG_END_OF_TABLE :
                break;

            default:
                dsi_set_cmdq_V2(cmd, table[i].count, table[i].para_list, force_update);
        }
    }

}


// ---------------------------------------------------------------------------
//  LCM Driver Implementations
// ---------------------------------------------------------------------------

static void lcm_set_util_funcs(const struct LCM_UTIL_FUNCS *util)
{
    memcpy(&lcm_util, util, sizeof(struct LCM_UTIL_FUNCS));
}

static void lcm_get_params(struct LCM_PARAMS *params)
{
    memset(params, 0, sizeof(struct LCM_PARAMS));

    params->type   = LCM_TYPE_DSI;

    params->width  = FRAME_WIDTH;
    params->height = FRAME_HEIGHT;

#if (LCM_DSI_CMD_MODE)
    params->dsi.mode   = CMD_MODE;
#else
    params->dsi.mode   = SYNC_PULSE_VDO_MODE;
#endif

    // DSI
    /* Command mode setting */
    params->dsi.LANE_NUM                = LCM_FOUR_LANE;
    //The following defined the fomat for data coming from LCD engine.
    params->dsi.data_format.color_order = LCM_COLOR_ORDER_RGB;
    params->dsi.data_format.trans_seq   = LCM_DSI_TRANS_SEQ_MSB_FIRST;
    params->dsi.data_format.padding     = LCM_DSI_PADDING_ON_LSB;
    params->dsi.data_format.format      = LCM_DSI_FORMAT_RGB888;
    params->physical_width              = LCM_PHYSICAL_WIDTH/1000;
    params->physical_height             = LCM_PHYSICAL_HEIGHT/1000;

    // Video mode setting
    params->dsi.PS=LCM_PACKED_PS_24BIT_RGB888;

    params->dsi.vertical_sync_active                = 4;
    params->dsi.vertical_backporch              = 32;
    params->dsi.vertical_frontporch             = 150;
    params->dsi.vertical_active_line                = FRAME_HEIGHT;

    params->dsi.horizontal_sync_active              = 4;
    params->dsi.horizontal_backporch                = 96;
    params->dsi.horizontal_frontporch               = 96;
    params->dsi.horizontal_active_pixel         = FRAME_WIDTH;
    params->dsi.compatibility_for_nvk = 0;
    params->dsi.ssc_disable=1;
 // params->dsi.ssc_range=2;
    params->dsi.PLL_CLOCK                = 302;
#ifndef BUILD_LK	
    params->dsi.esd_check_enable = 1; 
    params->dsi.customization_esd_check_enable = 1;//0:te esd check 1:read register
    params->dsi.lcm_esd_check_table[0].cmd = 0x0A;
    params->dsi.lcm_esd_check_table[0].count = 1;
    params->dsi.lcm_esd_check_table[0].para_list[0] = 0x9C;
#endif /*BUILD_LK*/

}



#ifdef BUILD_LK
static int gpio_bl_enp   = (168 | 0x80000000);
static int gpio_bl_enn   = (164 | 0x80000000);
static struct mt_i2c_t LCD_i2c;

static kal_uint32 lcd_write_byte(kal_uint8 addr, kal_uint8 value)
{
    kal_uint32 ret_code = I2C_OK;
    kal_uint8 write_data[2];
    kal_uint16 len;

    write_data[0]= addr;
    write_data[1] = value;

    LCD_i2c.id = I2C0;

    LCD_i2c.addr = (0x3e);
    LCD_i2c.mode = ST_MODE;
    LCD_i2c.speed = 100;
    len = 2;

    ret_code = i2c_write(&LCD_i2c, write_data, len);

    return ret_code;
}
#endif

static void lcm_init(void)
{
    LCM_DBG();
#ifdef BUILD_LK
    mt_set_gpio_mode(gpio_bl_enp,GPIO_MODE_00);
    mt_set_gpio_dir(gpio_bl_enp,GPIO_DIR_OUT);
    mt_set_gpio_mode(gpio_bl_enn,GPIO_MODE_00);
    mt_set_gpio_dir(gpio_bl_enn,GPIO_DIR_OUT);
    mt_set_gpio_out(gpio_bl_enp,GPIO_OUT_ONE);
    MDELAY(1);
    lcd_write_byte(0,0x12);
    MDELAY(1);
    lcd_write_byte(1,0x12);
    MDELAY(1);
    mt_set_gpio_out(gpio_bl_enn,GPIO_OUT_ONE);
#else //Kernel driver
    lcm_enp(1);
    MDELAY(3);
    _lcm_i2c_write_bytes(0,0x12);//5.8
    MDELAY(3);
    _lcm_i2c_write_bytes(1,0x12);
    MDELAY(3);
    lcm_enn(1);
#endif
#ifdef GPIO_LCM_PWR
    SET_PWR_PIN(0);
    MDELAY(20);
    SET_PWR_PIN(1);
    MDELAY(150);
#endif
    SET_RESET_PIN(1);
    MDELAY(5);
    SET_RESET_PIN(0);
    MDELAY(10);
    SET_RESET_PIN(1);
    MDELAY(100);
    LCM_DBG("debug,lcm reset end \n");
    lcm_initialization_setting[21].para_list[0] = kernel_F6_real;
    push_table(lcm_initialization_setting, sizeof(lcm_initialization_setting) / sizeof(struct LCM_setting_table), 1);
    LCM_DBG("debug,lcm init end \n");
}


static void lcm_suspend(void)
{	
    LCM_DBG("lcm_suspend enter");
#ifndef BUILD_LK
    LCM_DBG("geroge suspend bEnTGesture_icnl9911c_tp  = %d\n",bEnTGesture_icnl9911c_tp);
    if(!bEnTGesture_icnl9911c_tp)
    {
    	// 不开手势功能流程
    	push_table(lcm_deep_sleep_mode_in_setting, sizeof(lcm_deep_sleep_mode_in_setting) / sizeof(struct LCM_setting_table), 1);

    	//SET_RESET_PIN(0);
    	MDELAY(10); // 1ms
    	lcm_enn(0);
    	MDELAY(5);
    	lcm_enp(0);
    	MDELAY(5);
    	//SET_RESET_PIN(1);
    	MDELAY(50);
	}else{
    	//开手势唤醒功能流程
       push_table(lcm_deep_sleep_mode_in_setting, sizeof(lcm_deep_sleep_mode_in_setting) / sizeof(struct LCM_setting_table), 1);
}
#endif
}



static unsigned char char1Tonum(unsigned char ch)
{
    if((ch>='0')&&(ch<='9'))
        return ch - '0';
    else if ((ch>='a')&&(ch<='f'))
        return ch - 'a' + 10;
    else if ((ch>='A')&&(ch<='F'))
        return ch - 'A' + 10;
    else
     return 0xff;
}

//\u7b80\u5355\u7684\u628a\u5b57\u7b26\u4e32\u8f6c\u4e3a\u6570\u5b57
static unsigned char char2Tonum(unsigned char hch, unsigned char lch)
{
    return ((char1Tonum(hch) << 4) | char1Tonum(lch));
}

static void kernel_F6_reg_update(void)
{
	r = strstr(saved_command_line,"androidboot.Temp_F6=0x");
	snprintf(kernel_F6_buf, 3, "%s",(r+22));
	kernel_F6_real = char2Tonum(kernel_F6_buf[0], kernel_F6_buf[1]);
	printk("kernel_F6_reg_update = %d\n",kernel_F6_real);
	lcm_initialization_setting[21].para_list[0] = kernel_F6_real;
}



static void lcm_resume(void)
{
	
#ifndef BUILD_LK
    LCM_DBG("geroge resume bEnTGesture_icnl9911c_tp  = %d\n",bEnTGesture_icnl9911c_tp);
    
    if(!bEnTGesture_icnl9911c_tp)
    {
    	lcm_enp(1);
    	MDELAY(1);
    	_lcm_i2c_write_bytes(0,0x12);
    	MDELAY(5);
    	_lcm_i2c_write_bytes(1,0x12);
    	MDELAY(1);
    	lcm_enn(1);
    }
#endif
    MDELAY(10);
    SET_RESET_PIN(0);
    MDELAY(5);
    SET_RESET_PIN(1);
    MDELAY(50);
    kernel_F6_reg_update();
    push_table(lcm_initialization_setting, sizeof(lcm_initialization_setting) / sizeof(struct LCM_setting_table), 1);
    LCM_DBG();
	
}


static unsigned int lcm_compare_id(void)
{
    return 0;
}

struct LCM_DRIVER icnl9911c_v690_hdplus_dsi_vdo_hf_lcm_drv =
{
    .name           = "icnl9911c_v690_hdplus_dsi_vdo_hf",
    .set_util_funcs = lcm_set_util_funcs,
    .get_params     = lcm_get_params,
    .init           = lcm_init,
    .suspend        = lcm_suspend,
    .resume         = lcm_resume,
    .compare_id    = lcm_compare_id,
};
