#ifndef _AW86014_H_
#define _AW86014_H_

#define AF_DRVNAME		"AW86014AF_DRV"

/* Debug Info Control */
#define AW_AF_DEBUG
#ifdef AW_AF_DEBUG
#define AW_LOG_INF(format, args...) \
	pr_err(AF_DRVNAME " [%s] " format, __func__, ##args)
#else
#define AW_LOG_INF(format, args...)
#endif
#define AW_LOG_ERR(format, args...) \
	pr_err(AF_DRVNAME " [%s] " format, __func__, ##args)

/* Advance Mode */
#define AW_ADVANCE_VRC
#define AW_ADVANCE_VRC_MODE	(0x88) /* VRC3.5 */

#define AW_PDMODE_EN		(0x01)

/* Configure parameters according to different motors */
#define AW86014_ADVANCE_DIV	(0x00)
#define AW86014_ADVANCE_VRCT	(0x00)
/* Configure parameters according to different motors */
#define AW86017_ADVANCE_DIV	(0x00)
#define AW86017_ADVANCE_VRCT	(0x00)

/* Register */
#define AW_REG_CHIP_ID		(0x00)
#define AW_REG_CONTROL		(0x02)
#define AW_REG_VCM_MSB		(0x03)
#define AW_REG_VCM_LSB		(0x04)
#define AW_REG_MODE		(0x06)
#define AW_REG_DIV		(0x07)
#define AW_REG_VRCT		(0x08)
/* Init Position */
#define AW_INIT_POS_H		(0x00)
#define AW_INIT_POS_L		(0x00)
/* Chip id  */
#define CHIPID_AW86014		(0x41)
#define CHIPID_AW86017		(0x03)

#endif
