/* SPDX-License-Identifier: GPL-2.0 */
/*
 * Copyright (c) 2019 MediaTek Inc.
 */


/****************************************************************************
 *
 * Filename:
 * ---------
 *	   s5k3m3_setting_v1.h
 *
 * Project:
 * --------
 *	   ALPS
 *
 * Description:
 * ------------
 *	   CMOS sensor setting file
 *
 * Setting Release Date:
 * ------------
 *	   2016.09.01
 *
 ****************************************************************************/
#ifndef _s5k3m3MIPI_SETTING_V1_H_
#define _s5k3m3MIPI_SETTING_V1_H_


static void sensor_init_v1(void)
{
	write_cmos_sensor(0X6028, 0X4000);
	write_cmos_sensor(0X6010, 0X0001);
	mdelay(3);
	write_cmos_sensor(0X6214, 0X7971);
	write_cmos_sensor(0X6218, 0X7150);
#ifdef VCPDAF
	write_cmos_sensor(0x6028, 0x2000);
	write_cmos_sensor(0x602A, 0x303C);
	write_cmos_sensor(0x6F12, 0x0000);
	write_cmos_sensor(0x6F12, 0x0000);
	write_cmos_sensor(0x6F12, 0x0449);
	write_cmos_sensor(0x6F12, 0x0348);
	write_cmos_sensor(0x6F12, 0x0860);
	write_cmos_sensor(0x6F12, 0xCA8D);
	write_cmos_sensor(0x6F12, 0x101A);
	write_cmos_sensor(0x6F12, 0x8880);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0xA6BE);
	write_cmos_sensor(0x6F12, 0x2000);
	write_cmos_sensor(0x6F12, 0x401C);
	write_cmos_sensor(0x6F12, 0x2000);
	write_cmos_sensor(0x6F12, 0x1E80);
	write_cmos_sensor(0x6F12, 0x0000);
	write_cmos_sensor(0x6F12, 0x0000);
	write_cmos_sensor(0x6F12, 0x0000);
	write_cmos_sensor(0x6F12, 0x0000);
	write_cmos_sensor(0x6F12, 0x70B5);
	write_cmos_sensor(0x6F12, 0xFF4C);
	write_cmos_sensor(0x6F12, 0x0E46);
	write_cmos_sensor(0x6F12, 0xA4F8);
	write_cmos_sensor(0x6F12, 0x0001);
	write_cmos_sensor(0x6F12, 0xFE4D);
	write_cmos_sensor(0x6F12, 0x15F8);
	write_cmos_sensor(0x6F12, 0x940F);
	write_cmos_sensor(0x6F12, 0xA4F8);
	write_cmos_sensor(0x6F12, 0x0601);
	write_cmos_sensor(0x6F12, 0x6878);
	write_cmos_sensor(0x6F12, 0xA4F8);
	write_cmos_sensor(0x6F12, 0x0801);
	write_cmos_sensor(0x6F12, 0x1046);
	write_cmos_sensor(0x6F12, 0x04F5);
	write_cmos_sensor(0x6F12, 0xE874);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0x46FF);
	write_cmos_sensor(0x6F12, 0x3046);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0x48FF);
	write_cmos_sensor(0x6F12, 0xB5F8);
	write_cmos_sensor(0x6F12, 0x9A01);
	write_cmos_sensor(0x6F12, 0x6086);
	write_cmos_sensor(0x6F12, 0xB5F8);
	write_cmos_sensor(0x6F12, 0x9E01);
	write_cmos_sensor(0x6F12, 0xE086);
	write_cmos_sensor(0x6F12, 0xB5F8);
	write_cmos_sensor(0x6F12, 0xA001);
	write_cmos_sensor(0x6F12, 0x2087);
	write_cmos_sensor(0x6F12, 0xB5F8);
	write_cmos_sensor(0x6F12, 0xA601);
	write_cmos_sensor(0x6F12, 0xE087);
	write_cmos_sensor(0x6F12, 0x70BD);
	write_cmos_sensor(0x6F12, 0x2DE9);
	write_cmos_sensor(0x6F12, 0xF05F);
	write_cmos_sensor(0x6F12, 0xEF4A);
	write_cmos_sensor(0x6F12, 0xF049);
	write_cmos_sensor(0x6F12, 0xED4C);
	write_cmos_sensor(0x6F12, 0x0646);
	write_cmos_sensor(0x6F12, 0x92F8);
	write_cmos_sensor(0x6F12, 0xEC30);
	write_cmos_sensor(0x6F12, 0x0F89);
	write_cmos_sensor(0x6F12, 0x94F8);
	write_cmos_sensor(0x6F12, 0xBE00);
	write_cmos_sensor(0x6F12, 0x4FF4);
	write_cmos_sensor(0x6F12, 0x8079);
	write_cmos_sensor(0x6F12, 0x13B1);
	write_cmos_sensor(0x6F12, 0xA8B9);
	write_cmos_sensor(0x6F12, 0x4F46);
	write_cmos_sensor(0x6F12, 0x13E0);
	write_cmos_sensor(0x6F12, 0xEA4B);
	write_cmos_sensor(0x6F12, 0x0968);
	write_cmos_sensor(0x6F12, 0x92F8);
	write_cmos_sensor(0x6F12, 0xED20);
	write_cmos_sensor(0x6F12, 0x1B6D);
	write_cmos_sensor(0x6F12, 0xB1FB);
	write_cmos_sensor(0x6F12, 0xF3F1);
	write_cmos_sensor(0x6F12, 0x7943);
	write_cmos_sensor(0x6F12, 0xD140);
	write_cmos_sensor(0x6F12, 0x8BB2);
	write_cmos_sensor(0x6F12, 0x30B1);
	write_cmos_sensor(0x6F12, 0x0022);
	write_cmos_sensor(0x6F12, 0x4FF4);
	write_cmos_sensor(0x6F12, 0x8051);
	write_cmos_sensor(0x6F12, 0x1846);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0x1EFF);
	write_cmos_sensor(0x6F12, 0x00E0);
	write_cmos_sensor(0x6F12, 0x4846);
	write_cmos_sensor(0x6F12, 0x87B2);
	write_cmos_sensor(0x6F12, 0x3088);
	write_cmos_sensor(0x6F12, 0x18B1);
	write_cmos_sensor(0x6F12, 0x0121);
	write_cmos_sensor(0x6F12, 0xDF48);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0x1AFF);
	write_cmos_sensor(0x6F12, 0x0021);
	write_cmos_sensor(0x6F12, 0xDE48);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0x16FF);
	write_cmos_sensor(0x6F12, 0xDFF8);
	write_cmos_sensor(0x6F12, 0x78A3);
	write_cmos_sensor(0x6F12, 0x0025);
	write_cmos_sensor(0x6F12, 0xA046);
	write_cmos_sensor(0x6F12, 0x4FF0);
	write_cmos_sensor(0x6F12, 0x010B);
	write_cmos_sensor(0x6F12, 0x3088);
	write_cmos_sensor(0x6F12, 0x70B1);
	write_cmos_sensor(0x6F12, 0x7088);
	write_cmos_sensor(0x6F12, 0x38B1);
	write_cmos_sensor(0x6F12, 0xF089);
	write_cmos_sensor(0x6F12, 0x06E0);
	write_cmos_sensor(0x6F12, 0x2A46);
	write_cmos_sensor(0x6F12, 0xD549);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0x0BFF);
	write_cmos_sensor(0x6F12, 0x0446);
	write_cmos_sensor(0x6F12, 0x05E0);
	write_cmos_sensor(0x6F12, 0xB089);
	write_cmos_sensor(0x6F12, 0x0028);
	write_cmos_sensor(0x6F12, 0xF6D1);
	write_cmos_sensor(0x6F12, 0x3846);
	write_cmos_sensor(0x6F12, 0xF4E7);
	write_cmos_sensor(0x6F12, 0x4C46);
	write_cmos_sensor(0x6F12, 0x98F8);
	write_cmos_sensor(0x6F12, 0xBE00);
	write_cmos_sensor(0x6F12, 0x28B1);
	write_cmos_sensor(0x6F12, 0x2A46);
	write_cmos_sensor(0x6F12, 0xCF49);
	write_cmos_sensor(0x6F12, 0x3846);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0xFBFE);
	write_cmos_sensor(0x6F12, 0x00E0);
	write_cmos_sensor(0x6F12, 0x4846);
	write_cmos_sensor(0x6F12, 0xAAF8);
	write_cmos_sensor(0x6F12, 0x5802);
	write_cmos_sensor(0x6F12, 0x4443);
	write_cmos_sensor(0x6F12, 0x98F8);
	write_cmos_sensor(0x6F12, 0x2B02);
	write_cmos_sensor(0x6F12, 0x98F8);
	write_cmos_sensor(0x6F12, 0x2922);
	write_cmos_sensor(0x6F12, 0xC440);
	write_cmos_sensor(0x6F12, 0x0244);
	write_cmos_sensor(0x6F12, 0x0BFA);
	write_cmos_sensor(0x6F12, 0x02F0);
	write_cmos_sensor(0x6F12, 0x421E);
	write_cmos_sensor(0x6F12, 0xA242);
	write_cmos_sensor(0x6F12, 0x01DA);
	write_cmos_sensor(0x6F12, 0x1346);
	write_cmos_sensor(0x6F12, 0x00E0);
	write_cmos_sensor(0x6F12, 0x2346);
	write_cmos_sensor(0x6F12, 0x002B);
	write_cmos_sensor(0x6F12, 0x01DA);
	write_cmos_sensor(0x6F12, 0x0024);
	write_cmos_sensor(0x6F12, 0x02E0);
	write_cmos_sensor(0x6F12, 0xA242);
	write_cmos_sensor(0x6F12, 0x00DA);
	write_cmos_sensor(0x6F12, 0x1446);
	write_cmos_sensor(0x6F12, 0x0AEB);
	write_cmos_sensor(0x6F12, 0x4500);
	write_cmos_sensor(0x6F12, 0x6D1C);
	write_cmos_sensor(0x6F12, 0xA0F8);
	write_cmos_sensor(0x6F12, 0x5A42);
	write_cmos_sensor(0x6F12, 0x042D);
	write_cmos_sensor(0x6F12, 0xC4DB);
	write_cmos_sensor(0x6F12, 0xBDE8);
	write_cmos_sensor(0x6F12, 0xF09F);
	write_cmos_sensor(0x6F12, 0xB94A);
	write_cmos_sensor(0x6F12, 0x92F8);
	write_cmos_sensor(0x6F12, 0xB330);
	write_cmos_sensor(0x6F12, 0x53B1);
	write_cmos_sensor(0x6F12, 0x92F8);
	write_cmos_sensor(0x6F12, 0xFD20);
	write_cmos_sensor(0x6F12, 0x0420);
	write_cmos_sensor(0x6F12, 0x52B1);
	write_cmos_sensor(0x6F12, 0xB94A);
	write_cmos_sensor(0x6F12, 0x92F8);
	write_cmos_sensor(0x6F12, 0x3221);
	write_cmos_sensor(0x6F12, 0x012A);
	write_cmos_sensor(0x6F12, 0x05D1);
	write_cmos_sensor(0x6F12, 0x0220);
	write_cmos_sensor(0x6F12, 0x03E0);
	write_cmos_sensor(0x6F12, 0x5379);
	write_cmos_sensor(0x6F12, 0x2BB9);
	write_cmos_sensor(0x6F12, 0x20B1);
	write_cmos_sensor(0x6F12, 0x0020);
	write_cmos_sensor(0x6F12, 0x8842);
	write_cmos_sensor(0x6F12, 0x00D8);
	write_cmos_sensor(0x6F12, 0x0846);
	write_cmos_sensor(0x6F12, 0x7047);
	write_cmos_sensor(0x6F12, 0x1078);
	write_cmos_sensor(0x6F12, 0xF9E7);
	write_cmos_sensor(0x6F12, 0xFEB5);
	write_cmos_sensor(0x6F12, 0x0646);
	write_cmos_sensor(0x6F12, 0xB148);
	write_cmos_sensor(0x6F12, 0x0022);
	write_cmos_sensor(0x6F12, 0xC068);
	write_cmos_sensor(0x6F12, 0x84B2);
	write_cmos_sensor(0x6F12, 0x050C);
	write_cmos_sensor(0x6F12, 0x2146);
	write_cmos_sensor(0x6F12, 0x2846);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0xB9FE);
	write_cmos_sensor(0x6F12, 0x3046);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0xBBFE);
	write_cmos_sensor(0x6F12, 0xA64E);
	write_cmos_sensor(0x6F12, 0x0020);
	write_cmos_sensor(0x6F12, 0x8DF8);
	write_cmos_sensor(0x6F12, 0x0000);
	write_cmos_sensor(0x6F12, 0x96F8);
	write_cmos_sensor(0x6F12, 0xFD00);
	write_cmos_sensor(0x6F12, 0x8DF8);
	write_cmos_sensor(0x6F12, 0x0100);
	write_cmos_sensor(0x6F12, 0x96F8);
	write_cmos_sensor(0x6F12, 0xB310);
	write_cmos_sensor(0x6F12, 0xA54F);
	write_cmos_sensor(0x6F12, 0x19B1);
	write_cmos_sensor(0x6F12, 0x97F8);
	write_cmos_sensor(0x6F12, 0x3221);
	write_cmos_sensor(0x6F12, 0x012A);
	write_cmos_sensor(0x6F12, 0x0FD0);
	write_cmos_sensor(0x6F12, 0x0023);
	write_cmos_sensor(0x6F12, 0x0122);
	write_cmos_sensor(0x6F12, 0x0292);
	write_cmos_sensor(0x6F12, 0x0192);
	write_cmos_sensor(0x6F12, 0x21B1);
	write_cmos_sensor(0x6F12, 0x18B1);
	write_cmos_sensor(0x6F12, 0x97F8);
	write_cmos_sensor(0x6F12, 0x3201);
	write_cmos_sensor(0x6F12, 0x0128);
	write_cmos_sensor(0x6F12, 0x07D0);
	write_cmos_sensor(0x6F12, 0x96F8);
	write_cmos_sensor(0x6F12, 0x6801);
	write_cmos_sensor(0x6F12, 0x4208);
	write_cmos_sensor(0x6F12, 0x33B1);
	write_cmos_sensor(0x6F12, 0x0020);
	write_cmos_sensor(0x6F12, 0x06E0);
	write_cmos_sensor(0x6F12, 0x0123);
	write_cmos_sensor(0x6F12, 0xEEE7);
	write_cmos_sensor(0x6F12, 0x96F8);
	write_cmos_sensor(0x6F12, 0x6821);
	write_cmos_sensor(0x6F12, 0xF7E7);
	write_cmos_sensor(0x6F12, 0x96F8);
	write_cmos_sensor(0x6F12, 0xA400);
	write_cmos_sensor(0x6F12, 0x4100);
	write_cmos_sensor(0x6F12, 0x002A);
	write_cmos_sensor(0x6F12, 0x02D0);
	write_cmos_sensor(0x6F12, 0x4FF0);
	write_cmos_sensor(0x6F12, 0x0200);
	write_cmos_sensor(0x6F12, 0x01E0);
	write_cmos_sensor(0x6F12, 0x4FF0);
	write_cmos_sensor(0x6F12, 0x0000);
	write_cmos_sensor(0x6F12, 0x41EA);
	write_cmos_sensor(0x6F12, 0x4020);
	write_cmos_sensor(0x6F12, 0x9349);
	write_cmos_sensor(0x6F12, 0xA1F8);
	write_cmos_sensor(0x6F12, 0x5201);
	write_cmos_sensor(0x6F12, 0x07D0);
	write_cmos_sensor(0x6F12, 0x9248);
	write_cmos_sensor(0x6F12, 0x6B46);
	write_cmos_sensor(0x6F12, 0xB0F8);
	write_cmos_sensor(0x6F12, 0x4810);
	write_cmos_sensor(0x6F12, 0x4FF2);
	write_cmos_sensor(0x6F12, 0x5010);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0x83FE);
	write_cmos_sensor(0x6F12, 0x0122);
	write_cmos_sensor(0x6F12, 0x2146);
	write_cmos_sensor(0x6F12, 0x2846);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0x74FE);
	write_cmos_sensor(0x6F12, 0xFEBD);
	write_cmos_sensor(0x6F12, 0x2DE9);
	write_cmos_sensor(0x6F12, 0xF047);
	write_cmos_sensor(0x6F12, 0x0546);
	write_cmos_sensor(0x6F12, 0x8848);
	write_cmos_sensor(0x6F12, 0x9046);
	write_cmos_sensor(0x6F12, 0x8946);
	write_cmos_sensor(0x6F12, 0x8068);
	write_cmos_sensor(0x6F12, 0x1C46);
	write_cmos_sensor(0x6F12, 0x86B2);
	write_cmos_sensor(0x6F12, 0x070C);
	write_cmos_sensor(0x6F12, 0x0022);
	write_cmos_sensor(0x6F12, 0x3146);
	write_cmos_sensor(0x6F12, 0x3846);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0x64FE);
	write_cmos_sensor(0x6F12, 0x2346);
	write_cmos_sensor(0x6F12, 0x4246);
	write_cmos_sensor(0x6F12, 0x4946);
	write_cmos_sensor(0x6F12, 0x2846);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0x68FE);
	write_cmos_sensor(0x6F12, 0x7A48);
	write_cmos_sensor(0x6F12, 0x90F8);
	write_cmos_sensor(0x6F12, 0xB310);
	write_cmos_sensor(0x6F12, 0xD1B1);
	write_cmos_sensor(0x6F12, 0x90F8);
	write_cmos_sensor(0x6F12, 0xFD00);
	write_cmos_sensor(0x6F12, 0xB8B1);
	write_cmos_sensor(0x6F12, 0x0020);
	write_cmos_sensor(0x6F12, 0xA5F5);
	write_cmos_sensor(0x6F12, 0x7141);
	write_cmos_sensor(0x6F12, 0x05F1);
	write_cmos_sensor(0x6F12, 0x8044);
	write_cmos_sensor(0x6F12, 0x9039);
	write_cmos_sensor(0x6F12, 0x02D0);
	write_cmos_sensor(0x6F12, 0x4031);
	write_cmos_sensor(0x6F12, 0x02D0);
	write_cmos_sensor(0x6F12, 0x0DE0);
	write_cmos_sensor(0x6F12, 0xA081);
	write_cmos_sensor(0x6F12, 0x0BE0);
	write_cmos_sensor(0x6F12, 0xA081);
	write_cmos_sensor(0x6F12, 0x7448);
	write_cmos_sensor(0x6F12, 0x90F8);
	write_cmos_sensor(0x6F12, 0x3201);
	write_cmos_sensor(0x6F12, 0x0128);
	write_cmos_sensor(0x6F12, 0x05D1);
	write_cmos_sensor(0x6F12, 0x0220);
	write_cmos_sensor(0x6F12, 0xA080);
	write_cmos_sensor(0x6F12, 0x2D20);
	write_cmos_sensor(0x6F12, 0x2081);
	write_cmos_sensor(0x6F12, 0x2E20);
	write_cmos_sensor(0x6F12, 0x6081);
	write_cmos_sensor(0x6F12, 0x3146);
	write_cmos_sensor(0x6F12, 0x3846);
	write_cmos_sensor(0x6F12, 0xBDE8);
	write_cmos_sensor(0x6F12, 0xF047);
	write_cmos_sensor(0x6F12, 0x0122);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0x38BE);
	write_cmos_sensor(0x6F12, 0xF0B5);
	write_cmos_sensor(0x6F12, 0x30F8);
	write_cmos_sensor(0x6F12, 0x4A3F);
	write_cmos_sensor(0x6F12, 0x4FF0);
	write_cmos_sensor(0x6F12, 0x000C);
	write_cmos_sensor(0x6F12, 0xC488);
	write_cmos_sensor(0x6F12, 0x6746);
	write_cmos_sensor(0x6F12, 0x1B1B);
	write_cmos_sensor(0x6F12, 0x0489);
	write_cmos_sensor(0x6F12, 0x30F8);
	write_cmos_sensor(0x6F12, 0x0A0C);
	write_cmos_sensor(0x6F12, 0x1B1B);
	write_cmos_sensor(0x6F12, 0x9DB2);
	write_cmos_sensor(0x6F12, 0x32F8);
	write_cmos_sensor(0x6F12, 0x5A3F);
	write_cmos_sensor(0x6F12, 0x8C78);
	write_cmos_sensor(0x6F12, 0x117C);
	write_cmos_sensor(0x6F12, 0x92F8);
	write_cmos_sensor(0x6F12, 0x58E0);
	write_cmos_sensor(0x6F12, 0x04FB);
	write_cmos_sensor(0x6F12, 0x1133);
	write_cmos_sensor(0x6F12, 0x9BB2);
	write_cmos_sensor(0x6F12, 0x9489);
	write_cmos_sensor(0x6F12, 0xA0EB);
	write_cmos_sensor(0x6F12, 0x0E00);
	write_cmos_sensor(0x6F12, 0x04FB);
	write_cmos_sensor(0x6F12, 0x0134);
	write_cmos_sensor(0x6F12, 0x12F8);
	write_cmos_sensor(0x6F12, 0x3F6C);
	write_cmos_sensor(0x6F12, 0x80B2);
	write_cmos_sensor(0x6F12, 0x00FB);
	write_cmos_sensor(0x6F12, 0x013E);
	write_cmos_sensor(0x6F12, 0xA41B);
	write_cmos_sensor(0x6F12, 0xD27C);
	write_cmos_sensor(0x6F12, 0xA4B2);
	write_cmos_sensor(0x6F12, 0x1FFA);
	write_cmos_sensor(0x6F12, 0x8EFE);
	write_cmos_sensor(0x6F12, 0x22B1);
	write_cmos_sensor(0x6F12, 0x3444);
	write_cmos_sensor(0x6F12, 0x00FB);
	write_cmos_sensor(0x6F12, 0x1144);
	write_cmos_sensor(0x6F12, 0x641E);
	write_cmos_sensor(0x6F12, 0x07E0);
	write_cmos_sensor(0x6F12, 0x20B1);
	write_cmos_sensor(0x6F12, 0xAEF1);
	write_cmos_sensor(0x6F12, 0x0104);
	write_cmos_sensor(0x6F12, 0x05FB);
	write_cmos_sensor(0x6F12, 0x0144);
	write_cmos_sensor(0x6F12, 0x01E0);
	write_cmos_sensor(0x6F12, 0x641E);
	write_cmos_sensor(0x6F12, 0x3444);
	write_cmos_sensor(0x6F12, 0xA4B2);
	write_cmos_sensor(0x6F12, 0x2AB1);
	write_cmos_sensor(0x6F12, 0x10B1);
	write_cmos_sensor(0x6F12, 0x05FB);
	write_cmos_sensor(0x6F12, 0x1143);
	write_cmos_sensor(0x6F12, 0x5B1C);
	write_cmos_sensor(0x6F12, 0x1FFA);
	write_cmos_sensor(0x6F12, 0x83FE);
	write_cmos_sensor(0x6F12, 0xBEF1);
	write_cmos_sensor(0x6F12, 0x700F);
	write_cmos_sensor(0x6F12, 0x02D2);
	write_cmos_sensor(0x6F12, 0x4FF0);
	write_cmos_sensor(0x6F12, 0x010E);
	write_cmos_sensor(0x6F12, 0x01E0);
	write_cmos_sensor(0x6F12, 0xAEF1);
	write_cmos_sensor(0x6F12, 0x6F0E);
	write_cmos_sensor(0x6F12, 0x4FF4);
	write_cmos_sensor(0x6F12, 0x4061);
	write_cmos_sensor(0x6F12, 0x6F3C);
	write_cmos_sensor(0x6F12, 0x1FFA);
	write_cmos_sensor(0x6F12, 0x8EF0);
	write_cmos_sensor(0x6F12, 0x8C42);
	write_cmos_sensor(0x6F12, 0x00DD);
	write_cmos_sensor(0x6F12, 0x0C46);
	write_cmos_sensor(0x6F12, 0x211A);
	write_cmos_sensor(0x6F12, 0x491C);
	write_cmos_sensor(0x6F12, 0x8BB2);
	write_cmos_sensor(0x6F12, 0x401E);
	write_cmos_sensor(0x6F12, 0xC117);
	write_cmos_sensor(0x6F12, 0x00EB);
	write_cmos_sensor(0x6F12, 0x9161);
	write_cmos_sensor(0x6F12, 0x21F0);
	write_cmos_sensor(0x6F12, 0x3F01);
	write_cmos_sensor(0x6F12, 0x401A);
	write_cmos_sensor(0x6F12, 0xC117);
	write_cmos_sensor(0x6F12, 0x00EB);
	write_cmos_sensor(0x6F12, 0x1171);
	write_cmos_sensor(0x6F12, 0x0911);
	write_cmos_sensor(0x6F12, 0xA0EB);
	write_cmos_sensor(0x6F12, 0x0110);
	write_cmos_sensor(0x6F12, 0xC0F1);
	write_cmos_sensor(0x6F12, 0x1000);
	write_cmos_sensor(0x6F12, 0x81B2);
	write_cmos_sensor(0x6F12, 0x04F0);
	write_cmos_sensor(0x6F12, 0x0F00);
	write_cmos_sensor(0x6F12, 0xCC06);
	write_cmos_sensor(0x6F12, 0x00D5);
	write_cmos_sensor(0x6F12, 0x0021);
	write_cmos_sensor(0x6F12, 0xC406);
	write_cmos_sensor(0x6F12, 0x00D5);
	write_cmos_sensor(0x6F12, 0x0020);
	write_cmos_sensor(0x6F12, 0x0C18);
	write_cmos_sensor(0x6F12, 0x1B1B);
	write_cmos_sensor(0x6F12, 0x9BB2);
	write_cmos_sensor(0x6F12, 0x89B1);
	write_cmos_sensor(0x6F12, 0xB2B1);
	write_cmos_sensor(0x6F12, 0x0829);
	write_cmos_sensor(0x6F12, 0x02D9);
	write_cmos_sensor(0x6F12, 0x4FF0);
	write_cmos_sensor(0x6F12, 0x040C);
	write_cmos_sensor(0x6F12, 0x0BE0);
	write_cmos_sensor(0x6F12, 0x0529);
	write_cmos_sensor(0x6F12, 0x02D9);
	write_cmos_sensor(0x6F12, 0x4FF0);
	write_cmos_sensor(0x6F12, 0x030C);
	write_cmos_sensor(0x6F12, 0x06E0);
	write_cmos_sensor(0x6F12, 0x0429);
	write_cmos_sensor(0x6F12, 0x02D9);
	write_cmos_sensor(0x6F12, 0x4FF0);
	write_cmos_sensor(0x6F12, 0x020C);
	write_cmos_sensor(0x6F12, 0x01E0);
	write_cmos_sensor(0x6F12, 0x4FF0);
	write_cmos_sensor(0x6F12, 0x010C);
	write_cmos_sensor(0x6F12, 0xB0B1);
	write_cmos_sensor(0x6F12, 0x72B1);
	write_cmos_sensor(0x6F12, 0x0828);
	write_cmos_sensor(0x6F12, 0x06D2);
	write_cmos_sensor(0x6F12, 0x0027);
	write_cmos_sensor(0x6F12, 0x11E0);
	write_cmos_sensor(0x6F12, 0x0829);
	write_cmos_sensor(0x6F12, 0xE8D8);
	write_cmos_sensor(0x6F12, 0x0429);
	write_cmos_sensor(0x6F12, 0xF3D9);
	write_cmos_sensor(0x6F12, 0xEAE7);
	write_cmos_sensor(0x6F12, 0x0C28);
	write_cmos_sensor(0x6F12, 0x01D2);
	write_cmos_sensor(0x6F12, 0x0127);
	write_cmos_sensor(0x6F12, 0x08E0);
	write_cmos_sensor(0x6F12, 0x0327);
	write_cmos_sensor(0x6F12, 0x06E0);
	write_cmos_sensor(0x6F12, 0x0828);
	write_cmos_sensor(0x6F12, 0xF0D3);
	write_cmos_sensor(0x6F12, 0x0C28);
	write_cmos_sensor(0x6F12, 0xF7D3);
	write_cmos_sensor(0x6F12, 0x0D28);
	write_cmos_sensor(0x6F12, 0xF7D2);
	write_cmos_sensor(0x6F12, 0x0227);
	write_cmos_sensor(0x6F12, 0x9809);
	write_cmos_sensor(0x6F12, 0x0001);
	write_cmos_sensor(0x6F12, 0xC3F3);
	write_cmos_sensor(0x6F12, 0x0111);
	write_cmos_sensor(0x6F12, 0x00EB);
	write_cmos_sensor(0x6F12, 0x8100);
	write_cmos_sensor(0x6F12, 0x6044);
	write_cmos_sensor(0x6F12, 0x3844);
	write_cmos_sensor(0x6F12, 0x80B2);
	write_cmos_sensor(0x6F12, 0xF0BD);
	write_cmos_sensor(0x6F12, 0x2DE9);
	write_cmos_sensor(0x6F12, 0xFF41);
	write_cmos_sensor(0x6F12, 0x8046);
	write_cmos_sensor(0x6F12, 0x1B48);
	write_cmos_sensor(0x6F12, 0x1446);
	write_cmos_sensor(0x6F12, 0x0F46);
	write_cmos_sensor(0x6F12, 0x4069);
	write_cmos_sensor(0x6F12, 0x0022);
	write_cmos_sensor(0x6F12, 0x85B2);
	write_cmos_sensor(0x6F12, 0x060C);
	write_cmos_sensor(0x6F12, 0x2946);
	write_cmos_sensor(0x6F12, 0x3046);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0x8CFD);
	write_cmos_sensor(0x6F12, 0x2246);
	write_cmos_sensor(0x6F12, 0x3946);
	write_cmos_sensor(0x6F12, 0x4046);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0x96FD);
	write_cmos_sensor(0x6F12, 0x0C4A);
	write_cmos_sensor(0x6F12, 0x92F8);
	write_cmos_sensor(0x6F12, 0xCC00);
	write_cmos_sensor(0x6F12, 0x58B3);
	write_cmos_sensor(0x6F12, 0x97F8);
	write_cmos_sensor(0x6F12, 0x2000);
	write_cmos_sensor(0x6F12, 0x40B3);
	write_cmos_sensor(0x6F12, 0x4FF4);
	write_cmos_sensor(0x6F12, 0x8050);
	write_cmos_sensor(0x6F12, 0x0090);
	write_cmos_sensor(0x6F12, 0x1148);
	write_cmos_sensor(0x6F12, 0xB0F8);
	write_cmos_sensor(0x6F12, 0xBA13);
	write_cmos_sensor(0x6F12, 0xB1FA);
	write_cmos_sensor(0x6F12, 0x81F0);
	write_cmos_sensor(0x6F12, 0xC0F1);
	write_cmos_sensor(0x6F12, 0x1700);
	write_cmos_sensor(0x6F12, 0xC140);
	write_cmos_sensor(0x6F12, 0xC9B2);
	write_cmos_sensor(0x6F12, 0x02EB);
	write_cmos_sensor(0x6F12, 0x4000);
	write_cmos_sensor(0x6F12, 0x1AE0);
	write_cmos_sensor(0x6F12, 0x4000);
	write_cmos_sensor(0x6F12, 0xE000);
	write_cmos_sensor(0x6F12, 0x2000);
	write_cmos_sensor(0x6F12, 0x1350);
	write_cmos_sensor(0x6F12, 0x2000);
	write_cmos_sensor(0x6F12, 0x4A00);
	write_cmos_sensor(0x6F12, 0x2000);
	write_cmos_sensor(0x6F12, 0x2970);
	write_cmos_sensor(0x6F12, 0x2000);
	write_cmos_sensor(0x6F12, 0x1EB0);
	write_cmos_sensor(0x6F12, 0x2000);
	write_cmos_sensor(0x6F12, 0x1BAA);
	write_cmos_sensor(0x6F12, 0x2000);
	write_cmos_sensor(0x6F12, 0x1B58);
	write_cmos_sensor(0x6F12, 0x2000);
	write_cmos_sensor(0x6F12, 0x2530);
	write_cmos_sensor(0x6F12, 0x2000);
	write_cmos_sensor(0x6F12, 0x1CC0);
	write_cmos_sensor(0x6F12, 0x2000);
	write_cmos_sensor(0x6F12, 0x3FF0);
	write_cmos_sensor(0x6F12, 0x4000);
	write_cmos_sensor(0x6F12, 0xF000);
	write_cmos_sensor(0x6F12, 0x2000);
	write_cmos_sensor(0x6F12, 0x05C0);
	write_cmos_sensor(0x6F12, 0x2000);
	write_cmos_sensor(0x6F12, 0x2120);
	write_cmos_sensor(0x6F12, 0x26E0);
	write_cmos_sensor(0x6F12, 0xB0F8);
	write_cmos_sensor(0x6F12, 0xD030);
	write_cmos_sensor(0x6F12, 0x30F8);
	write_cmos_sensor(0x6F12, 0xCE2F);
	write_cmos_sensor(0x6F12, 0x9B1A);
	write_cmos_sensor(0x6F12, 0x4B43);
	write_cmos_sensor(0x6F12, 0x8033);
	write_cmos_sensor(0x6F12, 0x02EB);
	write_cmos_sensor(0x6F12, 0x2322);
	write_cmos_sensor(0x6F12, 0x0192);
	write_cmos_sensor(0x6F12, 0x8389);
	write_cmos_sensor(0x6F12, 0x4289);
	write_cmos_sensor(0x6F12, 0x9B1A);
	write_cmos_sensor(0x6F12, 0x4B43);
	write_cmos_sensor(0x6F12, 0x8033);
	write_cmos_sensor(0x6F12, 0x02EB);
	write_cmos_sensor(0x6F12, 0x2322);
	write_cmos_sensor(0x6F12, 0x0292);
	write_cmos_sensor(0x6F12, 0xC28A);
	write_cmos_sensor(0x6F12, 0x808A);
	write_cmos_sensor(0x6F12, 0x121A);
	write_cmos_sensor(0x6F12, 0x4A43);
	write_cmos_sensor(0x6F12, 0x8032);
	write_cmos_sensor(0x6F12, 0x00EB);
	write_cmos_sensor(0x6F12, 0x2220);
	write_cmos_sensor(0x6F12, 0x0023);
	write_cmos_sensor(0x6F12, 0x6946);
	write_cmos_sensor(0x6F12, 0x0390);
	write_cmos_sensor(0x6F12, 0x54F8);
	write_cmos_sensor(0x6F12, 0x2300);
	write_cmos_sensor(0x6F12, 0x51F8);
	write_cmos_sensor(0x6F12, 0x2320);
	write_cmos_sensor(0x6F12, 0x5043);
	write_cmos_sensor(0x6F12, 0x000B);
	write_cmos_sensor(0x6F12, 0x44F8);
	write_cmos_sensor(0x6F12, 0x2300);
	write_cmos_sensor(0x6F12, 0x5B1C);
	write_cmos_sensor(0x6F12, 0x042B);
	write_cmos_sensor(0x6F12, 0xF4D3);
	write_cmos_sensor(0x6F12, 0x0122);
	write_cmos_sensor(0x6F12, 0x2946);
	write_cmos_sensor(0x6F12, 0x3046);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0x2AFD);
	write_cmos_sensor(0x6F12, 0xBDE8);
	write_cmos_sensor(0x6F12, 0xFF81);
	write_cmos_sensor(0x6F12, 0x70B5);
	write_cmos_sensor(0x6F12, 0x0123);
	write_cmos_sensor(0x6F12, 0x11E0);
	write_cmos_sensor(0x6F12, 0x50F8);
	write_cmos_sensor(0x6F12, 0x2350);
	write_cmos_sensor(0x6F12, 0x5A1E);
	write_cmos_sensor(0x6F12, 0x03E0);
	write_cmos_sensor(0x6F12, 0x00EB);
	write_cmos_sensor(0x6F12, 0x8206);
	write_cmos_sensor(0x6F12, 0x521E);
	write_cmos_sensor(0x6F12, 0x7460);
	write_cmos_sensor(0x6F12, 0x50F8);
	write_cmos_sensor(0x6F12, 0x2240);
	write_cmos_sensor(0x6F12, 0xAC42);
	write_cmos_sensor(0x6F12, 0x01D9);
	write_cmos_sensor(0x6F12, 0x002A);
	write_cmos_sensor(0x6F12, 0xF5DA);
	write_cmos_sensor(0x6F12, 0x00EB);
	write_cmos_sensor(0x6F12, 0x8202);
	write_cmos_sensor(0x6F12, 0x5B1C);
	write_cmos_sensor(0x6F12, 0x5560);
	write_cmos_sensor(0x6F12, 0x8B42);
	write_cmos_sensor(0x6F12, 0xEBDB);
	write_cmos_sensor(0x6F12, 0x70BD);
	write_cmos_sensor(0x6F12, 0x70B5);
	write_cmos_sensor(0x6F12, 0x0123);
	write_cmos_sensor(0x6F12, 0x11E0);
	write_cmos_sensor(0x6F12, 0x50F8);
	write_cmos_sensor(0x6F12, 0x2350);
	write_cmos_sensor(0x6F12, 0x5A1E);
	write_cmos_sensor(0x6F12, 0x03E0);
	write_cmos_sensor(0x6F12, 0x00EB);
	write_cmos_sensor(0x6F12, 0x8206);
	write_cmos_sensor(0x6F12, 0x521E);
	write_cmos_sensor(0x6F12, 0x7460);
	write_cmos_sensor(0x6F12, 0x50F8);
	write_cmos_sensor(0x6F12, 0x2240);
	write_cmos_sensor(0x6F12, 0xAC42);
	write_cmos_sensor(0x6F12, 0x01D2);
	write_cmos_sensor(0x6F12, 0x002A);
	write_cmos_sensor(0x6F12, 0xF5DA);
	write_cmos_sensor(0x6F12, 0x00EB);
	write_cmos_sensor(0x6F12, 0x8202);
	write_cmos_sensor(0x6F12, 0x5B1C);
	write_cmos_sensor(0x6F12, 0x5560);
	write_cmos_sensor(0x6F12, 0x8B42);
	write_cmos_sensor(0x6F12, 0xEBDB);
	write_cmos_sensor(0x6F12, 0x70BD);
	write_cmos_sensor(0x6F12, 0x2DE9);
	write_cmos_sensor(0x6F12, 0xF34F);
	write_cmos_sensor(0x6F12, 0xF84F);
	write_cmos_sensor(0x6F12, 0x0646);
	write_cmos_sensor(0x6F12, 0x91B0);
	write_cmos_sensor(0x6F12, 0xB87F);
	write_cmos_sensor(0x6F12, 0x0028);
	write_cmos_sensor(0x6F12, 0x79D0);
	write_cmos_sensor(0x6F12, 0x307E);
	write_cmos_sensor(0x6F12, 0x717E);
	write_cmos_sensor(0x6F12, 0x129C);
	write_cmos_sensor(0x6F12, 0x0844);
	write_cmos_sensor(0x6F12, 0x0690);
	write_cmos_sensor(0x6F12, 0x96F8);
	write_cmos_sensor(0x6F12, 0x6B10);
	write_cmos_sensor(0x6F12, 0xB07E);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0xFAFC);
	write_cmos_sensor(0x6F12, 0x1090);
	write_cmos_sensor(0x6F12, 0xB07E);
	write_cmos_sensor(0x6F12, 0xF17E);
	write_cmos_sensor(0x6F12, 0x0844);
	write_cmos_sensor(0x6F12, 0x0590);
	write_cmos_sensor(0x6F12, 0x0090);
	write_cmos_sensor(0x6F12, 0x96F8);
	write_cmos_sensor(0x6F12, 0x6D00);
	write_cmos_sensor(0x6F12, 0x08B1);
	write_cmos_sensor(0x6F12, 0x0125);
	write_cmos_sensor(0x6F12, 0x00E0);
	write_cmos_sensor(0x6F12, 0x0025);
	write_cmos_sensor(0x6F12, 0xB6F8);
	write_cmos_sensor(0x6F12, 0x5800);
	write_cmos_sensor(0x6F12, 0x0699);
	write_cmos_sensor(0x6F12, 0xC5F1);
	write_cmos_sensor(0x6F12, 0x0108);
	write_cmos_sensor(0x6F12, 0xB0FB);
	write_cmos_sensor(0x6F12, 0xF1F2);
	write_cmos_sensor(0x6F12, 0x01FB);
	write_cmos_sensor(0x6F12, 0x1201);
	write_cmos_sensor(0x6F12, 0x069A);
	write_cmos_sensor(0x6F12, 0x4FF0);
	write_cmos_sensor(0x6F12, 0x000A);
	write_cmos_sensor(0x6F12, 0xB0FB);
	write_cmos_sensor(0x6F12, 0xF2F0);
	write_cmos_sensor(0x6F12, 0xB6F8);
	write_cmos_sensor(0x6F12, 0x8E20);
	write_cmos_sensor(0x6F12, 0x00EB);
	write_cmos_sensor(0x6F12, 0x5200);
	write_cmos_sensor(0x6F12, 0x0990);
	write_cmos_sensor(0x6F12, 0xE148);
	write_cmos_sensor(0x6F12, 0xB0F8);
	write_cmos_sensor(0x6F12, 0x8000);
	write_cmos_sensor(0x6F12, 0x401A);
	write_cmos_sensor(0x6F12, 0x0F90);
	write_cmos_sensor(0x6F12, 0x45B1);
	write_cmos_sensor(0x6F12, 0x4FF0);
	write_cmos_sensor(0x6F12, 0xFF30);
	write_cmos_sensor(0x6F12, 0x0A90);
	write_cmos_sensor(0x6F12, 0xD7E9);
	write_cmos_sensor(0x6F12, 0x0419);
	write_cmos_sensor(0x6F12, 0x091F);
	write_cmos_sensor(0x6F12, 0x0B91);
	write_cmos_sensor(0x6F12, 0x0146);
	write_cmos_sensor(0x6F12, 0x07E0);
	write_cmos_sensor(0x6F12, 0x0120);
	write_cmos_sensor(0x6F12, 0x0A90);
	write_cmos_sensor(0x6F12, 0xD7E9);
	write_cmos_sensor(0x6F12, 0x0490);
	write_cmos_sensor(0x6F12, 0x001D);
	write_cmos_sensor(0x6F12, 0x0B90);
	write_cmos_sensor(0x6F12, 0x0099);
	write_cmos_sensor(0x6F12, 0x0020);
	write_cmos_sensor(0x6F12, 0x96F8);
	write_cmos_sensor(0x6F12, 0x6C20);
	write_cmos_sensor(0x6F12, 0x12B1);
	write_cmos_sensor(0x6F12, 0xAFF2);
	write_cmos_sensor(0x6F12, 0xC902);
	write_cmos_sensor(0x6F12, 0x01E0);
	write_cmos_sensor(0x6F12, 0xAFF2);
	write_cmos_sensor(0x6F12, 0xFD02);
	write_cmos_sensor(0x6F12, 0xD34B);
	write_cmos_sensor(0x6F12, 0x9A61);
	write_cmos_sensor(0x6F12, 0xD04B);
	write_cmos_sensor(0x6F12, 0x9A68);
	write_cmos_sensor(0x6F12, 0x0392);
	write_cmos_sensor(0x6F12, 0xDB68);
	write_cmos_sensor(0x6F12, 0x0493);
	write_cmos_sensor(0x6F12, 0xCDE9);
	write_cmos_sensor(0x6F12, 0x0123);
	write_cmos_sensor(0x6F12, 0x7288);
	write_cmos_sensor(0x6F12, 0x96F8);
	write_cmos_sensor(0x6F12, 0x6A30);
	write_cmos_sensor(0x6F12, 0x368E);
	write_cmos_sensor(0x6F12, 0x03FB);
	write_cmos_sensor(0x6F12, 0x0622);
	write_cmos_sensor(0x6F12, 0x0892);
	write_cmos_sensor(0x6F12, 0xD0E0);
	write_cmos_sensor(0x6F12, 0x0A9E);
	write_cmos_sensor(0x6F12, 0xD9F8);
	write_cmos_sensor(0x6F12, 0x0020);
	write_cmos_sensor(0x6F12, 0x09EB);
	write_cmos_sensor(0x6F12, 0x8609);
	write_cmos_sensor(0x6F12, 0x089E);
	write_cmos_sensor(0x6F12, 0x130C);
	write_cmos_sensor(0x6F12, 0xB342);
	write_cmos_sensor(0x6F12, 0xF5D3);
	write_cmos_sensor(0x6F12, 0x9E1B);
	write_cmos_sensor(0x6F12, 0x0F9B);
	write_cmos_sensor(0x6F12, 0x92B2);
	write_cmos_sensor(0x6F12, 0x069F);
	write_cmos_sensor(0x6F12, 0x1344);
	write_cmos_sensor(0x6F12, 0xB3FB);
	write_cmos_sensor(0x6F12, 0xF7F3);
	write_cmos_sensor(0x6F12, 0x099F);
	write_cmos_sensor(0x6F12, 0xBB42);
	write_cmos_sensor(0x6F12, 0x7DD3);
	write_cmos_sensor(0x6F12, 0xDB1B);
	write_cmos_sensor(0x6F12, 0x63F3);
	write_cmos_sensor(0x6F12, 0x5F02);
	write_cmos_sensor(0x6F12, 0x0E92);
	write_cmos_sensor(0x6F12, 0xB8F1);
	write_cmos_sensor(0x6F12, 0x000F);
	write_cmos_sensor(0x6F12, 0x01D0);
	write_cmos_sensor(0x6F12, 0x8E42);
	write_cmos_sensor(0x6F12, 0x02D2);
	write_cmos_sensor(0x6F12, 0x25B1);
	write_cmos_sensor(0x6F12, 0x8642);
	write_cmos_sensor(0x6F12, 0x02D2);
	write_cmos_sensor(0x6F12, 0x0122);
	write_cmos_sensor(0x6F12, 0x01E0);
	write_cmos_sensor(0x6F12, 0x39E1);
	write_cmos_sensor(0x6F12, 0x0022);
	write_cmos_sensor(0x6F12, 0x002A);
	write_cmos_sensor(0x6F12, 0x6CD0);
	write_cmos_sensor(0x6F12, 0x01A8);
	write_cmos_sensor(0x6F12, 0x4AEA);
	write_cmos_sensor(0x6F12, 0x0547);
	write_cmos_sensor(0x6F12, 0x50F8);
	write_cmos_sensor(0x6F12, 0x2500);
	write_cmos_sensor(0x6F12, 0x0D90);
	write_cmos_sensor(0x6F12, 0x03A8);
	write_cmos_sensor(0x6F12, 0x50F8);
	write_cmos_sensor(0x6F12, 0x25B0);
	write_cmos_sensor(0x6F12, 0x0D98);
	write_cmos_sensor(0x6F12, 0xA0EB);
	write_cmos_sensor(0x6F12, 0x0B00);
	write_cmos_sensor(0x6F12, 0x8010);
	write_cmos_sensor(0x6F12, 0x0790);
	write_cmos_sensor(0x6F12, 0xB048);
	write_cmos_sensor(0x6F12, 0x90F8);
	write_cmos_sensor(0x6F12, 0xFC00);
	write_cmos_sensor(0x6F12, 0x08B1);
	write_cmos_sensor(0x6F12, 0x0020);
	write_cmos_sensor(0x6F12, 0x02E0);
	write_cmos_sensor(0x6F12, 0xAD48);
	write_cmos_sensor(0x6F12, 0xB0F8);
	write_cmos_sensor(0x6F12, 0x2C01);
	write_cmos_sensor(0x6F12, 0x0C90);
	write_cmos_sensor(0x6F12, 0xAD48);
	write_cmos_sensor(0x6F12, 0xB0F8);
	write_cmos_sensor(0x6F12, 0x4E15);
	write_cmos_sensor(0x6F12, 0x0798);
	write_cmos_sensor(0x6F12, 0x8142);
	write_cmos_sensor(0x6F12, 0x03D2);
	write_cmos_sensor(0x6F12, 0x390C);
	write_cmos_sensor(0x6F12, 0x3620);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0x69FC);
	write_cmos_sensor(0x6F12, 0xA648);
	write_cmos_sensor(0x6F12, 0x90F8);
	write_cmos_sensor(0x6F12, 0xFD00);
	write_cmos_sensor(0x6F12, 0x20B9);
	write_cmos_sensor(0x6F12, 0xA448);
	write_cmos_sensor(0x6F12, 0xB0F8);
	write_cmos_sensor(0x6F12, 0x2801);
	write_cmos_sensor(0x6F12, 0x07EB);
	write_cmos_sensor(0x6F12, 0x0047);
	write_cmos_sensor(0x6F12, 0x0798);
	write_cmos_sensor(0x6F12, 0x0128);
	write_cmos_sensor(0x6F12, 0x07D0);
	write_cmos_sensor(0x6F12, 0x15D9);
	write_cmos_sensor(0x6F12, 0xA04A);
	write_cmos_sensor(0x6F12, 0x0146);
	write_cmos_sensor(0x6F12, 0x5846);
	write_cmos_sensor(0x6F12, 0x9269);
	write_cmos_sensor(0x6F12, 0x9047);
	write_cmos_sensor(0x6F12, 0x5846);
	write_cmos_sensor(0x6F12, 0x0BE0);
	write_cmos_sensor(0x6F12, 0xDBF8);
	write_cmos_sensor(0x6F12, 0x0010);
	write_cmos_sensor(0x6F12, 0x0C98);
	write_cmos_sensor(0x6F12, 0x0844);
	write_cmos_sensor(0x6F12, 0x3843);
	write_cmos_sensor(0x6F12, 0x01C4);
	write_cmos_sensor(0x6F12, 0x07E0);
	write_cmos_sensor(0x6F12, 0x04C8);
	write_cmos_sensor(0x6F12, 0x0C99);
	write_cmos_sensor(0x6F12, 0x1144);
	write_cmos_sensor(0x6F12, 0x3943);
	write_cmos_sensor(0x6F12, 0x02C4);
	write_cmos_sensor(0x6F12, 0x0D99);
	write_cmos_sensor(0x6F12, 0x8842);
	write_cmos_sensor(0x6F12, 0xF7D1);
	write_cmos_sensor(0x6F12, 0x01A8);
	write_cmos_sensor(0x6F12, 0x4AEA);
	write_cmos_sensor(0x6F12, 0x0847);
	write_cmos_sensor(0x6F12, 0x50F8);
	write_cmos_sensor(0x6F12, 0x2800);
	write_cmos_sensor(0x6F12, 0x0C90);
	write_cmos_sensor(0x6F12, 0x03A8);
	write_cmos_sensor(0x6F12, 0x50F8);
	write_cmos_sensor(0x6F12, 0x28B0);
	write_cmos_sensor(0x6F12, 0x0C98);
	write_cmos_sensor(0x6F12, 0xA0EB);
	write_cmos_sensor(0x6F12, 0x0B00);
	write_cmos_sensor(0x6F12, 0x8010);
	write_cmos_sensor(0x6F12, 0x0790);
	write_cmos_sensor(0x6F12, 0x8D48);
	write_cmos_sensor(0x6F12, 0x90F8);
	write_cmos_sensor(0x6F12, 0xFC00);
	write_cmos_sensor(0x6F12, 0x08B1);
	write_cmos_sensor(0x6F12, 0x0020);
	write_cmos_sensor(0x6F12, 0x02E0);
	write_cmos_sensor(0x6F12, 0x8A48);
	write_cmos_sensor(0x6F12, 0xB0F8);
	write_cmos_sensor(0x6F12, 0x2C01);
	write_cmos_sensor(0x6F12, 0x8246);
	write_cmos_sensor(0x6F12, 0x8A48);
	write_cmos_sensor(0x6F12, 0xB0F8);
	write_cmos_sensor(0x6F12, 0x4E15);
	write_cmos_sensor(0x6F12, 0x0798);
	write_cmos_sensor(0x6F12, 0x8142);
	write_cmos_sensor(0x6F12, 0x03D2);
	write_cmos_sensor(0x6F12, 0x390C);
	write_cmos_sensor(0x6F12, 0x3620);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0x24FC);
	write_cmos_sensor(0x6F12, 0x8348);
	write_cmos_sensor(0x6F12, 0x90F8);
	write_cmos_sensor(0x6F12, 0xFD10);
	write_cmos_sensor(0x6F12, 0x31B9);
	write_cmos_sensor(0x6F12, 0x01E0);
	write_cmos_sensor(0x6F12, 0x3EE0);
	write_cmos_sensor(0x6F12, 0x2FE0);
	write_cmos_sensor(0x6F12, 0xB0F8);
	write_cmos_sensor(0x6F12, 0x2801);
	write_cmos_sensor(0x6F12, 0x07EB);
	write_cmos_sensor(0x6F12, 0x0047);
	write_cmos_sensor(0x6F12, 0x0798);
	write_cmos_sensor(0x6F12, 0x0128);
	write_cmos_sensor(0x6F12, 0x07D0);
	write_cmos_sensor(0x6F12, 0x15D9);
	write_cmos_sensor(0x6F12, 0x7D4A);
	write_cmos_sensor(0x6F12, 0x0146);
	write_cmos_sensor(0x6F12, 0x5846);
	write_cmos_sensor(0x6F12, 0x9269);
	write_cmos_sensor(0x6F12, 0x9047);
	write_cmos_sensor(0x6F12, 0x5846);
	write_cmos_sensor(0x6F12, 0x0BE0);
	write_cmos_sensor(0x6F12, 0xDBF8);
	write_cmos_sensor(0x6F12, 0x0010);
	write_cmos_sensor(0x6F12, 0x01EB);
	write_cmos_sensor(0x6F12, 0x0A00);
	write_cmos_sensor(0x6F12, 0x3843);
	write_cmos_sensor(0x6F12, 0x01C4);
	write_cmos_sensor(0x6F12, 0x07E0);
	write_cmos_sensor(0x6F12, 0x04C8);
	write_cmos_sensor(0x6F12, 0x02EB);
	write_cmos_sensor(0x6F12, 0x0A01);
	write_cmos_sensor(0x6F12, 0x3943);
	write_cmos_sensor(0x6F12, 0x02C4);
	write_cmos_sensor(0x6F12, 0x0C99);
	write_cmos_sensor(0x6F12, 0x8842);
	write_cmos_sensor(0x6F12, 0xF7D1);
	write_cmos_sensor(0x6F12, 0x0398);
	write_cmos_sensor(0x6F12, 0x0190);
	write_cmos_sensor(0x6F12, 0x0498);
	write_cmos_sensor(0x6F12, 0x0290);
	write_cmos_sensor(0x6F12, 0x0598);
	write_cmos_sensor(0x6F12, 0xB6FB);
	write_cmos_sensor(0x6F12, 0xF0F1);
	write_cmos_sensor(0x6F12, 0xB6FB);
	write_cmos_sensor(0x6F12, 0xF0F2);
	write_cmos_sensor(0x6F12, 0x00FB);
	write_cmos_sensor(0x6F12, 0x1163);
	write_cmos_sensor(0x6F12, 0x0098);
	write_cmos_sensor(0x6F12, 0x0099);
	write_cmos_sensor(0x6F12, 0x5043);
	write_cmos_sensor(0x6F12, 0x0144);
	write_cmos_sensor(0x6F12, 0x4FEA);
	write_cmos_sensor(0x6F12, 0x424A);
	write_cmos_sensor(0x6F12, 0x00E0);
	write_cmos_sensor(0x6F12, 0x331A);
	write_cmos_sensor(0x6F12, 0x109A);
	write_cmos_sensor(0x6F12, 0xDA40);
	write_cmos_sensor(0x6F12, 0xD207);
	write_cmos_sensor(0x6F12, 0x08D0);
	write_cmos_sensor(0x6F12, 0x06F0);
	write_cmos_sensor(0x6F12, 0x0103);
	write_cmos_sensor(0x6F12, 0x01AE);
	write_cmos_sensor(0x6F12, 0x0E9F);
	write_cmos_sensor(0x6F12, 0x56F8);
	write_cmos_sensor(0x6F12, 0x2320);
	write_cmos_sensor(0x6F12, 0x80C2);
	write_cmos_sensor(0x6F12, 0x46F8);
	write_cmos_sensor(0x6F12, 0x2320);
	write_cmos_sensor(0x6F12, 0x0B9B);
	write_cmos_sensor(0x6F12, 0x9945);
	write_cmos_sensor(0x6F12, 0x7FF4);
	write_cmos_sensor(0x6F12, 0x2BAF);
	write_cmos_sensor(0x6F12, 0x01A8);
	write_cmos_sensor(0x6F12, 0x50F8);
	write_cmos_sensor(0x6F12, 0x2590);
	write_cmos_sensor(0x6F12, 0x03A8);
	write_cmos_sensor(0x6F12, 0x50F8);
	write_cmos_sensor(0x6F12, 0x2560);
	write_cmos_sensor(0x6F12, 0x4AEA);
	write_cmos_sensor(0x6F12, 0x0545);
	write_cmos_sensor(0x6F12, 0xA9EB);
	write_cmos_sensor(0x6F12, 0x0600);
	write_cmos_sensor(0x6F12, 0x4FEA);
	write_cmos_sensor(0x6F12, 0xA00B);
	write_cmos_sensor(0x6F12, 0x5948);
	write_cmos_sensor(0x6F12, 0x90F8);
	write_cmos_sensor(0x6F12, 0xFC00);
	write_cmos_sensor(0x6F12, 0x08B1);
	write_cmos_sensor(0x6F12, 0x0027);
	write_cmos_sensor(0x6F12, 0x02E0);
	write_cmos_sensor(0x6F12, 0x5648);
	write_cmos_sensor(0x6F12, 0xB0F8);
	write_cmos_sensor(0x6F12, 0x2C71);
	write_cmos_sensor(0x6F12, 0x5648);
	write_cmos_sensor(0x6F12, 0xB0F8);
	write_cmos_sensor(0x6F12, 0x4E15);
	write_cmos_sensor(0x6F12, 0x5945);
	write_cmos_sensor(0x6F12, 0x03D2);
	write_cmos_sensor(0x6F12, 0x290C);
	write_cmos_sensor(0x6F12, 0x3620);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0xBDFB);
	write_cmos_sensor(0x6F12, 0x5048);
	write_cmos_sensor(0x6F12, 0x90F8);
	write_cmos_sensor(0x6F12, 0xFD00);
	write_cmos_sensor(0x6F12, 0x20B9);
	write_cmos_sensor(0x6F12, 0x4E48);
	write_cmos_sensor(0x6F12, 0xB0F8);
	write_cmos_sensor(0x6F12, 0x2801);
	write_cmos_sensor(0x6F12, 0x05EB);
	write_cmos_sensor(0x6F12, 0x0045);
	write_cmos_sensor(0x6F12, 0x5846);
	write_cmos_sensor(0x6F12, 0xBBF1);
	write_cmos_sensor(0x6F12, 0x010F);
	write_cmos_sensor(0x6F12, 0x06D0);
	write_cmos_sensor(0x6F12, 0x10D9);
	write_cmos_sensor(0x6F12, 0x4A4A);
	write_cmos_sensor(0x6F12, 0x0146);
	write_cmos_sensor(0x6F12, 0x3046);
	write_cmos_sensor(0x6F12, 0x9269);
	write_cmos_sensor(0x6F12, 0x9047);
	write_cmos_sensor(0x6F12, 0x08E0);
	write_cmos_sensor(0x6F12, 0x3068);
	write_cmos_sensor(0x6F12, 0x3844);
	write_cmos_sensor(0x6F12, 0x2843);
	write_cmos_sensor(0x6F12, 0x01C4);
	write_cmos_sensor(0x6F12, 0x05E0);
	write_cmos_sensor(0x6F12, 0x01CE);
	write_cmos_sensor(0x6F12, 0x3844);
	write_cmos_sensor(0x6F12, 0x2843);
	write_cmos_sensor(0x6F12, 0x01C4);
	write_cmos_sensor(0x6F12, 0x4E45);
	write_cmos_sensor(0x6F12, 0xF9D1);
	write_cmos_sensor(0x6F12, 0x01A8);
	write_cmos_sensor(0x6F12, 0x4AEA);
	write_cmos_sensor(0x6F12, 0x0845);
	write_cmos_sensor(0x6F12, 0x50F8);
	write_cmos_sensor(0x6F12, 0x2890);
	write_cmos_sensor(0x6F12, 0x03A8);
	write_cmos_sensor(0x6F12, 0xDFF8);
	write_cmos_sensor(0x6F12, 0xF4A0);
	write_cmos_sensor(0x6F12, 0x50F8);
	write_cmos_sensor(0x6F12, 0x2860);
	write_cmos_sensor(0x6F12, 0xA9EB);
	write_cmos_sensor(0x6F12, 0x0600);
	write_cmos_sensor(0x6F12, 0x4FEA);
	write_cmos_sensor(0x6F12, 0xA008);
	write_cmos_sensor(0x6F12, 0x9AF8);
	write_cmos_sensor(0x6F12, 0xFC00);
	write_cmos_sensor(0x6F12, 0x08B1);
	write_cmos_sensor(0x6F12, 0x0027);
	write_cmos_sensor(0x6F12, 0x01E0);
	write_cmos_sensor(0x6F12, 0xBAF8);
	write_cmos_sensor(0x6F12, 0x2C71);
	write_cmos_sensor(0x6F12, 0x3848);
	write_cmos_sensor(0x6F12, 0xB0F8);
	write_cmos_sensor(0x6F12, 0x4E15);
	write_cmos_sensor(0x6F12, 0x4145);
	write_cmos_sensor(0x6F12, 0x03D2);
	write_cmos_sensor(0x6F12, 0x290C);
	write_cmos_sensor(0x6F12, 0x3620);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0x80FB);
	write_cmos_sensor(0x6F12, 0x9AF8);
	write_cmos_sensor(0x6F12, 0xFD10);
	write_cmos_sensor(0x6F12, 0x19B9);
	write_cmos_sensor(0x6F12, 0xBAF8);
	write_cmos_sensor(0x6F12, 0x2801);
	write_cmos_sensor(0x6F12, 0x05EB);
	write_cmos_sensor(0x6F12, 0x0045);
	write_cmos_sensor(0x6F12, 0x4046);
	write_cmos_sensor(0x6F12, 0xB8F1);
	write_cmos_sensor(0x6F12, 0x010F);
	write_cmos_sensor(0x6F12, 0x06D0);
	write_cmos_sensor(0x6F12, 0x10D9);
	write_cmos_sensor(0x6F12, 0x2C4A);
	write_cmos_sensor(0x6F12, 0x0146);
	write_cmos_sensor(0x6F12, 0x3046);
	write_cmos_sensor(0x6F12, 0x9269);
	write_cmos_sensor(0x6F12, 0x9047);
	write_cmos_sensor(0x6F12, 0x08E0);
	write_cmos_sensor(0x6F12, 0x3068);
	write_cmos_sensor(0x6F12, 0x3844);
	write_cmos_sensor(0x6F12, 0x2843);
	write_cmos_sensor(0x6F12, 0x01C4);
	write_cmos_sensor(0x6F12, 0x05E0);
	write_cmos_sensor(0x6F12, 0x01CE);
	write_cmos_sensor(0x6F12, 0x3844);
	write_cmos_sensor(0x6F12, 0x2843);
	write_cmos_sensor(0x6F12, 0x01C4);
	write_cmos_sensor(0x6F12, 0x4E45);
	write_cmos_sensor(0x6F12, 0xF9D1);
	write_cmos_sensor(0x6F12, 0x4FF0);
	write_cmos_sensor(0x6F12, 0xFF30);
	write_cmos_sensor(0x6F12, 0x2060);
	write_cmos_sensor(0x6F12, 0x1298);
	write_cmos_sensor(0x6F12, 0x8442);
	write_cmos_sensor(0x6F12, 0x01D0);
	write_cmos_sensor(0x6F12, 0x0120);
	write_cmos_sensor(0x6F12, 0x00E0);
	write_cmos_sensor(0x6F12, 0x0020);
	write_cmos_sensor(0x6F12, 0x1D49);
	write_cmos_sensor(0x6F12, 0x0870);
	write_cmos_sensor(0x6F12, 0x1298);
	write_cmos_sensor(0x6F12, 0x201A);
	write_cmos_sensor(0x6F12, 0x8008);
	write_cmos_sensor(0x6F12, 0x0884);
	write_cmos_sensor(0x6F12, 0x13B0);
	write_cmos_sensor(0x6F12, 0xBDE8);
	write_cmos_sensor(0x6F12, 0xF08F);
	write_cmos_sensor(0x6F12, 0x2DE9);
	write_cmos_sensor(0x6F12, 0xF041);
	write_cmos_sensor(0x6F12, 0x90F8);
	write_cmos_sensor(0x6F12, 0x6920);
	write_cmos_sensor(0x6F12, 0x0D46);
	write_cmos_sensor(0x6F12, 0x0446);
	write_cmos_sensor(0x6F12, 0x032A);
	write_cmos_sensor(0x6F12, 0x15D0);
	write_cmos_sensor(0x6F12, 0x062A);
	write_cmos_sensor(0x6F12, 0x13D0);
	write_cmos_sensor(0x6F12, 0x1648);
	write_cmos_sensor(0x6F12, 0x0022);
	write_cmos_sensor(0x6F12, 0xC069);
	write_cmos_sensor(0x6F12, 0x87B2);
	write_cmos_sensor(0x6F12, 0x060C);
	write_cmos_sensor(0x6F12, 0x3946);
	write_cmos_sensor(0x6F12, 0x3046);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0x25FB);
	write_cmos_sensor(0x6F12, 0x2946);
	write_cmos_sensor(0x6F12, 0x2046);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0x3FFB);
	write_cmos_sensor(0x6F12, 0x3946);
	write_cmos_sensor(0x6F12, 0x3046);
	write_cmos_sensor(0x6F12, 0xBDE8);
	write_cmos_sensor(0x6F12, 0xF041);
	write_cmos_sensor(0x6F12, 0x0122);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0x1ABB);
	write_cmos_sensor(0x6F12, 0xBDE8);
	write_cmos_sensor(0x6F12, 0xF041);
	write_cmos_sensor(0x6F12, 0x1EE6);
	write_cmos_sensor(0x6F12, 0x0346);
	write_cmos_sensor(0x6F12, 0x0020);
	write_cmos_sensor(0x6F12, 0x0029);
	write_cmos_sensor(0x6F12, 0x0BD0);
	write_cmos_sensor(0x6F12, 0x0749);
	write_cmos_sensor(0x6F12, 0x0978);
	write_cmos_sensor(0x6F12, 0x0029);
	write_cmos_sensor(0x6F12, 0x07D0);
	write_cmos_sensor(0x6F12, 0x002A);
	write_cmos_sensor(0x6F12, 0x05D0);
	write_cmos_sensor(0x6F12, 0x73B1);
	write_cmos_sensor(0x6F12, 0x02F0);
	write_cmos_sensor(0x6F12, 0x0300);
	write_cmos_sensor(0x6F12, 0x0128);
	write_cmos_sensor(0x6F12, 0x0CD1);
	write_cmos_sensor(0x6F12, 0x0020);
	write_cmos_sensor(0x6F12, 0x7047);
	write_cmos_sensor(0x6F12, 0x0000);
	write_cmos_sensor(0x6F12, 0x2000);
	write_cmos_sensor(0x6F12, 0x1C20);
	write_cmos_sensor(0x6F12, 0x2000);
	write_cmos_sensor(0x6F12, 0x1EB0);
	write_cmos_sensor(0x6F12, 0x2000);
	write_cmos_sensor(0x6F12, 0x3FF0);
	write_cmos_sensor(0x6F12, 0x2000);
	write_cmos_sensor(0x6F12, 0x1350);
	write_cmos_sensor(0x6F12, 0x9007);
	write_cmos_sensor(0x6F12, 0xF3D0);
	write_cmos_sensor(0x6F12, 0x0120);
	write_cmos_sensor(0x6F12, 0xF1E7);
	write_cmos_sensor(0x6F12, 0x2DE9);
	write_cmos_sensor(0x6F12, 0xF05F);
	write_cmos_sensor(0x6F12, 0x0C46);
	write_cmos_sensor(0x6F12, 0x0546);
	write_cmos_sensor(0x6F12, 0x9089);
	write_cmos_sensor(0x6F12, 0x518A);
	write_cmos_sensor(0x6F12, 0x1646);
	write_cmos_sensor(0x6F12, 0x401A);
	write_cmos_sensor(0x6F12, 0x918A);
	write_cmos_sensor(0x6F12, 0x401A);
	write_cmos_sensor(0x6F12, 0x1FFA);
	write_cmos_sensor(0x6F12, 0x80FA);
	write_cmos_sensor(0x6F12, 0xFD48);
	write_cmos_sensor(0x6F12, 0xB5F8);
	write_cmos_sensor(0x6F12, 0x5A10);
	write_cmos_sensor(0x6F12, 0x8278);
	write_cmos_sensor(0x6F12, 0x95F8);
	write_cmos_sensor(0x6F12, 0x6A00);
	write_cmos_sensor(0x6F12, 0x02FB);
	write_cmos_sensor(0x6F12, 0x1011);
	write_cmos_sensor(0x6F12, 0xB5F8);
	write_cmos_sensor(0x6F12, 0x6620);
	write_cmos_sensor(0x6F12, 0x89B2);
	write_cmos_sensor(0x6F12, 0x02FB);
	write_cmos_sensor(0x6F12, 0x0010);
	write_cmos_sensor(0x6F12, 0xE97E);
	write_cmos_sensor(0x6F12, 0x401A);
	write_cmos_sensor(0x6F12, 0x1FFA);
	write_cmos_sensor(0x6F12, 0x80F8);
	write_cmos_sensor(0x6F12, 0x7088);
	write_cmos_sensor(0x6F12, 0x95F8);
	write_cmos_sensor(0x6F12, 0xB210);
	write_cmos_sensor(0x6F12, 0x401A);
	write_cmos_sensor(0x6F12, 0x87B2);
	write_cmos_sensor(0x6F12, 0x95F8);
	write_cmos_sensor(0x6F12, 0x2200);
	write_cmos_sensor(0x6F12, 0x30B1);
	write_cmos_sensor(0x6F12, 0x2846);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0xF4FA);
	write_cmos_sensor(0x6F12, 0x10B1);
	write_cmos_sensor(0x6F12, 0xF048);
	write_cmos_sensor(0x6F12, 0x0088);
	write_cmos_sensor(0x6F12, 0x00B1);
	write_cmos_sensor(0x6F12, 0x0120);
	write_cmos_sensor(0x6F12, 0x2070);
	write_cmos_sensor(0x6F12, 0x95F8);
	write_cmos_sensor(0x6F12, 0x6900);
	write_cmos_sensor(0x6F12, 0x0228);
	write_cmos_sensor(0x6F12, 0x03D1);
	write_cmos_sensor(0x6F12, 0x95F8);
	write_cmos_sensor(0x6F12, 0x6B00);
	write_cmos_sensor(0x6F12, 0x0228);
	write_cmos_sensor(0x6F12, 0x14D0);
	write_cmos_sensor(0x6F12, 0xB5F8);
	write_cmos_sensor(0x6F12, 0x9E00);
	write_cmos_sensor(0x6F12, 0x0221);
	write_cmos_sensor(0x6F12, 0xB1EB);
	write_cmos_sensor(0x6F12, 0x101F);
	write_cmos_sensor(0x6F12, 0x03D1);
	write_cmos_sensor(0x6F12, 0x95F8);
	write_cmos_sensor(0x6F12, 0x6B00);
	write_cmos_sensor(0x6F12, 0x0228);
	write_cmos_sensor(0x6F12, 0x0AD0);
	write_cmos_sensor(0x6F12, 0x0023);
	write_cmos_sensor(0x6F12, 0x6370);
	write_cmos_sensor(0x6F12, 0x95F8);
	write_cmos_sensor(0x6F12, 0x6D00);
	write_cmos_sensor(0x6F12, 0x591C);
	write_cmos_sensor(0x6F12, 0x30B1);
	write_cmos_sensor(0x6F12, 0xEA7E);
	write_cmos_sensor(0x6F12, 0xC8F5);
	write_cmos_sensor(0x6F12, 0x4960);
	write_cmos_sensor(0x6F12, 0x801A);
	write_cmos_sensor(0x6F12, 0x02E0);
	write_cmos_sensor(0x6F12, 0x0123);
	write_cmos_sensor(0x6F12, 0xF3E7);
	write_cmos_sensor(0x6F12, 0x6888);
	write_cmos_sensor(0x6F12, 0x95F8);
	write_cmos_sensor(0x6F12, 0x6B20);
	write_cmos_sensor(0x6F12, 0x1FFA);
	write_cmos_sensor(0x6F12, 0x80F9);
	write_cmos_sensor(0x6F12, 0xB9FB);
	write_cmos_sensor(0x6F12, 0xF2F0);
	write_cmos_sensor(0x6F12, 0x3844);
	write_cmos_sensor(0x6F12, 0x80B2);
	write_cmos_sensor(0x6F12, 0x6080);
	write_cmos_sensor(0x6F12, 0x95F8);
	write_cmos_sensor(0x6F12, 0x6B20);
	write_cmos_sensor(0x6F12, 0x4FF4);
	write_cmos_sensor(0x6F12, 0x426E);
	write_cmos_sensor(0x6F12, 0xBEFB);
	write_cmos_sensor(0x6F12, 0xF2F8);
	write_cmos_sensor(0x6F12, 0x00EB);
	write_cmos_sensor(0x6F12, 0x0A0C);
	write_cmos_sensor(0x6F12, 0xE045);
	write_cmos_sensor(0x6F12, 0x06D9);
	write_cmos_sensor(0x6F12, 0x2FB1);
	write_cmos_sensor(0x6F12, 0x728A);
	write_cmos_sensor(0x6F12, 0x02EB);
	write_cmos_sensor(0x6F12, 0x000C);
	write_cmos_sensor(0x6F12, 0x0CEB);
	write_cmos_sensor(0x6F12, 0x0A02);
	write_cmos_sensor(0x6F12, 0x04E0);
	write_cmos_sensor(0x6F12, 0xBEFB);
	write_cmos_sensor(0x6F12, 0xF2F2);
	write_cmos_sensor(0x6F12, 0xB6F8);
	write_cmos_sensor(0x6F12, 0x12C0);
	write_cmos_sensor(0x6F12, 0x6244);
	write_cmos_sensor(0x6F12, 0xA280);
	write_cmos_sensor(0x6F12, 0x95F8);
	write_cmos_sensor(0x6F12, 0x6B20);
	write_cmos_sensor(0x6F12, 0x4FF0);
	write_cmos_sensor(0x6F12, 0x200C);
	write_cmos_sensor(0x6F12, 0xBCFB);
	write_cmos_sensor(0x6F12, 0xF2F8);
	write_cmos_sensor(0x6F12, 0x8045);
	write_cmos_sensor(0x6F12, 0x14D2);
	write_cmos_sensor(0x6F12, 0x728A);
	write_cmos_sensor(0x6F12, 0x0AB1);
	write_cmos_sensor(0x6F12, 0x0246);
	write_cmos_sensor(0x6F12, 0x00E0);
	write_cmos_sensor(0x6F12, 0x0122);
	write_cmos_sensor(0x6F12, 0xE280);
	write_cmos_sensor(0x6F12, 0xB6F8);
	write_cmos_sensor(0x6F12, 0x12C0);
	write_cmos_sensor(0x6F12, 0x92B2);
	write_cmos_sensor(0x6F12, 0x6244);
	write_cmos_sensor(0x6F12, 0x92B2);
	write_cmos_sensor(0x6F12, 0xE280);
	write_cmos_sensor(0x6F12, 0x9346);
	write_cmos_sensor(0x6F12, 0x7289);
	write_cmos_sensor(0x6F12, 0x02FB);
	write_cmos_sensor(0x6F12, 0x01FC);
	write_cmos_sensor(0x6F12, 0xBCF5);
	write_cmos_sensor(0x6F12, 0x7C6F);
	write_cmos_sensor(0x6F12, 0x04DD);
	write_cmos_sensor(0x6F12, 0x7E22);
	write_cmos_sensor(0x6F12, 0x1AE0);
	write_cmos_sensor(0x6F12, 0xBCFB);
	write_cmos_sensor(0x6F12, 0xF2F2);
	write_cmos_sensor(0x6F12, 0xECE7);
	write_cmos_sensor(0x6F12, 0x4FF0);
	write_cmos_sensor(0x6F12, 0x400C);
	write_cmos_sensor(0x6F12, 0xBCFB);
	write_cmos_sensor(0x6F12, 0xF1FC);
	write_cmos_sensor(0x6F12, 0xB2FB);
	write_cmos_sensor(0x6F12, 0xFCF8);
	write_cmos_sensor(0x6F12, 0x0CFB);
	write_cmos_sensor(0x6F12, 0x182C);
	write_cmos_sensor(0x6F12, 0xBCF1);
	write_cmos_sensor(0x6F12, 0x000F);
	write_cmos_sensor(0x6F12, 0x4FF0);
	write_cmos_sensor(0x6F12, 0x400C);
	write_cmos_sensor(0x6F12, 0xBCFB);
	write_cmos_sensor(0x6F12, 0xF1FC);
	write_cmos_sensor(0x6F12, 0xB2FB);
	write_cmos_sensor(0x6F12, 0xFCF2);
	write_cmos_sensor(0x6F12, 0x02D0);
	write_cmos_sensor(0x6F12, 0x5200);
	write_cmos_sensor(0x6F12, 0x921C);
	write_cmos_sensor(0x6F12, 0x03E0);
	write_cmos_sensor(0x6F12, 0x4FF6);
	write_cmos_sensor(0x6F12, 0xFF7C);
	write_cmos_sensor(0x6F12, 0x0CEA);
	write_cmos_sensor(0x6F12, 0x4202);
	write_cmos_sensor(0x6F12, 0x2281);
	write_cmos_sensor(0x6F12, 0x1FFA);
	write_cmos_sensor(0x6F12, 0x82FC);
	write_cmos_sensor(0x6F12, 0x0C22);
	write_cmos_sensor(0x6F12, 0xBCFB);
	write_cmos_sensor(0x6F12, 0xF2F8);
	write_cmos_sensor(0x6F12, 0xA4F8);
	write_cmos_sensor(0x6F12, 0x0A80);
	write_cmos_sensor(0x6F12, 0xBCFB);
	write_cmos_sensor(0x6F12, 0xF2F8);
	write_cmos_sensor(0x6F12, 0x02FB);
	write_cmos_sensor(0x6F12, 0x18C2);
	write_cmos_sensor(0x6F12, 0xA281);
	write_cmos_sensor(0x6F12, 0xAB4A);
	write_cmos_sensor(0x6F12, 0x5288);
	write_cmos_sensor(0x6F12, 0xE281);
	write_cmos_sensor(0x6F12, 0xB6F8);
	write_cmos_sensor(0x6F12, 0x0AC0);
	write_cmos_sensor(0x6F12, 0x6FF0);
	write_cmos_sensor(0x6F12, 0x0A02);
	write_cmos_sensor(0x6F12, 0x02EB);
	write_cmos_sensor(0x6F12, 0x9C02);
	write_cmos_sensor(0x6F12, 0x2282);
	write_cmos_sensor(0x6F12, 0x95F8);
	write_cmos_sensor(0x6F12, 0x6D80);
	write_cmos_sensor(0x6F12, 0xB8F1);
	write_cmos_sensor(0x6F12, 0x000F);
	write_cmos_sensor(0x6F12, 0x02D0);
	write_cmos_sensor(0x6F12, 0x09F1);
	write_cmos_sensor(0x6F12, 0x0702);
	write_cmos_sensor(0x6F12, 0x00E0);
	write_cmos_sensor(0x6F12, 0x4A46);
	write_cmos_sensor(0x6F12, 0x1FFA);
	write_cmos_sensor(0x6F12, 0x82FC);
	write_cmos_sensor(0x6F12, 0x95F8);
	write_cmos_sensor(0x6F12, 0x6B20);
	write_cmos_sensor(0x6F12, 0x4843);
	write_cmos_sensor(0x6F12, 0xBCFB);
	write_cmos_sensor(0x6F12, 0xF2FC);
	write_cmos_sensor(0x6F12, 0xBC44);
	write_cmos_sensor(0x6F12, 0x1FFA);
	write_cmos_sensor(0x6F12, 0x8CFC);
	write_cmos_sensor(0x6F12, 0x2028);
	write_cmos_sensor(0x6F12, 0x3ADC);
	write_cmos_sensor(0x6F12, 0xB8F1);
	write_cmos_sensor(0x6F12, 0x000F);
	write_cmos_sensor(0x6F12, 0x03D0);
	write_cmos_sensor(0x6F12, 0x0720);
	write_cmos_sensor(0x6F12, 0xB0FB);
	write_cmos_sensor(0x6F12, 0xF1F0);
	write_cmos_sensor(0x6F12, 0x00E0);
	write_cmos_sensor(0x6F12, 0x0020);
	write_cmos_sensor(0x6F12, 0x9749);
	write_cmos_sensor(0x6F12, 0x6082);
	write_cmos_sensor(0x6F12, 0x8888);
	write_cmos_sensor(0x6F12, 0xA082);
	write_cmos_sensor(0x6F12, 0x95F8);
	write_cmos_sensor(0x6F12, 0x9200);
	write_cmos_sensor(0x6F12, 0x3844);
	write_cmos_sensor(0x6F12, 0xE082);
	write_cmos_sensor(0x6F12, 0x3FB1);
	write_cmos_sensor(0x6F12, 0x95F8);
	write_cmos_sensor(0x6F12, 0x6B20);
	write_cmos_sensor(0x6F12, 0x0AEB);
	write_cmos_sensor(0x6F12, 0x0700);
	write_cmos_sensor(0x6F12, 0xBEFB);
	write_cmos_sensor(0x6F12, 0xF2F2);
	write_cmos_sensor(0x6F12, 0x8242);
	write_cmos_sensor(0x6F12, 0x03D8);
	write_cmos_sensor(0x6F12, 0x95F8);
	write_cmos_sensor(0x6F12, 0x6B20);
	write_cmos_sensor(0x6F12, 0xBEFB);
	write_cmos_sensor(0x6F12, 0xF2F0);
	write_cmos_sensor(0x6F12, 0x2083);
	write_cmos_sensor(0x6F12, 0x82B2);
	write_cmos_sensor(0x6F12, 0x708A);
	write_cmos_sensor(0x6F12, 0x08B1);
	write_cmos_sensor(0x6F12, 0x95F8);
	write_cmos_sensor(0x6F12, 0x9200);
	write_cmos_sensor(0x6F12, 0x1044);
	write_cmos_sensor(0x6F12, 0x2083);
	write_cmos_sensor(0x6F12, 0xC888);
	write_cmos_sensor(0x6F12, 0x6083);
	write_cmos_sensor(0x6F12, 0x3088);
	write_cmos_sensor(0x6F12, 0xA083);
	write_cmos_sensor(0x6F12, 0xB5F8);
	write_cmos_sensor(0x6F12, 0x9E20);
	write_cmos_sensor(0x6F12, 0x3088);
	write_cmos_sensor(0x6F12, 0x7189);
	write_cmos_sensor(0x6F12, 0x1209);
	write_cmos_sensor(0x6F12, 0x01FB);
	write_cmos_sensor(0x6F12, 0x0200);
	write_cmos_sensor(0x6F12, 0xE083);
	write_cmos_sensor(0x6F12, 0x708A);
	write_cmos_sensor(0x6F12, 0x40B3);
	write_cmos_sensor(0x6F12, 0x608A);
	write_cmos_sensor(0x6F12, 0x0828);
	write_cmos_sensor(0x6F12, 0x16D0);
	write_cmos_sensor(0x6F12, 0x0C28);
	write_cmos_sensor(0x6F12, 0x14D0);
	write_cmos_sensor(0x6F12, 0x0D28);
	write_cmos_sensor(0x6F12, 0x12D0);
	write_cmos_sensor(0x6F12, 0x12E0);
	write_cmos_sensor(0x6F12, 0x02FB);
	write_cmos_sensor(0x6F12, 0x0CF2);
	write_cmos_sensor(0x6F12, 0x203A);
	write_cmos_sensor(0x6F12, 0xD017);
	write_cmos_sensor(0x6F12, 0x02EB);
	write_cmos_sensor(0x6F12, 0x9060);
	write_cmos_sensor(0x6F12, 0x20F0);
	write_cmos_sensor(0x6F12, 0x3F00);
	write_cmos_sensor(0x6F12, 0x101A);
	write_cmos_sensor(0x6F12, 0xC217);
	write_cmos_sensor(0x6F12, 0x00EB);
	write_cmos_sensor(0x6F12, 0x1272);
	write_cmos_sensor(0x6F12, 0x1211);
	write_cmos_sensor(0x6F12, 0xA0EB);
	write_cmos_sensor(0x6F12, 0x0210);
	write_cmos_sensor(0x6F12, 0x90FB);
	write_cmos_sensor(0x6F12, 0xF1F0);
	write_cmos_sensor(0x6F12, 0xBAE7);
	write_cmos_sensor(0x6F12, 0x13B1);
	write_cmos_sensor(0x6F12, 0x0428);
	write_cmos_sensor(0x6F12, 0x05D0);
	write_cmos_sensor(0x6F12, 0x0AE0);
	write_cmos_sensor(0x6F12, 0x801C);
	write_cmos_sensor(0x6F12, 0x6082);
	write_cmos_sensor(0x6F12, 0x0BF1);
	write_cmos_sensor(0x6F12, 0x0200);
	write_cmos_sensor(0x6F12, 0x04E0);
	write_cmos_sensor(0x6F12, 0x23B1);
	write_cmos_sensor(0x6F12, 0x0520);
	write_cmos_sensor(0x6F12, 0x6082);
	write_cmos_sensor(0x6F12, 0x0BF1);
	write_cmos_sensor(0x6F12, 0x0100);
	write_cmos_sensor(0x6F12, 0xE080);
	write_cmos_sensor(0x6F12, 0x95F8);
	write_cmos_sensor(0x6F12, 0x6D00);
	write_cmos_sensor(0x6F12, 0x3A46);
	write_cmos_sensor(0x6F12, 0x1946);
	write_cmos_sensor(0x6F12, 0xFFF7);
	write_cmos_sensor(0x6F12, 0xAEFE);
	write_cmos_sensor(0x6F12, 0x6B49);
	write_cmos_sensor(0x6F12, 0x0880);
	write_cmos_sensor(0x6F12, 0xBDE8);
	write_cmos_sensor(0x6F12, 0xF09F);
	write_cmos_sensor(0x6F12, 0x2DE9);
	write_cmos_sensor(0x6F12, 0xF041);
	write_cmos_sensor(0x6F12, 0x0446);
	write_cmos_sensor(0x6F12, 0x6948);
	write_cmos_sensor(0x6F12, 0x0022);
	write_cmos_sensor(0x6F12, 0x406A);
	write_cmos_sensor(0x6F12, 0x87B2);
	write_cmos_sensor(0x6F12, 0x4FEA);
	write_cmos_sensor(0x6F12, 0x1048);
	write_cmos_sensor(0x6F12, 0x3946);
	write_cmos_sensor(0x6F12, 0x4046);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0xB4F9);
	write_cmos_sensor(0x6F12, 0x2046);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0xD9F9);
	write_cmos_sensor(0x6F12, 0x634E);
	write_cmos_sensor(0x6F12, 0x04F1);
	write_cmos_sensor(0x6F12, 0x5805);
	write_cmos_sensor(0x6F12, 0xB6F8);
	write_cmos_sensor(0x6F12, 0xB400);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0xD7F9);
	write_cmos_sensor(0x6F12, 0x80B2);
	write_cmos_sensor(0x6F12, 0xE880);
	write_cmos_sensor(0x6F12, 0x96F8);
	write_cmos_sensor(0x6F12, 0xB810);
	write_cmos_sensor(0x6F12, 0x0129);
	write_cmos_sensor(0x6F12, 0x03D0);
	write_cmos_sensor(0x6F12, 0xB6F8);
	write_cmos_sensor(0x6F12, 0xB600);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0xCDF9);
	write_cmos_sensor(0x6F12, 0xA881);
	write_cmos_sensor(0x6F12, 0x96F8);
	write_cmos_sensor(0x6F12, 0xB800);
	write_cmos_sensor(0x6F12, 0x0128);
	write_cmos_sensor(0x6F12, 0x0ED0);
	write_cmos_sensor(0x6F12, 0x5948);
	write_cmos_sensor(0x6F12, 0x0068);
	write_cmos_sensor(0x6F12, 0xB0F8);
	write_cmos_sensor(0x6F12, 0x4800);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0xC2F9);
	write_cmos_sensor(0x6F12, 0xA4F8);
	write_cmos_sensor(0x6F12, 0x4800);
	write_cmos_sensor(0x6F12, 0x3946);
	write_cmos_sensor(0x6F12, 0x4046);
	write_cmos_sensor(0x6F12, 0xBDE8);
	write_cmos_sensor(0x6F12, 0xF041);
	write_cmos_sensor(0x6F12, 0x0122);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0x8CB9);
	write_cmos_sensor(0x6F12, 0x34F8);
	write_cmos_sensor(0x6F12, 0x420F);
	write_cmos_sensor(0x6F12, 0xE080);
	write_cmos_sensor(0x6F12, 0xF4E7);
	write_cmos_sensor(0x6F12, 0x2DE9);
	write_cmos_sensor(0x6F12, 0xF041);
	write_cmos_sensor(0x6F12, 0x4A4C);
	write_cmos_sensor(0x6F12, 0x4F4D);
	write_cmos_sensor(0x6F12, 0x0F46);
	write_cmos_sensor(0x6F12, 0x8046);
	write_cmos_sensor(0x6F12, 0x95F8);
	write_cmos_sensor(0x6F12, 0x4430);
	write_cmos_sensor(0x6F12, 0x94F8);
	write_cmos_sensor(0x6F12, 0xFD20);
	write_cmos_sensor(0x6F12, 0x94F8);
	write_cmos_sensor(0x6F12, 0x5C11);
	write_cmos_sensor(0x6F12, 0x0020);
	write_cmos_sensor(0x6F12, 0x23B1);
	write_cmos_sensor(0x6F12, 0x09B1);
	write_cmos_sensor(0x6F12, 0x0220);
	write_cmos_sensor(0x6F12, 0x01E0);
	write_cmos_sensor(0x6F12, 0x02B1);
	write_cmos_sensor(0x6F12, 0x0120);
	write_cmos_sensor(0x6F12, 0x484E);
	write_cmos_sensor(0x6F12, 0xA6F8);
	write_cmos_sensor(0x6F12, 0x4602);
	write_cmos_sensor(0x6F12, 0x95F8);
	write_cmos_sensor(0x6F12, 0x2030);
	write_cmos_sensor(0x6F12, 0x0020);
	write_cmos_sensor(0x6F12, 0x23B1);
	write_cmos_sensor(0x6F12, 0x09B1);
	write_cmos_sensor(0x6F12, 0x0220);
	write_cmos_sensor(0x6F12, 0x01E0);
	write_cmos_sensor(0x6F12, 0x02B1);
	write_cmos_sensor(0x6F12, 0x0120);
	write_cmos_sensor(0x6F12, 0x70B1);
	write_cmos_sensor(0x6F12, 0x0022);
	write_cmos_sensor(0x6F12, 0x0221);
	write_cmos_sensor(0x6F12, 0x47F2);
	write_cmos_sensor(0x6F12, 0xC600);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0x62F9);
	write_cmos_sensor(0x6F12, 0x94F8);
	write_cmos_sensor(0x6F12, 0xFD10);
	write_cmos_sensor(0x6F12, 0x39B1);
	write_cmos_sensor(0x6F12, 0x3E48);
	write_cmos_sensor(0x6F12, 0x90F8);
	write_cmos_sensor(0x6F12, 0x5D00);
	write_cmos_sensor(0x6F12, 0x18B1);
	write_cmos_sensor(0x6F12, 0x0120);
	write_cmos_sensor(0x6F12, 0x02E0);
	write_cmos_sensor(0x6F12, 0x0122);
	write_cmos_sensor(0x6F12, 0xEFE7);
	write_cmos_sensor(0x6F12, 0x0020);
	write_cmos_sensor(0x6F12, 0x94F8);
	write_cmos_sensor(0x6F12, 0xB120);
	write_cmos_sensor(0x6F12, 0x5040);
	write_cmos_sensor(0x6F12, 0x84F8);
	write_cmos_sensor(0x6F12, 0x5C01);
	write_cmos_sensor(0x6F12, 0x84F8);
	write_cmos_sensor(0x6F12, 0x5D01);
	write_cmos_sensor(0x6F12, 0x95F8);
	write_cmos_sensor(0x6F12, 0x2020);
	write_cmos_sensor(0x6F12, 0x022A);
	write_cmos_sensor(0x6F12, 0x04D1);
	write_cmos_sensor(0x6F12, 0x19B1);
	write_cmos_sensor(0x6F12, 0x80EA);
	write_cmos_sensor(0x6F12, 0x0102);
	write_cmos_sensor(0x6F12, 0x84F8);
	write_cmos_sensor(0x6F12, 0x5C21);
	write_cmos_sensor(0x6F12, 0xA6F8);
	write_cmos_sensor(0x6F12, 0x6A02);
	write_cmos_sensor(0x6F12, 0x2948);
	write_cmos_sensor(0x6F12, 0x9030);
	write_cmos_sensor(0x6F12, 0x0646);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0x71F9);
	write_cmos_sensor(0x6F12, 0xC4F8);
	write_cmos_sensor(0x6F12, 0x6001);
	write_cmos_sensor(0x6F12, 0x3046);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0x71F9);
	write_cmos_sensor(0x6F12, 0xC4F8);
	write_cmos_sensor(0x6F12, 0x6401);
	write_cmos_sensor(0x6F12, 0x95F8);
	write_cmos_sensor(0x6F12, 0x2020);
	write_cmos_sensor(0x6F12, 0x2B4D);
	write_cmos_sensor(0x6F12, 0x022A);
	write_cmos_sensor(0x6F12, 0x3FD0);
	write_cmos_sensor(0x6F12, 0x94F8);
	write_cmos_sensor(0x6F12, 0x5C01);
	write_cmos_sensor(0x6F12, 0xE8B3);
	write_cmos_sensor(0x6F12, 0x0021);
	write_cmos_sensor(0x6F12, 0x95F8);
	write_cmos_sensor(0x6F12, 0xAB32);
	write_cmos_sensor(0x6F12, 0x5940);
	write_cmos_sensor(0x6F12, 0x94F8);
	write_cmos_sensor(0x6F12, 0xFC30);
	write_cmos_sensor(0x6F12, 0x5840);
	write_cmos_sensor(0x6F12, 0x14F8);
	write_cmos_sensor(0x6F12, 0xEB3F);
	write_cmos_sensor(0x6F12, 0x94F8);
	write_cmos_sensor(0x6F12, 0x3640);
	write_cmos_sensor(0x6F12, 0x2344);
	write_cmos_sensor(0x6F12, 0x9B07);
	write_cmos_sensor(0x6F12, 0x00D0);
	write_cmos_sensor(0x6F12, 0x0123);
	write_cmos_sensor(0x6F12, 0x95F8);
	write_cmos_sensor(0x6F12, 0xAA42);
	write_cmos_sensor(0x6F12, 0x6340);
	write_cmos_sensor(0x6F12, 0x5840);
	write_cmos_sensor(0x6F12, 0xA2B1);
	write_cmos_sensor(0x6F12, 0x40EA);
	write_cmos_sensor(0x6F12, 0x4100);
	write_cmos_sensor(0x6F12, 0x95F8);
	write_cmos_sensor(0x6F12, 0xC213);
	write_cmos_sensor(0x6F12, 0x40EA);
	write_cmos_sensor(0x6F12, 0x8100);
	write_cmos_sensor(0x6F12, 0x95F8);
	write_cmos_sensor(0x6F12, 0xC313);
	write_cmos_sensor(0x6F12, 0x40EA);
	write_cmos_sensor(0x6F12, 0xC100);
	write_cmos_sensor(0x6F12, 0x1A49);
	write_cmos_sensor(0x6F12, 0xA1F8);
	write_cmos_sensor(0x6F12, 0x4A03);
	write_cmos_sensor(0x6F12, 0x8915);
	write_cmos_sensor(0x6F12, 0x4AF2);
	write_cmos_sensor(0x6F12, 0x4A30);
	write_cmos_sensor(0x6F12, 0x022A);
	write_cmos_sensor(0x6F12, 0x34D0);
	write_cmos_sensor(0x6F12, 0x0022);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0x07F9);
	write_cmos_sensor(0x6F12, 0x0D48);
	write_cmos_sensor(0x6F12, 0x0022);
	write_cmos_sensor(0x6F12, 0x816A);
	write_cmos_sensor(0x6F12, 0x0C0C);
	write_cmos_sensor(0x6F12, 0x8DB2);
	write_cmos_sensor(0x6F12, 0x2946);
	write_cmos_sensor(0x6F12, 0x2046);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0xFEF8);
	write_cmos_sensor(0x6F12, 0x3946);
	write_cmos_sensor(0x6F12, 0x4046);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0x36F9);
	write_cmos_sensor(0x6F12, 0x2946);
	write_cmos_sensor(0x6F12, 0x2046);
	write_cmos_sensor(0x6F12, 0xBDE8);
	write_cmos_sensor(0x6F12, 0xF041);
	write_cmos_sensor(0x6F12, 0x0122);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0xF3B8);
	write_cmos_sensor(0x6F12, 0x16E0);
	write_cmos_sensor(0x6F12, 0x19E0);
	write_cmos_sensor(0x6F12, 0x2000);
	write_cmos_sensor(0x6F12, 0x1EB0);
	write_cmos_sensor(0x6F12, 0x2000);
	write_cmos_sensor(0x6F12, 0x19E0);
	write_cmos_sensor(0x6F12, 0x2000);
	write_cmos_sensor(0x6F12, 0x4A00);
	write_cmos_sensor(0x6F12, 0x2000);
	write_cmos_sensor(0x6F12, 0x3FF0);
	write_cmos_sensor(0x6F12, 0x2000);
	write_cmos_sensor(0x6F12, 0x0010);
	write_cmos_sensor(0x6F12, 0x2000);
	write_cmos_sensor(0x6F12, 0x0520);
	write_cmos_sensor(0x6F12, 0x2000);
	write_cmos_sensor(0x6F12, 0x2970);
	write_cmos_sensor(0x6F12, 0x4000);
	write_cmos_sensor(0x6F12, 0xF000);
	write_cmos_sensor(0x6F12, 0x2000);
	write_cmos_sensor(0x6F12, 0x05C0);
	write_cmos_sensor(0x6F12, 0x2000);
	write_cmos_sensor(0x6F12, 0x1350);
	write_cmos_sensor(0x6F12, 0x4000);
	write_cmos_sensor(0x6F12, 0xA000);
	write_cmos_sensor(0x6F12, 0x94F8);
	write_cmos_sensor(0x6F12, 0x5C11);
	write_cmos_sensor(0x6F12, 0x0846);
	write_cmos_sensor(0x6F12, 0xBAE7);
	write_cmos_sensor(0x6F12, 0x0121);
	write_cmos_sensor(0x6F12, 0xA5E7);
	write_cmos_sensor(0x6F12, 0x0122);
	write_cmos_sensor(0x6F12, 0xC9E7);
	write_cmos_sensor(0x6F12, 0x70B5);
	write_cmos_sensor(0x6F12, 0x0022);
	write_cmos_sensor(0x6F12, 0xAFF6);
	write_cmos_sensor(0x6F12, 0x4351);
	write_cmos_sensor(0x6F12, 0x4648);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0x0DF9);
	write_cmos_sensor(0x6F12, 0x464D);
	write_cmos_sensor(0x6F12, 0x0022);
	write_cmos_sensor(0x6F12, 0xAFF6);
	write_cmos_sensor(0x6F12, 0x0B51);
	write_cmos_sensor(0x6F12, 0x2860);
	write_cmos_sensor(0x6F12, 0x4448);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0x05F9);
	write_cmos_sensor(0x6F12, 0x0022);
	write_cmos_sensor(0x6F12, 0xAFF6);
	write_cmos_sensor(0x6F12, 0x3741);
	write_cmos_sensor(0x6F12, 0x6860);
	write_cmos_sensor(0x6F12, 0x4248);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0xFEF8);
	write_cmos_sensor(0x6F12, 0x0022);
	write_cmos_sensor(0x6F12, 0xAFF6);
	write_cmos_sensor(0x6F12, 0x1141);
	write_cmos_sensor(0x6F12, 0x4048);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0xF8F8);
	write_cmos_sensor(0x6F12, 0x0022);
	write_cmos_sensor(0x6F12, 0xAFF6);
	write_cmos_sensor(0x6F12, 0x7B31);
	write_cmos_sensor(0x6F12, 0xE860);
	write_cmos_sensor(0x6F12, 0x3D48);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0xF1F8);
	write_cmos_sensor(0x6F12, 0x0022);
	write_cmos_sensor(0x6F12, 0xAFF6);
	write_cmos_sensor(0x6F12, 0x1531);
	write_cmos_sensor(0x6F12, 0xA860);
	write_cmos_sensor(0x6F12, 0x3B48);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0xEAF8);
	write_cmos_sensor(0x6F12, 0x3A4C);
	write_cmos_sensor(0x6F12, 0x2861);
	write_cmos_sensor(0x6F12, 0x44F6);
	write_cmos_sensor(0x6F12, 0x9C60);
	write_cmos_sensor(0x6F12, 0xE18C);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0xE8F8);
	write_cmos_sensor(0x6F12, 0xE08C);
	write_cmos_sensor(0x6F12, 0x384E);
	write_cmos_sensor(0x6F12, 0x3749);
	write_cmos_sensor(0x6F12, 0x46F8);
	write_cmos_sensor(0x6F12, 0x2010);
	write_cmos_sensor(0x6F12, 0x401C);
	write_cmos_sensor(0x6F12, 0x81B2);
	write_cmos_sensor(0x6F12, 0xE184);
	write_cmos_sensor(0x6F12, 0x43F2);
	write_cmos_sensor(0x6F12, 0xAC00);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0xDCF8);
	write_cmos_sensor(0x6F12, 0xE08C);
	write_cmos_sensor(0x6F12, 0x3349);
	write_cmos_sensor(0x6F12, 0x46F8);
	write_cmos_sensor(0x6F12, 0x2010);
	write_cmos_sensor(0x6F12, 0x401C);
	write_cmos_sensor(0x6F12, 0x81B2);
	write_cmos_sensor(0x6F12, 0xE184);
	write_cmos_sensor(0x6F12, 0x43F2);
	write_cmos_sensor(0x6F12, 0xB000);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0xD1F8);
	write_cmos_sensor(0x6F12, 0xE08C);
	write_cmos_sensor(0x6F12, 0x2F49);
	write_cmos_sensor(0x6F12, 0x46F8);
	write_cmos_sensor(0x6F12, 0x2010);
	write_cmos_sensor(0x6F12, 0x401C);
	write_cmos_sensor(0x6F12, 0x81B2);
	write_cmos_sensor(0x6F12, 0xE184);
	write_cmos_sensor(0x6F12, 0x43F2);
	write_cmos_sensor(0x6F12, 0x1840);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0xC6F8);
	write_cmos_sensor(0x6F12, 0xE08C);
	write_cmos_sensor(0x6F12, 0x2A49);
	write_cmos_sensor(0x6F12, 0x46F8);
	write_cmos_sensor(0x6F12, 0x2010);
	write_cmos_sensor(0x6F12, 0x401C);
	write_cmos_sensor(0x6F12, 0x81B2);
	write_cmos_sensor(0x6F12, 0xE184);
	write_cmos_sensor(0x6F12, 0x43F2);
	write_cmos_sensor(0x6F12, 0x1C40);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0xBBF8);
	write_cmos_sensor(0x6F12, 0xE08C);
	write_cmos_sensor(0x6F12, 0x2649);
	write_cmos_sensor(0x6F12, 0x46F8);
	write_cmos_sensor(0x6F12, 0x2010);
	write_cmos_sensor(0x6F12, 0x401C);
	write_cmos_sensor(0x6F12, 0xE084);
	write_cmos_sensor(0x6F12, 0x0022);
	write_cmos_sensor(0x6F12, 0xAFF6);
	write_cmos_sensor(0x6F12, 0x5921);
	write_cmos_sensor(0x6F12, 0x2348);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0xAAF8);
	write_cmos_sensor(0x6F12, 0x224C);
	write_cmos_sensor(0x6F12, 0x6861);
	write_cmos_sensor(0x6F12, 0x4FF4);
	write_cmos_sensor(0x6F12, 0x8050);
	write_cmos_sensor(0x6F12, 0x24F8);
	write_cmos_sensor(0x6F12, 0xCE0F);
	write_cmos_sensor(0x6F12, 0x0022);
	write_cmos_sensor(0x6F12, 0x6081);
	write_cmos_sensor(0x6F12, 0xA082);
	write_cmos_sensor(0x6F12, 0xAFF2);
	write_cmos_sensor(0x6F12, 0xB151);
	write_cmos_sensor(0x6F12, 0x1E48);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0x9CF8);
	write_cmos_sensor(0x6F12, 0xE861);
	write_cmos_sensor(0x6F12, 0x0020);
	write_cmos_sensor(0x6F12, 0x24F8);
	write_cmos_sensor(0x6F12, 0xCE0C);
	write_cmos_sensor(0x6F12, 0x0246);
	write_cmos_sensor(0x6F12, 0xAFF2);
	write_cmos_sensor(0x6F12, 0x4751);
	write_cmos_sensor(0x6F12, 0x1A48);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0x92F8);
	write_cmos_sensor(0x6F12, 0x0022);
	write_cmos_sensor(0x6F12, 0xAFF2);
	write_cmos_sensor(0x6F12, 0xE321);
	write_cmos_sensor(0x6F12, 0x2862);
	write_cmos_sensor(0x6F12, 0x1748);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0x8BF8);
	write_cmos_sensor(0x6F12, 0x0022);
	write_cmos_sensor(0x6F12, 0xAFF2);
	write_cmos_sensor(0x6F12, 0x8121);
	write_cmos_sensor(0x6F12, 0x6862);
	write_cmos_sensor(0x6F12, 0x1548);
	write_cmos_sensor(0x6F12, 0x00F0);
	write_cmos_sensor(0x6F12, 0x84F8);
	write_cmos_sensor(0x6F12, 0xA862);
	write_cmos_sensor(0x6F12, 0x70BD);
	write_cmos_sensor(0x6F12, 0x0000);
	write_cmos_sensor(0x6F12, 0x333B);
	write_cmos_sensor(0x6F12, 0x2000);
	write_cmos_sensor(0x6F12, 0x3FF0);
	write_cmos_sensor(0x6F12, 0x0000);
	write_cmos_sensor(0x6F12, 0x3757);
	write_cmos_sensor(0x6F12, 0x0000);
	write_cmos_sensor(0x6F12, 0x7BED);
	write_cmos_sensor(0x6F12, 0x0000);
	write_cmos_sensor(0x6F12, 0xAC61);
	write_cmos_sensor(0x6F12, 0x0000);
	write_cmos_sensor(0x6F12, 0xA831);
	write_cmos_sensor(0x6F12, 0x0000);
	write_cmos_sensor(0x6F12, 0x9E01);
	write_cmos_sensor(0x6F12, 0x2000);
	write_cmos_sensor(0x6F12, 0x1E80);
	write_cmos_sensor(0x6F12, 0x9E04);
	write_cmos_sensor(0x6F12, 0x0BE0);
	write_cmos_sensor(0x6F12, 0x2000);
	write_cmos_sensor(0x6F12, 0x2E10);
	write_cmos_sensor(0x6F12, 0x18BF);
	write_cmos_sensor(0x6F12, 0x06F2);
	write_cmos_sensor(0x6F12, 0x0144);
	write_cmos_sensor(0x6F12, 0x04F5);
	write_cmos_sensor(0x6F12, 0x18BF);
	write_cmos_sensor(0x6F12, 0x0AF2);
	write_cmos_sensor(0x6F12, 0x0148);
	write_cmos_sensor(0x6F12, 0x1FFA);
	write_cmos_sensor(0x6F12, 0x0000);
	write_cmos_sensor(0x6F12, 0x79B3);
	write_cmos_sensor(0x6F12, 0x2000);
	write_cmos_sensor(0x6F12, 0x4A00);
	write_cmos_sensor(0x6F12, 0x0000);
	write_cmos_sensor(0x6F12, 0x3C7B);
	write_cmos_sensor(0x6F12, 0x0000);
	write_cmos_sensor(0x6F12, 0x0A65);
	write_cmos_sensor(0x6F12, 0x0000);
	write_cmos_sensor(0x6F12, 0x6979);
	write_cmos_sensor(0x6F12, 0x0000);
	write_cmos_sensor(0x6F12, 0x79D9);
	write_cmos_sensor(0x6F12, 0x43F2);
	write_cmos_sensor(0x6F12, 0x1B3C);
	write_cmos_sensor(0x6F12, 0xC0F2);
	write_cmos_sensor(0x6F12, 0x000C);
	write_cmos_sensor(0x6F12, 0x6047);
	write_cmos_sensor(0x6F12, 0x43F2);
	write_cmos_sensor(0x6F12, 0xC32C);
	write_cmos_sensor(0x6F12, 0xC0F2);
	write_cmos_sensor(0x6F12, 0x000C);
	write_cmos_sensor(0x6F12, 0x6047);
	write_cmos_sensor(0x6F12, 0x40F2);
	write_cmos_sensor(0x6F12, 0xF76C);
	write_cmos_sensor(0x6F12, 0xC0F2);
	write_cmos_sensor(0x6F12, 0x000C);
	write_cmos_sensor(0x6F12, 0x6047);
	write_cmos_sensor(0x6F12, 0x43F2);
	write_cmos_sensor(0x6F12, 0xBD6C);
	write_cmos_sensor(0x6F12, 0xC0F2);
	write_cmos_sensor(0x6F12, 0x000C);
	write_cmos_sensor(0x6F12, 0x6047);
	write_cmos_sensor(0x6F12, 0x43F2);
	write_cmos_sensor(0x6F12, 0x476C);
	write_cmos_sensor(0x6F12, 0xC0F2);
	write_cmos_sensor(0x6F12, 0x000C);
	write_cmos_sensor(0x6F12, 0x6047);
	write_cmos_sensor(0x6F12, 0x40F2);
	write_cmos_sensor(0x6F12, 0x777C);
	write_cmos_sensor(0x6F12, 0xC0F2);
	write_cmos_sensor(0x6F12, 0x000C);
	write_cmos_sensor(0x6F12, 0x6047);
	write_cmos_sensor(0x6F12, 0x4AF6);
	write_cmos_sensor(0x6F12, 0x614C);
	write_cmos_sensor(0x6F12, 0xC0F2);
	write_cmos_sensor(0x6F12, 0x000C);
	write_cmos_sensor(0x6F12, 0x6047);
	write_cmos_sensor(0x6F12, 0x4AF6);
	write_cmos_sensor(0x6F12, 0x310C);
	write_cmos_sensor(0x6F12, 0xC0F2);
	write_cmos_sensor(0x6F12, 0x000C);
	write_cmos_sensor(0x6F12, 0x6047);
	write_cmos_sensor(0x6F12, 0x47F6);
	write_cmos_sensor(0x6F12, 0xB31C);
	write_cmos_sensor(0x6F12, 0xC0F2);
	write_cmos_sensor(0x6F12, 0x000C);
	write_cmos_sensor(0x6F12, 0x6047);
	write_cmos_sensor(0x6F12, 0x43F6);
	write_cmos_sensor(0x6F12, 0xB53C);
	write_cmos_sensor(0x6F12, 0xC0F2);
	write_cmos_sensor(0x6F12, 0x000C);
	write_cmos_sensor(0x6F12, 0x6047);
	write_cmos_sensor(0x6F12, 0x40F2);
	write_cmos_sensor(0x6F12, 0xA90C);
	write_cmos_sensor(0x6F12, 0xC0F2);
	write_cmos_sensor(0x6F12, 0x000C);
	write_cmos_sensor(0x6F12, 0x6047);
	write_cmos_sensor(0x6F12, 0x43F6);
	write_cmos_sensor(0x6F12, 0x7B4C);
	write_cmos_sensor(0x6F12, 0xC0F2);
	write_cmos_sensor(0x6F12, 0x000C);
	write_cmos_sensor(0x6F12, 0x6047);
	write_cmos_sensor(0x6F12, 0x40F6);
	write_cmos_sensor(0x6F12, 0x2D2C);
	write_cmos_sensor(0x6F12, 0xC0F2);
	write_cmos_sensor(0x6F12, 0x000C);
	write_cmos_sensor(0x6F12, 0x6047);
	write_cmos_sensor(0x6F12, 0x46F6);
	write_cmos_sensor(0x6F12, 0x791C);
	write_cmos_sensor(0x6F12, 0xC0F2);
	write_cmos_sensor(0x6F12, 0x000C);
	write_cmos_sensor(0x6F12, 0x6047);
	write_cmos_sensor(0x6F12, 0x46F6);
	write_cmos_sensor(0x6F12, 0x6D1C);
	write_cmos_sensor(0x6F12, 0xC0F2);
	write_cmos_sensor(0x6F12, 0x000C);
	write_cmos_sensor(0x6F12, 0x6047);
	write_cmos_sensor(0x6F12, 0x47F6);
	write_cmos_sensor(0x6F12, 0xDB2C);
	write_cmos_sensor(0x6F12, 0xC0F2);
	write_cmos_sensor(0x6F12, 0x000C);
	write_cmos_sensor(0x6F12, 0x6047);
	write_cmos_sensor(0x6F12, 0x47F6);
	write_cmos_sensor(0x6F12, 0xC72C);
	write_cmos_sensor(0x6F12, 0xC0F2);
	write_cmos_sensor(0x6F12, 0x000C);
	write_cmos_sensor(0x6F12, 0x6047);
	write_cmos_sensor(0x6F12, 0x47F6);
	write_cmos_sensor(0x6F12, 0xD91C);
	write_cmos_sensor(0x6F12, 0xC0F2);
	write_cmos_sensor(0x6F12, 0x000C);
	write_cmos_sensor(0x6F12, 0x6047);
	write_cmos_sensor(0x6F12, 0x4DF2);
	write_cmos_sensor(0x6F12, 0x536C);
	write_cmos_sensor(0x6F12, 0xC0F2);
	write_cmos_sensor(0x6F12, 0x000C);
	write_cmos_sensor(0x6F12, 0x6047);
	write_cmos_sensor(0x6F12, 0x4DF2);
	write_cmos_sensor(0x6F12, 0xF35C);
	write_cmos_sensor(0x6F12, 0xC0F2);
	write_cmos_sensor(0x6F12, 0x000C);
	write_cmos_sensor(0x6F12, 0x6047);
	write_cmos_sensor(0x6F12, 0x0000);
	write_cmos_sensor(0x6F12, 0x0000);
	write_cmos_sensor(0x6F12, 0x0000);
	write_cmos_sensor(0x6F12, 0x0000);
	write_cmos_sensor(0x6F12, 0x30D3);
	write_cmos_sensor(0x6F12, 0x01C0);
	write_cmos_sensor(0x6F12, 0x0000);
	write_cmos_sensor(0x6F12, 0x0FFF);
	write_cmos_sensor(0x6028, 0x2000);
	write_cmos_sensor(0x602A, 0x1930);
	write_cmos_sensor(0x6F12, 0x0001);
	write_cmos_sensor(0x602A, 0x1940);
	write_cmos_sensor(0x6F12, 0x00AE);
	write_cmos_sensor(0x602A, 0x194A);
	write_cmos_sensor(0x6F12, 0x007A);
	write_cmos_sensor(0x602A, 0x1954);
	write_cmos_sensor(0x6F12, 0x0047);
	write_cmos_sensor(0x602A, 0x195E);
	write_cmos_sensor(0x6F12, 0x0066);
	write_cmos_sensor(0x602A, 0x1976);
	write_cmos_sensor(0x6F12, 0x00B8);
	write_cmos_sensor(0x602A, 0x1980);
	write_cmos_sensor(0x6F12, 0x003D);
	write_cmos_sensor(0x602A, 0x198A);
	write_cmos_sensor(0x6F12, 0x0014);
	write_cmos_sensor(0x602A, 0x1994);
	write_cmos_sensor(0x6F12, 0x001E);
	write_cmos_sensor(0x602A, 0x19AC);
	write_cmos_sensor(0x6F12, 0x0133);
	write_cmos_sensor(0x602A, 0x19B6);
	write_cmos_sensor(0x6F12, 0x0151);
	write_cmos_sensor(0x602A, 0x19C0);
	write_cmos_sensor(0x6F12, 0x0166);
	write_cmos_sensor(0x602A, 0x19CA);
	write_cmos_sensor(0x6F12, 0x0133);
	write_cmos_sensor(0x602A, 0x4ACC);
	write_cmos_sensor(0x6F12, 0x0172);
	write_cmos_sensor(0x602A, 0x4AD0);
	write_cmos_sensor(0x6F12, 0x0FEB);
	write_cmos_sensor(0x6F12, 0x0FF3);
	write_cmos_sensor(0x6F12, 0x1000);
	write_cmos_sensor(0x6F12, 0x1000);
	write_cmos_sensor(0x602A, 0x4ADA);
	write_cmos_sensor(0x6F12, 0x0FEB);
	write_cmos_sensor(0x6F12, 0x0FF3);
	write_cmos_sensor(0x6F12, 0x0FF3);
	write_cmos_sensor(0x6F12, 0x1000);
	write_cmos_sensor(0x602A, 0x4AE4);
	write_cmos_sensor(0x6F12, 0x0FD7);
	write_cmos_sensor(0x6F12, 0x0FCA);
	write_cmos_sensor(0x6F12, 0x0FAE);
	write_cmos_sensor(0x6F12, 0x0FAE);
	write_cmos_sensor(0x602A, 0x162C);
	write_cmos_sensor(0x6F12, 0x8080);
	write_cmos_sensor(0x602A, 0x164C);
	write_cmos_sensor(0x6F12, 0x5555);
	write_cmos_sensor(0x602A, 0x164E);
	write_cmos_sensor(0x6F12, 0x5500);
	write_cmos_sensor(0x602A, 0x166C);
	write_cmos_sensor(0x6F12, 0x4040);
	write_cmos_sensor(0x602A, 0x166E);
	write_cmos_sensor(0x6F12, 0x4040);
	write_cmos_sensor(0x6028, 0x4000);
	write_cmos_sensor(0x3D6C, 0x0080);
	write_cmos_sensor(0x3D64, 0x0105);
	write_cmos_sensor(0x3D66, 0x0105);
	write_cmos_sensor(0x3D6A, 0x0001);
	write_cmos_sensor(0x3D70, 0x0002);
	write_cmos_sensor(0xF496, 0x0048);
	write_cmos_sensor(0xF470, 0x0008);
	write_cmos_sensor(0xF43A, 0x0015);
	write_cmos_sensor(0x3676, 0x0008);
	write_cmos_sensor(0x3678, 0x0008);
	write_cmos_sensor(0x3AC8, 0x0A04);
	write_cmos_sensor(0x3D34, 0x0010);
	write_cmos_sensor(0x30A0, 0x0008);
	write_cmos_sensor(0x0112, 0x0A0A);
	write_cmos_sensor(0x322E, 0x000C);
	write_cmos_sensor(0x3230, 0x000C);
	write_cmos_sensor(0x3236, 0x000B);
	write_cmos_sensor(0x3238, 0x000B);
	write_cmos_sensor(0x32A6, 0x000C);
	write_cmos_sensor(0x32A8, 0x000C);
	write_cmos_sensor(0x3616, 0x0707);
	write_cmos_sensor(0x3622, 0x0808);
	write_cmos_sensor(0x3626, 0x0808);
	write_cmos_sensor(0x32EE, 0x0001);
	write_cmos_sensor(0x32F0, 0x0001);
	write_cmos_sensor(0x32F6, 0x0003);
	write_cmos_sensor(0x32F8, 0x0003);
	write_cmos_sensor(0x361E, 0x3030);
	write_cmos_sensor(0x362A, 0x0303);
	write_cmos_sensor(0x3664, 0x0019);
	write_cmos_sensor(0x3666, 0x030B);
	write_cmos_sensor(0x3670, 0x0001);
	write_cmos_sensor(0x31B6, 0x0008);
	write_cmos_sensor(0xF442, 0x44C6);
	write_cmos_sensor(0xF408, 0xFFF7);
	write_cmos_sensor(0xF47C, 0x001F);
	write_cmos_sensor(0x347E, 0x00CE);
	write_cmos_sensor(0x3480, 0x00CE);
	write_cmos_sensor(0x3482, 0x00E6);
	write_cmos_sensor(0x3484, 0x00E6);
	write_cmos_sensor(0x3486, 0x00FE);
	write_cmos_sensor(0x3488, 0x00FE);
	write_cmos_sensor(0x348A, 0x0116);
	write_cmos_sensor(0x348C, 0x0116);
	write_cmos_sensor(0xF636, 0x00D6);
	write_cmos_sensor(0xF638, 0x00DE);
	write_cmos_sensor(0xF63A, 0x00EE);
	write_cmos_sensor(0xF63C, 0x00F6);
	write_cmos_sensor(0xF63E, 0x0106);
	write_cmos_sensor(0xF640, 0x010E);
	write_cmos_sensor(0xF4D0, 0x0034);
	write_cmos_sensor(0xF4D8, 0x0034);

#else
	write_cmos_sensor(0X6028, 0X2000);
	write_cmos_sensor(0X602A, 0X303C);
	write_cmos_sensor(0X6F12, 0X0000);
	write_cmos_sensor(0X6F12, 0X0000);
	write_cmos_sensor(0X6F12, 0X0449);
	write_cmos_sensor(0X6F12, 0X0348);
	write_cmos_sensor(0X6F12, 0X044A);
	write_cmos_sensor(0X6F12, 0X0860);
	write_cmos_sensor(0X6F12, 0X101A);
	write_cmos_sensor(0X6F12, 0X8880);
	write_cmos_sensor(0X6F12, 0X00F0);
	write_cmos_sensor(0X6F12, 0X7DB9);
	write_cmos_sensor(0X6F12, 0X2000);
	write_cmos_sensor(0X6F12, 0X34F4);
	write_cmos_sensor(0X6F12, 0X2000);
	write_cmos_sensor(0X6F12, 0X1E80);
	write_cmos_sensor(0X6F12, 0X2000);
	write_cmos_sensor(0X6F12, 0X4A00);
	write_cmos_sensor(0X6F12, 0X0000);
	write_cmos_sensor(0X6F12, 0X0000);
	write_cmos_sensor(0X6F12, 0X70B5);
	write_cmos_sensor(0X6F12, 0XE74C);
	write_cmos_sensor(0X6F12, 0X0E46);
	write_cmos_sensor(0X6F12, 0XA4F8);
	write_cmos_sensor(0X6F12, 0X0001);
	write_cmos_sensor(0X6F12, 0XE64D);
	write_cmos_sensor(0X6F12, 0X15F8);
	write_cmos_sensor(0X6F12, 0X940F);
	write_cmos_sensor(0X6F12, 0XA4F8);
	write_cmos_sensor(0X6F12, 0X0601);
	write_cmos_sensor(0X6F12, 0X6878);
	write_cmos_sensor(0X6F12, 0XA4F8);
	write_cmos_sensor(0X6F12, 0X0801);
	write_cmos_sensor(0X6F12, 0X1046);
	write_cmos_sensor(0X6F12, 0X04F5);
	write_cmos_sensor(0X6F12, 0XE874);
	write_cmos_sensor(0X6F12, 0X00F0);
	write_cmos_sensor(0X6F12, 0XEEF9);
	write_cmos_sensor(0X6F12, 0X3046);
	write_cmos_sensor(0X6F12, 0X00F0);
	write_cmos_sensor(0X6F12, 0XF0F9);
	write_cmos_sensor(0X6F12, 0XB5F8);
	write_cmos_sensor(0X6F12, 0X9A01);
	write_cmos_sensor(0X6F12, 0X6086);
	write_cmos_sensor(0X6F12, 0XB5F8);
	write_cmos_sensor(0X6F12, 0X9E01);
	write_cmos_sensor(0X6F12, 0XE086);
	write_cmos_sensor(0X6F12, 0XB5F8);
	write_cmos_sensor(0X6F12, 0XA001);
	write_cmos_sensor(0X6F12, 0X2087);
	write_cmos_sensor(0X6F12, 0XB5F8);
	write_cmos_sensor(0X6F12, 0XA601);
	write_cmos_sensor(0X6F12, 0XE087);
	write_cmos_sensor(0X6F12, 0X70BD);
	write_cmos_sensor(0X6F12, 0X2DE9);
	write_cmos_sensor(0X6F12, 0XF05F);
	write_cmos_sensor(0X6F12, 0XD74A);
	write_cmos_sensor(0X6F12, 0XD849);
	write_cmos_sensor(0X6F12, 0XD54C);
	write_cmos_sensor(0X6F12, 0X0646);
	write_cmos_sensor(0X6F12, 0X92F8);
	write_cmos_sensor(0X6F12, 0XEC30);
	write_cmos_sensor(0X6F12, 0X0F89);
	write_cmos_sensor(0X6F12, 0X94F8);
	write_cmos_sensor(0X6F12, 0XBE00);
	write_cmos_sensor(0X6F12, 0X4FF4);
	write_cmos_sensor(0X6F12, 0X8079);
	write_cmos_sensor(0X6F12, 0X13B1);
	write_cmos_sensor(0X6F12, 0XA8B9);
	write_cmos_sensor(0X6F12, 0X4F46);
	write_cmos_sensor(0X6F12, 0X13E0);
	write_cmos_sensor(0X6F12, 0XD24B);
	write_cmos_sensor(0X6F12, 0X0968);
	write_cmos_sensor(0X6F12, 0X92F8);
	write_cmos_sensor(0X6F12, 0XED20);
	write_cmos_sensor(0X6F12, 0X1B6D);
	write_cmos_sensor(0X6F12, 0XB1FB);
	write_cmos_sensor(0X6F12, 0XF3F1);
	write_cmos_sensor(0X6F12, 0X7943);
	write_cmos_sensor(0X6F12, 0XD140);
	write_cmos_sensor(0X6F12, 0X8BB2);
	write_cmos_sensor(0X6F12, 0X30B1);
	write_cmos_sensor(0X6F12, 0X0022);
	write_cmos_sensor(0X6F12, 0X4FF4);
	write_cmos_sensor(0X6F12, 0X8051);
	write_cmos_sensor(0X6F12, 0X1846);
	write_cmos_sensor(0X6F12, 0X00F0);
	write_cmos_sensor(0X6F12, 0XC6F9);
	write_cmos_sensor(0X6F12, 0X00E0);
	write_cmos_sensor(0X6F12, 0X4846);
	write_cmos_sensor(0X6F12, 0X87B2);
	write_cmos_sensor(0X6F12, 0X3088);
	write_cmos_sensor(0X6F12, 0X18B1);
	write_cmos_sensor(0X6F12, 0X0121);
	write_cmos_sensor(0X6F12, 0XC748);
	write_cmos_sensor(0X6F12, 0X00F0);
	write_cmos_sensor(0X6F12, 0XC2F9);
	write_cmos_sensor(0X6F12, 0X0021);
	write_cmos_sensor(0X6F12, 0XC648);
	write_cmos_sensor(0X6F12, 0X00F0);
	write_cmos_sensor(0X6F12, 0XBEF9);
	write_cmos_sensor(0X6F12, 0XDFF8);
	write_cmos_sensor(0X6F12, 0X18A3);
	write_cmos_sensor(0X6F12, 0X0025);
	write_cmos_sensor(0X6F12, 0XA046);
	write_cmos_sensor(0X6F12, 0X4FF0);
	write_cmos_sensor(0X6F12, 0X010B);
	write_cmos_sensor(0X6F12, 0X3088);
	write_cmos_sensor(0X6F12, 0X70B1);
	write_cmos_sensor(0X6F12, 0X7088);
	write_cmos_sensor(0X6F12, 0X38B1);
	write_cmos_sensor(0X6F12, 0XF089);
	write_cmos_sensor(0X6F12, 0X06E0);
	write_cmos_sensor(0X6F12, 0X2A46);
	write_cmos_sensor(0X6F12, 0XBD49);
	write_cmos_sensor(0X6F12, 0X00F0);
	write_cmos_sensor(0X6F12, 0XB3F9);
	write_cmos_sensor(0X6F12, 0X0446);
	write_cmos_sensor(0X6F12, 0X05E0);
	write_cmos_sensor(0X6F12, 0XB089);
	write_cmos_sensor(0X6F12, 0X0028);
	write_cmos_sensor(0X6F12, 0XF6D1);
	write_cmos_sensor(0X6F12, 0X3846);
	write_cmos_sensor(0X6F12, 0XF4E7);
	write_cmos_sensor(0X6F12, 0X4C46);
	write_cmos_sensor(0X6F12, 0X98F8);
	write_cmos_sensor(0X6F12, 0XBE00);
	write_cmos_sensor(0X6F12, 0X28B1);
	write_cmos_sensor(0X6F12, 0X2A46);
	write_cmos_sensor(0X6F12, 0XB749);
	write_cmos_sensor(0X6F12, 0X3846);
	write_cmos_sensor(0X6F12, 0X00F0);
	write_cmos_sensor(0X6F12, 0XA3F9);
	write_cmos_sensor(0X6F12, 0X00E0);
	write_cmos_sensor(0X6F12, 0X4846);
	write_cmos_sensor(0X6F12, 0XAAF8);
	write_cmos_sensor(0X6F12, 0X5802);
	write_cmos_sensor(0X6F12, 0X4443);
	write_cmos_sensor(0X6F12, 0X98F8);
	write_cmos_sensor(0X6F12, 0X2B02);
	write_cmos_sensor(0X6F12, 0X98F8);
	write_cmos_sensor(0X6F12, 0X2922);
	write_cmos_sensor(0X6F12, 0XC440);
	write_cmos_sensor(0X6F12, 0X0244);
	write_cmos_sensor(0X6F12, 0X0BFA);
	write_cmos_sensor(0X6F12, 0X02F0);
	write_cmos_sensor(0X6F12, 0X421E);
	write_cmos_sensor(0X6F12, 0XA242);
	write_cmos_sensor(0X6F12, 0X01DA);
	write_cmos_sensor(0X6F12, 0X1346);
	write_cmos_sensor(0X6F12, 0X00E0);
	write_cmos_sensor(0X6F12, 0X2346);
	write_cmos_sensor(0X6F12, 0X002B);
	write_cmos_sensor(0X6F12, 0X01DA);
	write_cmos_sensor(0X6F12, 0X0024);
	write_cmos_sensor(0X6F12, 0X02E0);
	write_cmos_sensor(0X6F12, 0XA242);
	write_cmos_sensor(0X6F12, 0X00DA);
	write_cmos_sensor(0X6F12, 0X1446);
	write_cmos_sensor(0X6F12, 0X0AEB);
	write_cmos_sensor(0X6F12, 0X4500);
	write_cmos_sensor(0X6F12, 0X6D1C);
	write_cmos_sensor(0X6F12, 0XA0F8);
	write_cmos_sensor(0X6F12, 0X5A42);
	write_cmos_sensor(0X6F12, 0X042D);
	write_cmos_sensor(0X6F12, 0XC4DB);
	write_cmos_sensor(0X6F12, 0XBDE8);
	write_cmos_sensor(0X6F12, 0XF09F);
	write_cmos_sensor(0X6F12, 0XA14A);
	write_cmos_sensor(0X6F12, 0X92F8);
	write_cmos_sensor(0X6F12, 0XB330);
	write_cmos_sensor(0X6F12, 0X53B1);
	write_cmos_sensor(0X6F12, 0X92F8);
	write_cmos_sensor(0X6F12, 0XFD20);
	write_cmos_sensor(0X6F12, 0X0420);
	write_cmos_sensor(0X6F12, 0X52B1);
	write_cmos_sensor(0X6F12, 0XA14A);
	write_cmos_sensor(0X6F12, 0X92F8);
	write_cmos_sensor(0X6F12, 0X3221);
	write_cmos_sensor(0X6F12, 0X012A);
	write_cmos_sensor(0X6F12, 0X05D1);
	write_cmos_sensor(0X6F12, 0X0220);
	write_cmos_sensor(0X6F12, 0X03E0);
	write_cmos_sensor(0X6F12, 0X5379);
	write_cmos_sensor(0X6F12, 0X2BB9);
	write_cmos_sensor(0X6F12, 0X20B1);
	write_cmos_sensor(0X6F12, 0X0020);
	write_cmos_sensor(0X6F12, 0X8842);
	write_cmos_sensor(0X6F12, 0X00D8);
	write_cmos_sensor(0X6F12, 0X0846);
	write_cmos_sensor(0X6F12, 0X7047);
	write_cmos_sensor(0X6F12, 0X1078);
	write_cmos_sensor(0X6F12, 0XF9E7);
	write_cmos_sensor(0X6F12, 0XFEB5);
	write_cmos_sensor(0X6F12, 0X0646);
	write_cmos_sensor(0X6F12, 0X9948);
	write_cmos_sensor(0X6F12, 0X0022);
	write_cmos_sensor(0X6F12, 0XC068);
	write_cmos_sensor(0X6F12, 0X84B2);
	write_cmos_sensor(0X6F12, 0X050C);
	write_cmos_sensor(0X6F12, 0X2146);
	write_cmos_sensor(0X6F12, 0X2846);
	write_cmos_sensor(0X6F12, 0X00F0);
	write_cmos_sensor(0X6F12, 0X61F9);
	write_cmos_sensor(0X6F12, 0X3046);
	write_cmos_sensor(0X6F12, 0X00F0);
	write_cmos_sensor(0X6F12, 0X63F9);
	write_cmos_sensor(0X6F12, 0X8E4E);
	write_cmos_sensor(0X6F12, 0X0020);
	write_cmos_sensor(0X6F12, 0X8DF8);
	write_cmos_sensor(0X6F12, 0X0000);
	write_cmos_sensor(0X6F12, 0X96F8);
	write_cmos_sensor(0X6F12, 0XFD00);
	write_cmos_sensor(0X6F12, 0X8DF8);
	write_cmos_sensor(0X6F12, 0X0100);
	write_cmos_sensor(0X6F12, 0X96F8);
	write_cmos_sensor(0X6F12, 0XB310);
	write_cmos_sensor(0X6F12, 0X8D4F);
	write_cmos_sensor(0X6F12, 0X19B1);
	write_cmos_sensor(0X6F12, 0X97F8);
	write_cmos_sensor(0X6F12, 0X3221);
	write_cmos_sensor(0X6F12, 0X012A);
	write_cmos_sensor(0X6F12, 0X0FD0);
	write_cmos_sensor(0X6F12, 0X0023);
	write_cmos_sensor(0X6F12, 0X0122);
	write_cmos_sensor(0X6F12, 0X0292);
	write_cmos_sensor(0X6F12, 0X0192);
	write_cmos_sensor(0X6F12, 0X21B1);
	write_cmos_sensor(0X6F12, 0X18B1);
	write_cmos_sensor(0X6F12, 0X97F8);
	write_cmos_sensor(0X6F12, 0X3201);
	write_cmos_sensor(0X6F12, 0X0128);
	write_cmos_sensor(0X6F12, 0X07D0);
	write_cmos_sensor(0X6F12, 0X96F8);
	write_cmos_sensor(0X6F12, 0X6801);
	write_cmos_sensor(0X6F12, 0X4208);
	write_cmos_sensor(0X6F12, 0X33B1);
	write_cmos_sensor(0X6F12, 0X0020);
	write_cmos_sensor(0X6F12, 0X06E0);
	write_cmos_sensor(0X6F12, 0X0123);
	write_cmos_sensor(0X6F12, 0XEEE7);
	write_cmos_sensor(0X6F12, 0X96F8);
	write_cmos_sensor(0X6F12, 0X6821);
	write_cmos_sensor(0X6F12, 0XF7E7);
	write_cmos_sensor(0X6F12, 0X96F8);
	write_cmos_sensor(0X6F12, 0XA400);
	write_cmos_sensor(0X6F12, 0X4100);
	write_cmos_sensor(0X6F12, 0X002A);
	write_cmos_sensor(0X6F12, 0X02D0);
	write_cmos_sensor(0X6F12, 0X4FF0);
	write_cmos_sensor(0X6F12, 0X0200);
	write_cmos_sensor(0X6F12, 0X01E0);
	write_cmos_sensor(0X6F12, 0X4FF0);
	write_cmos_sensor(0X6F12, 0X0000);
	write_cmos_sensor(0X6F12, 0X41EA);
	write_cmos_sensor(0X6F12, 0X4020);
	write_cmos_sensor(0X6F12, 0X7B49);
	write_cmos_sensor(0X6F12, 0XA1F8);
	write_cmos_sensor(0X6F12, 0X5201);
	write_cmos_sensor(0X6F12, 0X07D0);
	write_cmos_sensor(0X6F12, 0X7A48);
	write_cmos_sensor(0X6F12, 0X6B46);
	write_cmos_sensor(0X6F12, 0XB0F8);
	write_cmos_sensor(0X6F12, 0X4810);
	write_cmos_sensor(0X6F12, 0X4FF2);
	write_cmos_sensor(0X6F12, 0X5010);
	write_cmos_sensor(0X6F12, 0X00F0);
	write_cmos_sensor(0X6F12, 0X2BF9);
	write_cmos_sensor(0X6F12, 0X0122);
	write_cmos_sensor(0X6F12, 0X2146);
	write_cmos_sensor(0X6F12, 0X2846);
	write_cmos_sensor(0X6F12, 0X00F0);
	write_cmos_sensor(0X6F12, 0X1CF9);
	write_cmos_sensor(0X6F12, 0XFEBD);
	write_cmos_sensor(0X6F12, 0X2DE9);
	write_cmos_sensor(0X6F12, 0XF047);
	write_cmos_sensor(0X6F12, 0X0546);
	write_cmos_sensor(0X6F12, 0X7048);
	write_cmos_sensor(0X6F12, 0X9046);
	write_cmos_sensor(0X6F12, 0X8946);
	write_cmos_sensor(0X6F12, 0X8068);
	write_cmos_sensor(0X6F12, 0X1C46);
	write_cmos_sensor(0X6F12, 0X86B2);
	write_cmos_sensor(0X6F12, 0X070C);
	write_cmos_sensor(0X6F12, 0X0022);
	write_cmos_sensor(0X6F12, 0X3146);
	write_cmos_sensor(0X6F12, 0X3846);
	write_cmos_sensor(0X6F12, 0X00F0);
	write_cmos_sensor(0X6F12, 0X0CF9);
	write_cmos_sensor(0X6F12, 0X2346);
	write_cmos_sensor(0X6F12, 0X4246);
	write_cmos_sensor(0X6F12, 0X4946);
	write_cmos_sensor(0X6F12, 0X2846);
	write_cmos_sensor(0X6F12, 0X00F0);
	write_cmos_sensor(0X6F12, 0X10F9);
	write_cmos_sensor(0X6F12, 0X6248);
	write_cmos_sensor(0X6F12, 0X90F8);
	write_cmos_sensor(0X6F12, 0XB310);
	write_cmos_sensor(0X6F12, 0XD1B1);
	write_cmos_sensor(0X6F12, 0X90F8);
	write_cmos_sensor(0X6F12, 0XFD00);
	write_cmos_sensor(0X6F12, 0XB8B1);
	write_cmos_sensor(0X6F12, 0X0020);
	write_cmos_sensor(0X6F12, 0XA5F5);
	write_cmos_sensor(0X6F12, 0X7141);
	write_cmos_sensor(0X6F12, 0X05F1);
	write_cmos_sensor(0X6F12, 0X8044);
	write_cmos_sensor(0X6F12, 0X9039);
	write_cmos_sensor(0X6F12, 0X02D0);
	write_cmos_sensor(0X6F12, 0X4031);
	write_cmos_sensor(0X6F12, 0X02D0);
	write_cmos_sensor(0X6F12, 0X0DE0);
	write_cmos_sensor(0X6F12, 0XA081);
	write_cmos_sensor(0X6F12, 0X0BE0);
	write_cmos_sensor(0X6F12, 0XA081);
	write_cmos_sensor(0X6F12, 0X5C48);
	write_cmos_sensor(0X6F12, 0X90F8);
	write_cmos_sensor(0X6F12, 0X3201);
	write_cmos_sensor(0X6F12, 0X0128);
	write_cmos_sensor(0X6F12, 0X05D1);
	write_cmos_sensor(0X6F12, 0X0220);
	write_cmos_sensor(0X6F12, 0XA080);
	write_cmos_sensor(0X6F12, 0X2D20);
	write_cmos_sensor(0X6F12, 0X2081);
	write_cmos_sensor(0X6F12, 0X2E20);
	write_cmos_sensor(0X6F12, 0X6081);
	write_cmos_sensor(0X6F12, 0X3146);
	write_cmos_sensor(0X6F12, 0X3846);
	write_cmos_sensor(0X6F12, 0XBDE8);
	write_cmos_sensor(0X6F12, 0XF047);
	write_cmos_sensor(0X6F12, 0X0122);
	write_cmos_sensor(0X6F12, 0X00F0);
	write_cmos_sensor(0X6F12, 0XE0B8);
	write_cmos_sensor(0X6F12, 0X2DE9);
	write_cmos_sensor(0X6F12, 0XF041);
	write_cmos_sensor(0X6F12, 0X0546);
	write_cmos_sensor(0X6F12, 0X4D48);
	write_cmos_sensor(0X6F12, 0X4C4B);
	write_cmos_sensor(0X6F12, 0X0C46);
	write_cmos_sensor(0X6F12, 0X90F8);
	write_cmos_sensor(0X6F12, 0X5C11);
	write_cmos_sensor(0X6F12, 0X93F8);
	write_cmos_sensor(0X6F12, 0X4460);
	write_cmos_sensor(0X6F12, 0X90F8);
	write_cmos_sensor(0X6F12, 0XFD00);
	write_cmos_sensor(0X6F12, 0X0022);
	write_cmos_sensor(0X6F12, 0X26B1);
	write_cmos_sensor(0X6F12, 0X09B1);
	write_cmos_sensor(0X6F12, 0X0222);
	write_cmos_sensor(0X6F12, 0X01E0);
	write_cmos_sensor(0X6F12, 0X00B1);
	write_cmos_sensor(0X6F12, 0X0122);
	write_cmos_sensor(0X6F12, 0X4B4E);
	write_cmos_sensor(0X6F12, 0XA6F8);
	write_cmos_sensor(0X6F12, 0X4622);
	write_cmos_sensor(0X6F12, 0X93F8);
	write_cmos_sensor(0X6F12, 0X2030);
	write_cmos_sensor(0X6F12, 0X0022);
	write_cmos_sensor(0X6F12, 0X23B1);
	write_cmos_sensor(0X6F12, 0X09B1);
	write_cmos_sensor(0X6F12, 0X0222);
	write_cmos_sensor(0X6F12, 0X01E0);
	write_cmos_sensor(0X6F12, 0X00B1);
	write_cmos_sensor(0X6F12, 0X0122);
	write_cmos_sensor(0X6F12, 0XCAB1);
	write_cmos_sensor(0X6F12, 0X0022);
	write_cmos_sensor(0X6F12, 0X0221);
	write_cmos_sensor(0X6F12, 0X47F2);
	write_cmos_sensor(0X6F12, 0XC600);
	write_cmos_sensor(0X6F12, 0X00F0);
	write_cmos_sensor(0X6F12, 0XBAF8);
	write_cmos_sensor(0X6F12, 0X4148);
	write_cmos_sensor(0X6F12, 0X0022);
	write_cmos_sensor(0X6F12, 0X0069);
	write_cmos_sensor(0X6F12, 0X87B2);
	write_cmos_sensor(0X6F12, 0X060C);
	write_cmos_sensor(0X6F12, 0X3946);
	write_cmos_sensor(0X6F12, 0X3046);
	write_cmos_sensor(0X6F12, 0X00F0);
	write_cmos_sensor(0X6F12, 0XB1F8);
	write_cmos_sensor(0X6F12, 0X2146);
	write_cmos_sensor(0X6F12, 0X2846);
	write_cmos_sensor(0X6F12, 0X00F0);
	write_cmos_sensor(0X6F12, 0XBCF8);
	write_cmos_sensor(0X6F12, 0X3946);
	write_cmos_sensor(0X6F12, 0X3046);
	write_cmos_sensor(0X6F12, 0XBDE8);
	write_cmos_sensor(0X6F12, 0XF041);
	write_cmos_sensor(0X6F12, 0X0122);
	write_cmos_sensor(0X6F12, 0X00F0);
	write_cmos_sensor(0X6F12, 0XA6B8);
	write_cmos_sensor(0X6F12, 0X0122);
	write_cmos_sensor(0X6F12, 0XE4E7);
	write_cmos_sensor(0X6F12, 0X70B5);
	write_cmos_sensor(0X6F12, 0X0022);
	write_cmos_sensor(0X6F12, 0XAFF2);
	write_cmos_sensor(0X6F12, 0XEF21);
	write_cmos_sensor(0X6F12, 0X3748);
	write_cmos_sensor(0X6F12, 0X00F0);
	write_cmos_sensor(0X6F12, 0XB1F8);
	write_cmos_sensor(0X6F12, 0X324D);
	write_cmos_sensor(0X6F12, 0X0022);
	write_cmos_sensor(0X6F12, 0XAFF2);
	write_cmos_sensor(0X6F12, 0XBB21);
	write_cmos_sensor(0X6F12, 0X2860);
	write_cmos_sensor(0X6F12, 0X3448);
	write_cmos_sensor(0X6F12, 0X00F0);
	write_cmos_sensor(0X6F12, 0XA9F8);
	write_cmos_sensor(0X6F12, 0X0022);
	write_cmos_sensor(0X6F12, 0XAFF2);
	write_cmos_sensor(0X6F12, 0XE311);
	write_cmos_sensor(0X6F12, 0X6860);
	write_cmos_sensor(0X6F12, 0X3148);
	write_cmos_sensor(0X6F12, 0X00F0);
	write_cmos_sensor(0X6F12, 0XA2F8);
	write_cmos_sensor(0X6F12, 0X0022);
	write_cmos_sensor(0X6F12, 0XAFF2);
	write_cmos_sensor(0X6F12, 0XC111);
	write_cmos_sensor(0X6F12, 0X2F48);
	write_cmos_sensor(0X6F12, 0X00F0);
	write_cmos_sensor(0X6F12, 0X9CF8);
	write_cmos_sensor(0X6F12, 0X0022);
	write_cmos_sensor(0X6F12, 0XAFF2);
	write_cmos_sensor(0X6F12, 0X2B11);
	write_cmos_sensor(0X6F12, 0XE860);
	write_cmos_sensor(0X6F12, 0X2D48);
	write_cmos_sensor(0X6F12, 0X00F0);
	write_cmos_sensor(0X6F12, 0X95F8);
	write_cmos_sensor(0X6F12, 0X2C4C);
	write_cmos_sensor(0X6F12, 0XA860);
	write_cmos_sensor(0X6F12, 0X43F2);
	write_cmos_sensor(0X6F12, 0XAC00);
	write_cmos_sensor(0X6F12, 0XE18C);
	write_cmos_sensor(0X6F12, 0X00F0);
	write_cmos_sensor(0X6F12, 0X93F8);
	write_cmos_sensor(0X6F12, 0XE08C);
	write_cmos_sensor(0X6F12, 0X2A4E);
	write_cmos_sensor(0X6F12, 0X2949);
	write_cmos_sensor(0X6F12, 0X46F8);
	write_cmos_sensor(0X6F12, 0X2010);
	write_cmos_sensor(0X6F12, 0X401C);
	write_cmos_sensor(0X6F12, 0X81B2);
	write_cmos_sensor(0X6F12, 0XE184);
	write_cmos_sensor(0X6F12, 0X43F2);
	write_cmos_sensor(0X6F12, 0XB000);
	write_cmos_sensor(0X6F12, 0X00F0);
	write_cmos_sensor(0X6F12, 0X87F8);
	write_cmos_sensor(0X6F12, 0XE08C);
	write_cmos_sensor(0X6F12, 0X2549);
	write_cmos_sensor(0X6F12, 0X46F8);
	write_cmos_sensor(0X6F12, 0X2010);
	write_cmos_sensor(0X6F12, 0X401C);
	write_cmos_sensor(0X6F12, 0X81B2);
	write_cmos_sensor(0X6F12, 0XE184);
	write_cmos_sensor(0X6F12, 0X43F2);
	write_cmos_sensor(0X6F12, 0X1840);
	write_cmos_sensor(0X6F12, 0X00F0);
	write_cmos_sensor(0X6F12, 0X7CF8);
	write_cmos_sensor(0X6F12, 0XE08C);
	write_cmos_sensor(0X6F12, 0X2149);
	write_cmos_sensor(0X6F12, 0X46F8);
	write_cmos_sensor(0X6F12, 0X2010);
	write_cmos_sensor(0X6F12, 0X401C);
	write_cmos_sensor(0X6F12, 0X81B2);
	write_cmos_sensor(0X6F12, 0XE184);
	write_cmos_sensor(0X6F12, 0X43F2);
	write_cmos_sensor(0X6F12, 0X1C40);
	write_cmos_sensor(0X6F12, 0X00F0);
	write_cmos_sensor(0X6F12, 0X71F8);
	write_cmos_sensor(0X6F12, 0XE08C);
	write_cmos_sensor(0X6F12, 0X1C49);
	write_cmos_sensor(0X6F12, 0X46F8);
	write_cmos_sensor(0X6F12, 0X2010);
	write_cmos_sensor(0X6F12, 0X401C);
	write_cmos_sensor(0X6F12, 0XE084);
	write_cmos_sensor(0X6F12, 0X0022);
	write_cmos_sensor(0X6F12, 0XAFF2);
	write_cmos_sensor(0X6F12, 0X2111);
	write_cmos_sensor(0X6F12, 0X1948);
	write_cmos_sensor(0X6F12, 0X00F0);
	write_cmos_sensor(0X6F12, 0X60F8);
	write_cmos_sensor(0X6F12, 0X2861);
	write_cmos_sensor(0X6F12, 0X70BD);
	write_cmos_sensor(0X6F12, 0X0000);
	write_cmos_sensor(0X6F12, 0X4000);
	write_cmos_sensor(0X6F12, 0XE000);
	write_cmos_sensor(0X6F12, 0X2000);
	write_cmos_sensor(0X6F12, 0X1350);
	write_cmos_sensor(0X6F12, 0X2000);
	write_cmos_sensor(0X6F12, 0X4A00);
	write_cmos_sensor(0X6F12, 0X2000);
	write_cmos_sensor(0X6F12, 0X2970);
	write_cmos_sensor(0X6F12, 0X2000);
	write_cmos_sensor(0X6F12, 0X1EB0);
	write_cmos_sensor(0X6F12, 0X2000);
	write_cmos_sensor(0X6F12, 0X1BAA);
	write_cmos_sensor(0X6F12, 0X2000);
	write_cmos_sensor(0X6F12, 0X1B58);
	write_cmos_sensor(0X6F12, 0X2000);
	write_cmos_sensor(0X6F12, 0X2530);
	write_cmos_sensor(0X6F12, 0X2000);
	write_cmos_sensor(0X6F12, 0X1CC0);
	write_cmos_sensor(0X6F12, 0X2000);
	write_cmos_sensor(0X6F12, 0X34E0);
	write_cmos_sensor(0X6F12, 0X4000);
	write_cmos_sensor(0X6F12, 0XF000);
	write_cmos_sensor(0X6F12, 0X2000);
	write_cmos_sensor(0X6F12, 0X05C0);
	write_cmos_sensor(0X6F12, 0X0000);
	write_cmos_sensor(0X6F12, 0X333B);
	write_cmos_sensor(0X6F12, 0X0000);
	write_cmos_sensor(0X6F12, 0X3757);
	write_cmos_sensor(0X6F12, 0X0000);
	write_cmos_sensor(0X6F12, 0X7BED);
	write_cmos_sensor(0X6F12, 0X0000);
	write_cmos_sensor(0X6F12, 0XAC61);
	write_cmos_sensor(0X6F12, 0X0000);
	write_cmos_sensor(0X6F12, 0XA831);
	write_cmos_sensor(0X6F12, 0X2000);
	write_cmos_sensor(0X6F12, 0X1E80);
	write_cmos_sensor(0X6F12, 0X18BF);
	write_cmos_sensor(0X6F12, 0X06F2);
	write_cmos_sensor(0X6F12, 0X2000);
	write_cmos_sensor(0X6F12, 0X2E10);
	write_cmos_sensor(0X6F12, 0X0144);
	write_cmos_sensor(0X6F12, 0X04F5);
	write_cmos_sensor(0X6F12, 0X18BF);
	write_cmos_sensor(0X6F12, 0X0AF2);
	write_cmos_sensor(0X6F12, 0X0148);
	write_cmos_sensor(0X6F12, 0X1FFA);
	write_cmos_sensor(0X6F12, 0X0000);
	write_cmos_sensor(0X6F12, 0X79D9);
	write_cmos_sensor(0X6F12, 0X43F2);
	write_cmos_sensor(0X6F12, 0X1B3C);
	write_cmos_sensor(0X6F12, 0XC0F2);
	write_cmos_sensor(0X6F12, 0X000C);
	write_cmos_sensor(0X6F12, 0X6047);
	write_cmos_sensor(0X6F12, 0X43F2);
	write_cmos_sensor(0X6F12, 0XC32C);
	write_cmos_sensor(0X6F12, 0XC0F2);
	write_cmos_sensor(0X6F12, 0X000C);
	write_cmos_sensor(0X6F12, 0X6047);
	write_cmos_sensor(0X6F12, 0X40F2);
	write_cmos_sensor(0X6F12, 0XF76C);
	write_cmos_sensor(0X6F12, 0XC0F2);
	write_cmos_sensor(0X6F12, 0X000C);
	write_cmos_sensor(0X6F12, 0X6047);
	write_cmos_sensor(0X6F12, 0X43F2);
	write_cmos_sensor(0X6F12, 0XBD6C);
	write_cmos_sensor(0X6F12, 0XC0F2);
	write_cmos_sensor(0X6F12, 0X000C);
	write_cmos_sensor(0X6F12, 0X6047);
	write_cmos_sensor(0X6F12, 0X43F2);
	write_cmos_sensor(0X6F12, 0X476C);
	write_cmos_sensor(0X6F12, 0XC0F2);
	write_cmos_sensor(0X6F12, 0X000C);
	write_cmos_sensor(0X6F12, 0X6047);
	write_cmos_sensor(0X6F12, 0X40F2);
	write_cmos_sensor(0X6F12, 0X777C);
	write_cmos_sensor(0X6F12, 0XC0F2);
	write_cmos_sensor(0X6F12, 0X000C);
	write_cmos_sensor(0X6F12, 0X6047);
	write_cmos_sensor(0X6F12, 0X4AF6);
	write_cmos_sensor(0X6F12, 0X614C);
	write_cmos_sensor(0X6F12, 0XC0F2);
	write_cmos_sensor(0X6F12, 0X000C);
	write_cmos_sensor(0X6F12, 0X6047);
	write_cmos_sensor(0X6F12, 0X4AF6);
	write_cmos_sensor(0X6F12, 0X310C);
	write_cmos_sensor(0X6F12, 0XC0F2);
	write_cmos_sensor(0X6F12, 0X000C);
	write_cmos_sensor(0X6F12, 0X6047);
	write_cmos_sensor(0X6F12, 0X47F6);
	write_cmos_sensor(0X6F12, 0XD91C);
	write_cmos_sensor(0X6F12, 0XC0F2);
	write_cmos_sensor(0X6F12, 0X000C);
	write_cmos_sensor(0X6F12, 0X6047);
	write_cmos_sensor(0X6F12, 0X4DF2);
	write_cmos_sensor(0X6F12, 0X536C);
	write_cmos_sensor(0X6F12, 0XC0F2);
	write_cmos_sensor(0X6F12, 0X000C);
	write_cmos_sensor(0X6F12, 0X6047);
	write_cmos_sensor(0X6F12, 0X4DF2);
	write_cmos_sensor(0X6F12, 0XF35C);
	write_cmos_sensor(0X6F12, 0XC0F2);
	write_cmos_sensor(0X6F12, 0X000C);
	write_cmos_sensor(0X6F12, 0X6047);
	write_cmos_sensor(0X6F12, 0X0000);
	write_cmos_sensor(0X6F12, 0X30D3);
	write_cmos_sensor(0X6F12, 0X0244);
	write_cmos_sensor(0X6F12, 0X0000);
	write_cmos_sensor(0X6F12, 0X060D);
	write_cmos_sensor(0X602A, 0X4ACC);
	write_cmos_sensor(0X6F12, 0X0172);
	write_cmos_sensor(0X602A, 0X4AD0);
	write_cmos_sensor(0X6F12, 0X0FEB);
	write_cmos_sensor(0X6F12, 0X0FF3);
	write_cmos_sensor(0X6F12, 0X1000);
	write_cmos_sensor(0X6F12, 0X1000);
	write_cmos_sensor(0X602A, 0X4ADA);
	write_cmos_sensor(0X6F12, 0X0FEB);
	write_cmos_sensor(0X6F12, 0X0FF3);
	write_cmos_sensor(0X6F12, 0X0FF3);
	write_cmos_sensor(0X6F12, 0X1000);
	write_cmos_sensor(0X602A, 0X4AE4);
	write_cmos_sensor(0X6F12, 0X0FD7);
	write_cmos_sensor(0X6F12, 0X0FCA);
	write_cmos_sensor(0X6F12, 0X0FAE);
	write_cmos_sensor(0X6F12, 0X0FAE);
	write_cmos_sensor(0X602A, 0X162C);
	write_cmos_sensor(0X6F12, 0X8080);
	write_cmos_sensor(0X602A, 0X164C);
	write_cmos_sensor(0X6F12, 0X5555);
	write_cmos_sensor(0X602A, 0X164E);
	write_cmos_sensor(0X6F12, 0X5500);
	write_cmos_sensor(0X602A, 0X166C);
	write_cmos_sensor(0X6F12, 0X4040);
	write_cmos_sensor(0X602A, 0X166E);
	write_cmos_sensor(0X6F12, 0X4040);
	write_cmos_sensor(0X6028, 0X4000);
	write_cmos_sensor(0X3D6C, 0X0080);
	write_cmos_sensor(0X3D64, 0X0105);
	write_cmos_sensor(0X3D66, 0X0105);
	write_cmos_sensor(0X3D6A, 0X0001);
	write_cmos_sensor(0X3D70, 0X0002);
	write_cmos_sensor(0XF496, 0X0048);
	write_cmos_sensor(0XF470, 0X0008);
	write_cmos_sensor(0XF43A, 0X0015);
	write_cmos_sensor(0X3676, 0X0008);
	write_cmos_sensor(0X3678, 0X0008);
	write_cmos_sensor(0X3AC8, 0X0A04);
	write_cmos_sensor(0X3D34, 0X0010);
	write_cmos_sensor(0X30A0, 0X0008);
	write_cmos_sensor(0X0112, 0X0A0A);
	write_cmos_sensor(0X322E, 0X000C);
	write_cmos_sensor(0X3230, 0X000C);
	write_cmos_sensor(0X3236, 0X000B);
	write_cmos_sensor(0X3238, 0X000B);
	write_cmos_sensor(0X32A6, 0X000C);
	write_cmos_sensor(0X32A8, 0X000C);
	write_cmos_sensor(0X3616, 0X0707);
	write_cmos_sensor(0X3622, 0X0808);
	write_cmos_sensor(0X3626, 0X0808);
	write_cmos_sensor(0X32EE, 0X0001);
	write_cmos_sensor(0X32F0, 0X0001);
	write_cmos_sensor(0X32F6, 0X0003);
	write_cmos_sensor(0X32F8, 0X0003);
	write_cmos_sensor(0X361E, 0X3030);
	write_cmos_sensor(0X362A, 0X0303);
	write_cmos_sensor(0X3664, 0X0019);
	write_cmos_sensor(0X3666, 0X030B);
	write_cmos_sensor(0X3670, 0X0001);
	write_cmos_sensor(0X31B6, 0X0008);
	write_cmos_sensor(0XF442, 0X44C6);
	write_cmos_sensor(0XF408, 0XFFF7);
	write_cmos_sensor(0XF47C, 0X001F);
	write_cmos_sensor(0X347E, 0X00CE);
	write_cmos_sensor(0X3480, 0X00CE);
	write_cmos_sensor(0X3482, 0X00E6);
	write_cmos_sensor(0X3484, 0X00E6);
	write_cmos_sensor(0X3486, 0X00FE);
	write_cmos_sensor(0X3488, 0X00FE);
	write_cmos_sensor(0X348A, 0X0116);
	write_cmos_sensor(0X348C, 0X0116);
	write_cmos_sensor(0XF636, 0X00D6);
	write_cmos_sensor(0XF638, 0X00DE);
	write_cmos_sensor(0XF63A, 0X00EE);
	write_cmos_sensor(0XF63C, 0X00F6);
	write_cmos_sensor(0XF63E, 0X0106);
	write_cmos_sensor(0XF640, 0X010E);
	write_cmos_sensor(0XF4D0, 0X0034);
	write_cmos_sensor(0XF4D8, 0X0034);
#endif
}				/*      sensor_init  */


static void preview_setting_v1(kal_uint16 fps)
{
	write_cmos_sensor_byte(0x0100, 0x00);
	check_stremoff(fps);
	write_cmos_sensor(0X6028, 0X4000);
	write_cmos_sensor(0X6214, 0X7971);
	write_cmos_sensor(0X6218, 0X7150);
	write_cmos_sensor(0X0344, 0X0008);
	write_cmos_sensor(0X0346, 0X0008);
	write_cmos_sensor(0X0348, 0X1077);
	write_cmos_sensor(0X034A, 0X0C37);
	write_cmos_sensor(0X034C, 0X0838);
	write_cmos_sensor(0X034E, 0X0618);
	write_cmos_sensor(0X0340, 0X0699);
	write_cmos_sensor(0X0342, 0X24C0);
	write_cmos_sensor(0X3000, 0X0001);
	write_cmos_sensor(0X0900, 0X0122);
	write_cmos_sensor(0X0380, 0X0001);
	write_cmos_sensor(0X0382, 0X0003);
	write_cmos_sensor(0X0384, 0X0001);
	write_cmos_sensor(0X0386, 0X0003);
	write_cmos_sensor(0X0400, 0X0000);
	write_cmos_sensor(0X0404, 0X0010);
	write_cmos_sensor(0X6028, 0X2000);
	write_cmos_sensor(0X602A, 0X157C);
	write_cmos_sensor(0X6F12, 0X0100);
	write_cmos_sensor(0X602A, 0X15F0);
	write_cmos_sensor(0X6F12, 0X0101);
	write_cmos_sensor(0X6028, 0X4000);
	write_cmos_sensor(0X0B00, 0X0080);
	write_cmos_sensor(0X3070, 0X0100);
	write_cmos_sensor(0X6028, 0X2000);
	write_cmos_sensor(0X602A, 0X1898);
	write_cmos_sensor(0X6F12, 0X0101);
	write_cmos_sensor(0X6028, 0X4000);
	write_cmos_sensor(0X0B04, 0X0101);
	write_cmos_sensor(0X0B08, 0X0000);
#ifdef VCPDAF
	write_cmos_sensor(0X0B0E, 0X0100);
#else
	write_cmos_sensor(0X0B0E, 0X0000);
#endif
	write_cmos_sensor(0X3090, 0X0904);
	write_cmos_sensor(0X3058, 0X0001);
	write_cmos_sensor(0X3D06, 0X0010);
#ifdef VCPDAF_PRE
	write_cmos_sensor(0X6028, 0X2000);
	write_cmos_sensor(0X602A, 0X19E0);
	write_cmos_sensor(0X6F12, 0X0000);
	write_cmos_sensor(0X6028, 0X4000);
	write_cmos_sensor(0X30E2, 0X0001);
	write_cmos_sensor(0X317A, 0X0115);
#else
	write_cmos_sensor(0X6028, 0X2000);
	write_cmos_sensor(0X602A, 0X19E0);
	write_cmos_sensor(0X6F12, 0X0001);
	write_cmos_sensor(0X6028, 0X4000);
	write_cmos_sensor(0X30E2, 0X0000);
	write_cmos_sensor(0X317A, 0X0007);
#endif
	write_cmos_sensor(0X6028, 0X2000);
	write_cmos_sensor(0X602A, 0X4AEC);
	write_cmos_sensor(0X6F12, 0X0105);
	write_cmos_sensor(0X6028, 0X4000);
	write_cmos_sensor(0X0208, 0X0100);
	write_cmos_sensor(0X3604, 0X0000);
	write_cmos_sensor(0X3606, 0X0104);
	write_cmos_sensor(0X3002, 0X0001);
	write_cmos_sensor(0X0136, 0X1800);
	write_cmos_sensor(0X0300, 0X0004);
	write_cmos_sensor(0X0302, 0X0001);
	write_cmos_sensor(0X0304, 0X0006);
	write_cmos_sensor(0X0306, 0X0078);
	write_cmos_sensor(0X0308, 0X0008);
	write_cmos_sensor(0X030A, 0X0001);
	write_cmos_sensor(0X030C, 0X0004);
	write_cmos_sensor(0X030E, 0X0032);
	write_cmos_sensor(0X0200, 0X0618);
	write_cmos_sensor(0X0202, 0X059D);
	write_cmos_sensor(0X021E, 0X0400);
	write_cmos_sensor(0X021C, 0X0000);
	write_cmos_sensor(0X0204, 0X0020);
	write_cmos_sensor(0X0206, 0X0020);
	write_cmos_sensor(0X0114, 0X0300);
	write_cmos_sensor(0X0110, 0X1002);
	write_cmos_sensor(0X0216, 0X0000);
	write_cmos_sensor(0XF440, 0X006F);
	write_cmos_sensor(0XF494, 0X0020);
	write_cmos_sensor(0XF4CC, 0X0029);
	write_cmos_sensor(0XF4CE, 0X002C);
	write_cmos_sensor(0XF4D2, 0X0035);
	write_cmos_sensor(0XF4D4, 0X0038);
	write_cmos_sensor(0XF4D6, 0X0039);
	write_cmos_sensor(0XF4DA, 0X0035);
	write_cmos_sensor(0XF4DC, 0X0038);
	write_cmos_sensor(0XF4DE, 0X0039);
	write_cmos_sensor_byte(0x0100, 0x01);

}				/*      preview_setting  */

static void capture_setting_v1(kal_uint16 currefps)
{
	write_cmos_sensor_byte(0x0100, 0x00);
	check_stremoff(currefps);
	write_cmos_sensor(0X6028, 0X4000);
	write_cmos_sensor(0X6214, 0X7971);
	write_cmos_sensor(0X6218, 0X7150);
	write_cmos_sensor(0X0344, 0X0008);
	write_cmos_sensor(0X0346, 0X0008);
	write_cmos_sensor(0X0348, 0X1077);
	write_cmos_sensor(0X034A, 0X0C37);
	write_cmos_sensor(0X034C, 0X1070);
	write_cmos_sensor(0X034E, 0X0C30);
	write_cmos_sensor(0X0340, 0X0d47);
	write_cmos_sensor(0X0342, 0X1260);
	write_cmos_sensor(0X3000, 0X0001);
	write_cmos_sensor(0X0900, 0X0011);
	write_cmos_sensor(0X0380, 0X0001);
	write_cmos_sensor(0X0382, 0X0001);
	write_cmos_sensor(0X0384, 0X0001);
	write_cmos_sensor(0X0386, 0X0001);
	write_cmos_sensor(0X0400, 0X0000);
	write_cmos_sensor(0X0404, 0X0010);
	write_cmos_sensor(0X6028, 0X2000);
	write_cmos_sensor(0X602A, 0X157C);
	write_cmos_sensor(0X6F12, 0X0100);
	write_cmos_sensor(0X602A, 0X15F0);
	write_cmos_sensor(0X6F12, 0X0101);
	write_cmos_sensor(0X6028, 0X4000);
	write_cmos_sensor(0X0B00, 0X0080);
	write_cmos_sensor(0X3070, 0X0100);
	write_cmos_sensor(0X6028, 0X2000);
	write_cmos_sensor(0X602A, 0X1898);
	write_cmos_sensor(0X6F12, 0X0101);
	write_cmos_sensor(0X6028, 0X4000);
	write_cmos_sensor(0X0B04, 0X0101);
	write_cmos_sensor(0X0B08, 0X0000);
#ifdef VCPDAF
	write_cmos_sensor(0X0B0E, 0X0100);
#else
	write_cmos_sensor(0X0B0E, 0X0000);
#endif
	write_cmos_sensor(0X3090, 0X0904);
	write_cmos_sensor(0X3058, 0X0001);
	write_cmos_sensor(0X3D06, 0X0010);
#ifdef VCPDAF
	write_cmos_sensor(0X6028, 0X2000);
	write_cmos_sensor(0X602A, 0X19E0);
	write_cmos_sensor(0X6F12, 0X0000);
	write_cmos_sensor(0X6028, 0X4000);
	write_cmos_sensor(0X30E2, 0X0001);
	write_cmos_sensor(0X317A, 0X0115);
#else
	write_cmos_sensor(0X6028, 0X2000);
	write_cmos_sensor(0X602A, 0X19E0);
	write_cmos_sensor(0X6F12, 0X0001);
	write_cmos_sensor(0X6028, 0X4000);
	write_cmos_sensor(0X30E2, 0X0000);
	write_cmos_sensor(0X317A, 0X0007);
#endif
	write_cmos_sensor(0X6028, 0X2000);
	write_cmos_sensor(0X602A, 0X4AEC);
	write_cmos_sensor(0X6F12, 0X0105);
	write_cmos_sensor(0X6028, 0X4000);
	write_cmos_sensor(0X0208, 0X0100);
	write_cmos_sensor(0X3604, 0X0000);
	write_cmos_sensor(0X3606, 0X0104);
	write_cmos_sensor(0X3002, 0X0001);
	write_cmos_sensor(0X0136, 0X1800);
	write_cmos_sensor(0X0300, 0X0004);
	write_cmos_sensor(0X0302, 0X0001);
	write_cmos_sensor(0X0304, 0X0006);
	write_cmos_sensor(0X0306, 0X0078);
	write_cmos_sensor(0X0308, 0X0008);
	write_cmos_sensor(0X030A, 0X0001);
	write_cmos_sensor(0X030C, 0X0004);
	write_cmos_sensor(0X030E, 0X0062);
	write_cmos_sensor(0X0200, 0X0618);
	write_cmos_sensor(0X0202, 0X0D27);
	write_cmos_sensor(0X021E, 0X0400);
	write_cmos_sensor(0X021C, 0X0000);
	write_cmos_sensor(0X0204, 0X0020);
	write_cmos_sensor(0X0206, 0X0020);
	write_cmos_sensor(0X0114, 0X0300);
	write_cmos_sensor(0X0110, 0X1002);
	write_cmos_sensor(0X0216, 0X0000);
	write_cmos_sensor(0XF440, 0X002F);
	write_cmos_sensor(0XF494, 0X0030);
	write_cmos_sensor(0XF4CC, 0X0029);
	write_cmos_sensor(0XF4CE, 0X002C);
	write_cmos_sensor(0XF4D2, 0X0035);
	write_cmos_sensor(0XF4D4, 0X0038);
	write_cmos_sensor(0XF4D6, 0X0039);
	write_cmos_sensor(0XF4DA, 0X0035);
	write_cmos_sensor(0XF4DC, 0X0038);
	write_cmos_sensor(0XF4DE, 0X0039);
	write_cmos_sensor_byte(0x0100, 0x01);
}

static void hs_video_setting_v1(kal_uint16 fps)
{
	write_cmos_sensor_byte(0x0100, 0x00);
	check_stremoff(fps);
	write_cmos_sensor(0X6028, 0X4000);
	write_cmos_sensor(0X6214, 0X7971);
	write_cmos_sensor(0X6218, 0X7150);
	write_cmos_sensor(0x0344, 0x00C0);
	write_cmos_sensor(0x0346, 0x01E8);
	write_cmos_sensor(0x0348, 0x0FBF);
	write_cmos_sensor(0x034A, 0x0A57);
	write_cmos_sensor(0X034C, 0X0500);
	write_cmos_sensor(0X034E, 0X02D0);
	write_cmos_sensor(0X0340, 0X0380);
	write_cmos_sensor(0X0342, 0X1168);
	write_cmos_sensor(0X3000, 0X0000);
	write_cmos_sensor(0X0900, 0X0113);
	write_cmos_sensor(0X0380, 0X0001);
	write_cmos_sensor(0X0382, 0X0001);
	write_cmos_sensor(0X0384, 0X0001);
	write_cmos_sensor(0X0386, 0X0005);
	write_cmos_sensor(0X0400, 0X0001);
	write_cmos_sensor(0X0404, 0X0030);
	write_cmos_sensor(0X6028, 0X2000);
	write_cmos_sensor(0X602A, 0X157C);
	write_cmos_sensor(0X6F12, 0X0100);
	write_cmos_sensor(0X602A, 0X15F0);
	write_cmos_sensor(0X6F12, 0X0101);
	write_cmos_sensor(0X6028, 0X4000);
	write_cmos_sensor(0X0B00, 0X0080);
	write_cmos_sensor(0X3070, 0X0100);
	write_cmos_sensor(0X6028, 0X2000);
	write_cmos_sensor(0X602A, 0X1898);
	write_cmos_sensor(0X6F12, 0X0101);
	write_cmos_sensor(0X6028, 0X4000);
	write_cmos_sensor(0X0B04, 0X0101);
	write_cmos_sensor(0X0B08, 0X0000);
	write_cmos_sensor(0X0B0E, 0X0000);
	write_cmos_sensor(0X3090, 0X0904);
	write_cmos_sensor(0X3058, 0X0000);
	write_cmos_sensor(0X3D06, 0X0010);
	write_cmos_sensor(0X6028, 0X2000);
	write_cmos_sensor(0X602A, 0X19E0);
	write_cmos_sensor(0X6F12, 0X0001);
	write_cmos_sensor(0X6028, 0X4000);
	write_cmos_sensor(0X30E2, 0X0000);
	write_cmos_sensor(0X317A, 0X0007);
	write_cmos_sensor(0X6028, 0X2000);
	write_cmos_sensor(0X602A, 0X4AEC);
	write_cmos_sensor(0X6F12, 0X0105);
	write_cmos_sensor(0X6028, 0X4000);
	write_cmos_sensor(0X0208, 0X0100);
	write_cmos_sensor(0X3604, 0X0001);
	write_cmos_sensor(0X3606, 0X0104);
	write_cmos_sensor(0X3002, 0X0001);
	write_cmos_sensor(0X0136, 0X1800);
	write_cmos_sensor(0X0300, 0X0004);
	write_cmos_sensor(0X0302, 0X0001);
	write_cmos_sensor(0X0304, 0X0006);
	write_cmos_sensor(0X0306, 0X0078);
	write_cmos_sensor(0X0308, 0X0008);
	write_cmos_sensor(0X030A, 0X0001);
	write_cmos_sensor(0X030C, 0X0004);
	write_cmos_sensor(0X030E, 0X0032);
	write_cmos_sensor(0X0200, 0X0618);
	write_cmos_sensor(0X0202, 0X0369);
	write_cmos_sensor(0X021E, 0X0400);
	write_cmos_sensor(0X021C, 0X0000);
	write_cmos_sensor(0X0204, 0X0020);
	write_cmos_sensor(0X0206, 0X0020);
	write_cmos_sensor(0X0114, 0X0300);
	write_cmos_sensor(0X0110, 0X1002);
	write_cmos_sensor(0X0216, 0X0000);
	write_cmos_sensor(0XF440, 0X00AF);
	write_cmos_sensor(0XF494, 0X0020);
	write_cmos_sensor(0XF4CC, 0X0028);
	write_cmos_sensor(0XF4CE, 0X0028);
	write_cmos_sensor(0XF4D2, 0X0034);
	write_cmos_sensor(0XF4D4, 0X0FFF);
	write_cmos_sensor(0XF4D6, 0X0FFF);
	write_cmos_sensor(0XF4DA, 0X0034);
	write_cmos_sensor(0XF4DC, 0X0FFF);
	write_cmos_sensor(0XF4DE, 0X0FFF);
	write_cmos_sensor_byte(0x0100, 0x01);

}

static void slim_video_setting_v1(kal_uint16 fps)
{
	write_cmos_sensor_byte(0x0100, 0x00);
	check_stremoff(fps);
	write_cmos_sensor(0X6028, 0X4000);
	write_cmos_sensor(0X6214, 0X7971);
	write_cmos_sensor(0X6218, 0X7150);
	write_cmos_sensor(0x0344, 0x00C0);
	write_cmos_sensor(0x0346, 0x01E8);
	write_cmos_sensor(0x0348, 0x0FBF);
	write_cmos_sensor(0x034A, 0x0A57);
	write_cmos_sensor(0X034C, 0X0500);
	write_cmos_sensor(0X034E, 0X02D0);
	write_cmos_sensor(0x0340, 0x0699);
	write_cmos_sensor(0X0342, 0X24c0);
	write_cmos_sensor(0X3000, 0X0000);
	write_cmos_sensor(0X0900, 0X0113);
	write_cmos_sensor(0X0380, 0X0001);
	write_cmos_sensor(0X0382, 0X0001);
	write_cmos_sensor(0X0384, 0X0001);
	write_cmos_sensor(0X0386, 0X0005);
	write_cmos_sensor(0X0400, 0X0001);
	write_cmos_sensor(0X0404, 0X0030);
	write_cmos_sensor(0X6028, 0X2000);
	write_cmos_sensor(0X602A, 0X157C);
	write_cmos_sensor(0X6F12, 0X0100);
	write_cmos_sensor(0X602A, 0X15F0);
	write_cmos_sensor(0X6F12, 0X0101);
	write_cmos_sensor(0X6028, 0X4000);
	write_cmos_sensor(0X0B00, 0X0080);
	write_cmos_sensor(0X3070, 0X0100);
	write_cmos_sensor(0X6028, 0X2000);
	write_cmos_sensor(0X602A, 0X1898);
	write_cmos_sensor(0X6F12, 0X0101);
	write_cmos_sensor(0X6028, 0X4000);
	write_cmos_sensor(0X0B04, 0X0101);
	write_cmos_sensor(0X0B08, 0X0000);
	write_cmos_sensor(0X0B0E, 0X0000);
	write_cmos_sensor(0X3090, 0X0904);
	write_cmos_sensor(0X3058, 0X0000);
	write_cmos_sensor(0X3D06, 0X0010);
	write_cmos_sensor(0X6028, 0X2000);
	write_cmos_sensor(0X602A, 0X19E0);
	write_cmos_sensor(0X6F12, 0X0001);
	write_cmos_sensor(0X6028, 0X4000);
	write_cmos_sensor(0X30E2, 0X0000);
	write_cmos_sensor(0X317A, 0X0007);
	write_cmos_sensor(0X6028, 0X2000);
	write_cmos_sensor(0X602A, 0X4AEC);
	write_cmos_sensor(0X6F12, 0X0105);
	write_cmos_sensor(0X6028, 0X4000);
	write_cmos_sensor(0X0208, 0X0100);
	write_cmos_sensor(0X3604, 0X0001);
	write_cmos_sensor(0X3606, 0X0104);
	write_cmos_sensor(0X3002, 0X0001);
	write_cmos_sensor(0X0136, 0X1800);
	write_cmos_sensor(0X0300, 0X0004);
	write_cmos_sensor(0X0302, 0X0001);
	write_cmos_sensor(0X0304, 0X0006);
	write_cmos_sensor(0X0306, 0X0078);
	write_cmos_sensor(0X0308, 0X0008);
	write_cmos_sensor(0X030A, 0X0001);
	write_cmos_sensor(0X030C, 0X0004);
	write_cmos_sensor(0x030E, 0x0032);
	write_cmos_sensor(0X0200, 0X0618);
	write_cmos_sensor(0X0202, 0X0369);
	write_cmos_sensor(0X021E, 0X0400);
	write_cmos_sensor(0X021C, 0X0000);
	write_cmos_sensor(0X0204, 0X0020);
	write_cmos_sensor(0X0206, 0X0020);
	write_cmos_sensor(0X0114, 0X0300);
	write_cmos_sensor(0X0110, 0X1002);
	write_cmos_sensor(0X0216, 0X0000);
	write_cmos_sensor(0XF440, 0X00AF);
	write_cmos_sensor(0XF494, 0X0020);
	write_cmos_sensor(0XF4CC, 0X0028);
	write_cmos_sensor(0XF4CE, 0X0028);
	write_cmos_sensor(0XF4D2, 0X0034);
	write_cmos_sensor(0XF4D4, 0X0FFF);
	write_cmos_sensor(0XF4D6, 0X0FFF);
	write_cmos_sensor(0XF4DA, 0X0034);
	write_cmos_sensor(0XF4DC, 0X0FFF);
	write_cmos_sensor(0XF4DE, 0X0FFF);
	write_cmos_sensor_byte(0x0100, 0x01);
}

static void custom1_setting_v1(kal_uint16 fps)
{
	write_cmos_sensor_byte(0x0100, 0x00);
	check_stremoff(fps);
	write_cmos_sensor(0X6028, 0X4000);
	write_cmos_sensor(0X6214, 0X7971);
	write_cmos_sensor(0X6218, 0X7150);
	write_cmos_sensor(0X0344, 0X0008);
	write_cmos_sensor(0X0346, 0X0008);
	write_cmos_sensor(0X0348, 0X1077);
	write_cmos_sensor(0X034A, 0X0C37);
	write_cmos_sensor(0X034C, 0X1070);
	write_cmos_sensor(0X034E, 0X0C30);
	write_cmos_sensor(0X0340, 0X0d2F);
	write_cmos_sensor(0X0342, 0X1716);
	write_cmos_sensor(0X3000, 0X0001);
	write_cmos_sensor(0X0900, 0X0011);
	write_cmos_sensor(0X0380, 0X0001);
	write_cmos_sensor(0X0382, 0X0001);
	write_cmos_sensor(0X0384, 0X0001);
	write_cmos_sensor(0X0386, 0X0001);
	write_cmos_sensor(0X0400, 0X0000);
	write_cmos_sensor(0X0404, 0X0010);
	write_cmos_sensor(0X6028, 0X2000);
	write_cmos_sensor(0X602A, 0X157C);
	write_cmos_sensor(0X6F12, 0X0100);
	write_cmos_sensor(0X602A, 0X15F0);
	write_cmos_sensor(0X6F12, 0X0101);
	write_cmos_sensor(0X6028, 0X4000);
	write_cmos_sensor(0X0B00, 0X0080);
	write_cmos_sensor(0X3070, 0X0100);
	write_cmos_sensor(0X6028, 0X2000);
	write_cmos_sensor(0X602A, 0X1898);
	write_cmos_sensor(0X6F12, 0X0101);
	write_cmos_sensor(0X6028, 0X4000);
	write_cmos_sensor(0X0B04, 0X0101);
	write_cmos_sensor(0X0B08, 0X0000);
#ifdef VCPDAF
	write_cmos_sensor(0X0B0E, 0X0100);
#else
	write_cmos_sensor(0X0B0E, 0X0000);
#endif
	write_cmos_sensor(0X3090, 0X0904);
	write_cmos_sensor(0X3058, 0X0001);
	write_cmos_sensor(0X3D06, 0X0010);
#ifdef VCPDAF
	write_cmos_sensor(0X6028, 0X2000);
	write_cmos_sensor(0X602A, 0X19E0);
	write_cmos_sensor(0X6F12, 0X0000);
	write_cmos_sensor(0X6028, 0X4000);
	write_cmos_sensor(0X30E2, 0X0001);
	write_cmos_sensor(0X317A, 0X0115);
#else
	write_cmos_sensor(0X6028, 0X2000);
	write_cmos_sensor(0X602A, 0X19E0);
	write_cmos_sensor(0X6F12, 0X0001);
	write_cmos_sensor(0X6028, 0X4000);
	write_cmos_sensor(0X30E2, 0X0000);
	write_cmos_sensor(0X317A, 0X0007);
#endif
	write_cmos_sensor(0X6028, 0X2000);
	write_cmos_sensor(0X602A, 0X4AEC);
	write_cmos_sensor(0X6F12, 0X0105);
	write_cmos_sensor(0X6028, 0X4000);
	write_cmos_sensor(0X0208, 0X0100);
	write_cmos_sensor(0X3604, 0X0000);
	write_cmos_sensor(0X3606, 0X0104);
	write_cmos_sensor(0X3002, 0X0001);
	write_cmos_sensor(0X0136, 0X1800);
	write_cmos_sensor(0X0300, 0X0004);
	write_cmos_sensor(0X0302, 0X0001);
	write_cmos_sensor(0X0304, 0X0006);
	write_cmos_sensor(0X0306, 0X0078);
	write_cmos_sensor(0X0308, 0X0008);
	write_cmos_sensor(0X030A, 0X0001);
	write_cmos_sensor(0X030C, 0X0004);
	write_cmos_sensor(0X030E, 0X004E);
	write_cmos_sensor(0X0200, 0X0618);
	write_cmos_sensor(0X0202, 0X0D27);
	write_cmos_sensor(0X021E, 0X0400);
	write_cmos_sensor(0X021C, 0X0000);
	write_cmos_sensor(0X0204, 0X0020);
	write_cmos_sensor(0X0206, 0X0020);
	write_cmos_sensor(0X0114, 0X0300);
	write_cmos_sensor(0X0110, 0X1002);
	write_cmos_sensor(0X0216, 0X0000);
	write_cmos_sensor(0XF440, 0X002F);
	write_cmos_sensor(0XF494, 0X0030);
	write_cmos_sensor(0XF4CC, 0X0029);
	write_cmos_sensor(0XF4CE, 0X002C);
	write_cmos_sensor(0XF4D2, 0X0035);
	write_cmos_sensor(0XF4D4, 0X0038);
	write_cmos_sensor(0XF4D6, 0X0039);
	write_cmos_sensor(0XF4DA, 0X0035);
	write_cmos_sensor(0XF4DC, 0X0038);
	write_cmos_sensor(0XF4DE, 0X0039);
	write_cmos_sensor_byte(0x0100, 0x01);
}

static void custom2_setting_v1(kal_uint16 fps)
{
	write_cmos_sensor_byte(0x0100, 0x00);
	check_stremoff(fps);
	write_cmos_sensor(0X6028, 0X4000);
	write_cmos_sensor(0X6214, 0X7971);
	write_cmos_sensor(0X6218, 0X7150);
	write_cmos_sensor(0X0344, 0X0008);
	write_cmos_sensor(0X0346, 0X0008);
	write_cmos_sensor(0X0348, 0X1077);
	write_cmos_sensor(0X034A, 0X0C37);
	write_cmos_sensor(0X034C, 0X0838);
	write_cmos_sensor(0X034E, 0X0618);
	write_cmos_sensor(0X0340, 0X0840);
	write_cmos_sensor(0X0342, 0X24C0);
	write_cmos_sensor(0X3000, 0X0001);
	write_cmos_sensor(0X0900, 0X0122);
	write_cmos_sensor(0X0380, 0X0001);
	write_cmos_sensor(0X0382, 0X0003);
	write_cmos_sensor(0X0384, 0X0001);
	write_cmos_sensor(0X0386, 0X0003);
	write_cmos_sensor(0X0400, 0X0000);
	write_cmos_sensor(0X0404, 0X0010);
	write_cmos_sensor(0X6028, 0X2000);
	write_cmos_sensor(0X602A, 0X157C);
	write_cmos_sensor(0X6F12, 0X0100);
	write_cmos_sensor(0X602A, 0X15F0);
	write_cmos_sensor(0X6F12, 0X0101);
	write_cmos_sensor(0X6028, 0X4000);
	write_cmos_sensor(0X0B00, 0X0080);
	write_cmos_sensor(0X3070, 0X0100);
	write_cmos_sensor(0X6028, 0X2000);
	write_cmos_sensor(0X602A, 0X1898);
	write_cmos_sensor(0X6F12, 0X0101);
	write_cmos_sensor(0X6028, 0X4000);
	write_cmos_sensor(0X0B04, 0X0101);
	write_cmos_sensor(0X0B08, 0X0000);
#ifdef VCPDAF
	write_cmos_sensor(0X0B0E, 0X0100);
#else
	write_cmos_sensor(0X0B0E, 0X0000);
#endif
	write_cmos_sensor(0X3090, 0X0904);
	write_cmos_sensor(0X3058, 0X0001);
	write_cmos_sensor(0X3D06, 0X0010);
#ifdef VCPDAF_PRE
	write_cmos_sensor(0X6028, 0X2000);
	write_cmos_sensor(0X602A, 0X19E0);
	write_cmos_sensor(0X6F12, 0X0000);
	write_cmos_sensor(0X6028, 0X4000);
	write_cmos_sensor(0X30E2, 0X0001);
	write_cmos_sensor(0X317A, 0X0115);
#else
	write_cmos_sensor(0X6028, 0X2000);
	write_cmos_sensor(0X602A, 0X19E0);
	write_cmos_sensor(0X6F12, 0X0001);
	write_cmos_sensor(0X6028, 0X4000);
	write_cmos_sensor(0X30E2, 0X0000);
	write_cmos_sensor(0X317A, 0X0007);
#endif
	write_cmos_sensor(0X6028, 0X2000);
	write_cmos_sensor(0X602A, 0X4AEC);
	write_cmos_sensor(0X6F12, 0X0105);
	write_cmos_sensor(0X6028, 0X4000);
	write_cmos_sensor(0X0208, 0X0100);
	write_cmos_sensor(0X3604, 0X0000);
	write_cmos_sensor(0X3606, 0X0104);
	write_cmos_sensor(0X3002, 0X0001);
	write_cmos_sensor(0X0136, 0X1800);
	write_cmos_sensor(0X0300, 0X0004);
	write_cmos_sensor(0X0302, 0X0001);
	write_cmos_sensor(0X0304, 0X0006);
	write_cmos_sensor(0X0306, 0X0078);
	write_cmos_sensor(0X0308, 0X0008);
	write_cmos_sensor(0X030A, 0X0001);
	write_cmos_sensor(0X030C, 0X0004);
	write_cmos_sensor(0X030E, 0X0032);
	write_cmos_sensor(0X0200, 0X0618);
	write_cmos_sensor(0X0202, 0X059D);
	write_cmos_sensor(0X021E, 0X0400);
	write_cmos_sensor(0X021C, 0X0000);
	write_cmos_sensor(0X0204, 0X0020);
	write_cmos_sensor(0X0206, 0X0020);
	write_cmos_sensor(0X0114, 0X0300);
	write_cmos_sensor(0X0110, 0X1002);
	write_cmos_sensor(0X0216, 0X0000);
	write_cmos_sensor(0XF440, 0X006F);
	write_cmos_sensor(0XF494, 0X0020);
	write_cmos_sensor(0XF4CC, 0X0029);
	write_cmos_sensor(0XF4CE, 0X002C);
	write_cmos_sensor(0XF4D2, 0X0035);
	write_cmos_sensor(0XF4D4, 0X0038);
	write_cmos_sensor(0XF4D6, 0X0039);
	write_cmos_sensor(0XF4DA, 0X0035);
	write_cmos_sensor(0XF4DC, 0X0038);
	write_cmos_sensor(0XF4DE, 0X0039);
	write_cmos_sensor_byte(0x0100, 0x01);
}

#endif
